   
/************************************************************************
*
*    [9.X.86]
*
*    fax.c-- desk accessory shell for "fx".
*
*    This version compiled under Megamax C.
*    WARNING. This code (especially the in-line assembly routines)
*             contains various inconsistencies and loose ends. Be
*             careful about making changes.
*
*              
*
************************************************************************/

 
/*********************         
*
* include files--    
*
*                                                 
*********************/

#include <obdefs.h>      /* common object definitions & structures     */
#include <gemdefs.h>     /* common GEM definitions & misc. structures  */
#include <osbind.h>      /* for BIOS &c. calls                         */
#include <ctype.h>       /* char-processing macros                     */

#include "fxcomp.h"      /* compiler switches                          */
#include "fxm.h"         /* data structure sizes                       */

#ifndef NO_IMAGE
extern char *malloc(), *calloc(); /* in lieu of #include <stdio.h>     */
#endif

/********************
*
* defines-- (mostly) my own.    
*
*
*********************/
#define TRUE 1
#define FALSE 0
#define NULL '\0'
#define ABORT 0xff

          /* main title and subtitle for main window   */
#define TOP_TITLE " ANALOG-FAX "
#define SUB_TITLE " Text Screen Dump     "
#define FAX_LABEL "  FAX  "

          /* max title & subtitle string length   */
          /* not currently used                   */
#define TTL_LEN 60

          /* used to set window attributes        */
          /* note no info attribute now           */
#define WI1_KIND  (MOVER|CLOSER|NAME|FULLER|INFO)

          /* used to test GEM function return     */
#define NO_WINDOW (-1)

          /* following are used to prevent window 'underflow'     */
#define MIN_WIDTH  (2*gl_wbox_G)
#define MIN_HEIGHT (3*gl_hbox_G)

#define RES_NR 3
          /* ... nr of possible resolutions                       */
#define ONE 1
          /* ... handy indivisible graphics constant              */
#define STD 1
          /* ... type of coordinates used                         */
#define XFER 3
          /* ... straight transfer for raster operations          */
#define NR_WWS 1
          /* ... i.e., nr of windows allowed                      */


/*********************
*
* externals-- 
*
*
*********************/

extern int      gl_apid;   /* used by accessory, set by call to      */
                           /*   'appl_init()'; label is internal.    */

/*********************
*
* system variables--
*
*********************/
int     contrl[12];
int     intin[128];
int     ptsin[128];
int     intout[128];
int     ptsout[128];        /* used to pass args by c bindings      */


/*********************
*
* global variables-- identified by '_G' suffix.
*
*  
*********************/

int     gl_hchar_G;
int     gl_wchar_G;
int     gl_wbox_G;
int     gl_hbox_G;            /* ...system sizes                    */
int     screenx_G, screeny_G; /* defines top edge of screen buffer  */

int     phys_handle_G;  /* physical workstation handle              */
int     handle_G;       /* virtual workstation handle               */
int     top_window_G;   /* handle of topped window                  */
int     menu_id_G;      /* menu id number                           */

int     xdesk_G,ydesk_G,hdesk_G,wdesk_G;
                        /* dimensions of desktop window             */

int     msgbuff_G[8];   /* event message buffer                     */
int     butdown_G;      /* button state tested for, UP/DOWN         */
int     ret_G;          /* dummy return variable                    */

int     hidden_G;       /* current state of cursor                  */

int     work_in_G[11];      /* input to GEM parameter array         */
int     work_out_G[57];     /* output from GEM parameter array      */

int     d1_G,d2_G,d3_G,d4_G,d5_G,d6_G;  /* dummy vars               */

          /* following are arrays containing values for each of     */
          /*   three possible resolutions                           */
          /* these are used for windowing operations                */
int     heights_G[RES_NR] = {200,200,400};
          /* ...pixel heights of screen                             */
int     widths_G[RES_NR] = {320,640,640};
          /* ...pixel widths of screen                              */
int     planes_G[RES_NR] = {4,2,1};
          /* ...number of bit planes                                */

          /* following variables are loaded by 'fix_res()' with the */
          /*   correct values from the above arrays                 */
int     r_height_G;
int     r_width_G;
int     r_planes_G;

/* Following are used by 'fax_go()' to fool around with window      */
/*   dimensions:                                                    */
int w_edge_G[3] = {320,640,640};  /* different screen widths        */
int h_edge_G[3] = {800,400,400};  /* different screen heights       */

int *ww_trim_G;                   /* pointer to one of 3 arrays:    */
int w1_trim_G[3] = {15,23,23};    /* trim values for "1st_Word"     */
int dt_trim_G[3] = {8,39,39};     /* trim values for Desktop        */
int df_trim_G[3] = {0,0,0};       /* default trim values            */

int *st_trim_G;                   /* pointer to one of 4 arrays:    */
int st1_trim_G[3] = {40,20,16};   /* subtitle trim 1st_word         */
int std_trim_G[3] = {8,4,0};      /* ditto for desktop              */
int stg_trim_G[3] = {0,0,0};      /* ditto for Logo                 */
int stf_trim_G[3] = {8,4,0};      /* ditto default                  */

int fax_time_G;     /* used by initial draw routine to distinguish  */
                    /*   open and close calls                       */



/************************
*
* structure definitions--
*
************************/
struct  w_pack {            /* window data package                  */
        int wi_handle;      /* window handle                        */
        int fulled;         /* current state of window              */
        int xold,yold,hold,wold;      /* prev dim of window         */ 
        FDB wind_buff;      /* buffer to save window's contents     */
        int xwork,ywork,hwork,wwork;  /* work dim of window         */
        int w_kind;         /* first arg to 'wind_create()'         */
        int max_dims[4];    /* window's max dimensions              */
        int st_dims[4];     /* window's initial dimensions          */
        char t;             /* TRUE == window has title             */
        char *title;        /* title string, if any                 */
        char s;             /* TRUE == window has subtitle          */
        char *subtl;        /* subtitle string, if any              */
        int closed;         /* TRUE == window is closed             */
        }; 

#ifdef SC_IMAGE
/* the following are declared here so that they can be 'calloc'ed'  */
/*     at the accessory startup:                                    */
long *scan_packs;   /* collision list area                          */
long *hash_table;   /* hash table area                              */
int *chunk;         /* screen save area                             */
char *dump_space;   /* all the dump strings                         */
#endif

#ifdef NO_IMAGE
/* data structures in 'bss' segment to avoid huge overhead involved */
/*     in using 'malloc()' or 'calloc()'                            */
long sc_pks[SCAN_P_SIZE];     /* collision list                     */
long hsh_tb[HASH_T_SIZE];     /* hash table                         */
char dp_sp[DUMP_SIZE];        /* ascii codes dumped                 */
long *scan_packs = sc_pks;    /* pointers to above for consistency: */
long *hash_table = hsh_tb;
char *dump_space = dp_sp;
#endif

char *one_line;     /* pointer to processed data for one text line  */

#ifndef NO_IMAGE
     int *screen[NR_WWS];     /* pointers to window buffers         */
#else
     int *screen[NR_WWS];     /* window buffer in 'bss' segment     */
     char scrn[SMALL_SCRN];
#endif

extern int fax_exec();    /*  'faxlib' call from 'fax_go()'         */           

/*****
*
* main-- top execution level of application: performs initialization.
*
*****/
main()
{
     struct w_pack ww[NR_WWS];    /* window data                */
     FDB wind_actv;       /* mfdb for screen                    */
     int raz_pts[8];      /* source/dest coord packet for       */
                          /*  raster functions                  */
     int r;               /* function return                    */

     /* initialize GEM   */
     appl_init();

     /* initialize AES   */
     phys_handle_G = graf_handle(&gl_wchar_G,&gl_hchar_G,&gl_wbox_G,
                               &gl_hbox_G);

     /* set up menu id   */
     menu_id_G = menu_register(gl_apid,FAX_LABEL);

     /* Big data structures must be dynamically allocated to obviate  */
     /*   Megamax's 32K limit for data/bss segments.                  */
     /* The window redraw buffer --'screen[0]' points to it-- and the */
     /*   area used to save the window to be dumped --pointed to by   */
     /*   'chunk' (SC_IMAGE version) or 'one_line' (NO_IMAGE version) */ 
     /*   -- share the same memory space, since they are not          */
     /*   used at the same time.                                      */
     /* In NO_IMAGE (small memory) version, (smaller) data structures */
     /*   are all declared in bss segment area to avoid using dynamic */
     /*   allocation functions, which add a huge (40K+) overhead to   */
     /*   the size of an active desk accessory above and beyond the   */
     /*   amount of memory actually allocated. Whether this is true   */
     /*   of the Megamax implementation only remains to be seen, but  */
     /*   I doubt it.                                                 */
#ifdef SC_IMAGE
     screen[0] = (int *)calloc(SCRN_SIZE,1);
     chunk = screen[0];
#endif
#ifdef NO_IMAGE
     screen[0] = (int *)scrn;
     one_line = scrn;
#endif

#ifndef NO_IMAGE
     /* allocate memory for screen dump data structures         */
     scan_packs = (long *)calloc(SCAN_P_SIZE,1);
     hash_table = (long *)calloc(HASH_T_SIZE,1);
     dump_space = calloc(DUMP_SIZE,1);
#endif

     wind_get(0,WF_WORKXYWH,&xdesk_G,&ydesk_G,&wdesk_G,&hdesk_G);
     ww[0].wi_handle = NO_WINDOW;

     /* initialize screen variables     */
     init_svars();

     /* set up resolution-dependent variables */
     fix_res();

     /* set some global states     */
     hidden_G = FALSE;   
     butdown_G = TRUE;   
     fax_time_G = 1;

     /* now go wait for messages; i.e., do the main business of   */
     /*   the program                                             */
     gem_loop(ww,&wind_actv,raz_pts,screen);
}

/*****
*
* gem_loop-- main execution level of application.
*
*****/
int gem_loop(ww,wind_actv,raz_pts,screen)
struct w_pack ww[];      /* data for windows                   */
FDB *wind_actv;          /* raster info for screen             */
int raz_pts[];           /* raster source/dest coords          */
int *screen[];           /* pointers to window buffers         */
{
     int event;          /* combined returned event bit fields */
     int keycode;        /* keycode returned by event-keyboard */
     int mx,my;          /* mouse x and y pos.                 */
     int i;              /* index variable                     */
     int form_inc;       /* user-requested spacing inc         */
     int kbd_abort;      /* TRUE => keypress aborts dump       */
     int trigger;        /* keycode to trigger TOS dump        */
     int TOS_ver;        /* TRUE => TOS version active         */
     int hi50;           /* TRUE => 6 x 6 font in use          */
     int r;              /* function return value              */


     event = 0;
     while (TRUE) 
     {
          
          /* check for mouse button and/or keyboard events,       */
          /*    as well as GEM window, &c., messages              */
          event = evnt_multi(MU_MESAG | MU_BUTTON | MU_KEYBD,
                         1,1,butdown_G, /* button parms           */
                         0,0,0,0,0, /* 1st rect parms             */
                         0,0,0,0,0, /* 2nd rect parms             */
                         msgbuff_G, /* message pipe buffer        */
                         0,0,       /* timer low and high words   */      
                         &mx,&my,   /* mouse x/y coords at event  */
                         &ret_G,    /* state of buttons at event  */
                         &ret_G,    /* state of certain keys      */
                         &keycode,  /* code of pressed key        */
                         &ret_G);   /* nr of mouse key states     */
          
          /* freeze the AES prior to fooling with windows  */          
          wind_update(TRUE);

          /* process window management messages    */
          if (event & MU_MESAG)
          {
               /* interpret AES message     */          
               switch (msgbuff_G[0]) 
               {
                    case WM_REDRAW:
                         if (msgbuff_G[3] == ww[0].wi_handle)
                              do_redraw(&ww[0],msgbuff_G[4],
                                   msgbuff_G[5],msgbuff_G[6],msgbuff_G[7],
                                   wind_actv,raz_pts);
                         break;

                    case WM_NEWTOP:
                    case WM_TOPPED:
                         if (msgbuff_G[3] == ww[0].wi_handle)
                         {
                              wind_set(ww[0].wi_handle,WF_TOP,0,0,0,0);
                              top_window_G = ww[0].wi_handle;
                         }
                         break;

                    case WM_SIZED:
                    case WM_MOVED:
                         do_resize(&ww[0],msgbuff_G[0],wind_actv,
                                   raz_pts);
                         break;

                    case AC_OPEN:
                         if ((msgbuff_G[4] == menu_id_G) &&
                             (ww[0].wi_handle == NO_WINDOW))
                         {
                              /* initialize VDI, &c.   */
                              open_vwork();

                              i_scrnras(r_planes_G,wind_actv);

                              /* initialize startup structure for */
                              /* first window                     */
                              ww[0].w_kind = WI1_KIND;
                              ww[0].max_dims[0] = ww[0].st_dims[0] 
                                   = xdesk_G;
                              ww[0].max_dims[1] = ww[0].st_dims[1] 
                                   = (ydesk_G + hdesk_G) / 4;
                              ww[0].max_dims[2] = ww[0].st_dims[2] 
                                   = wdesk_G - (wdesk_G / 2);
                              ww[0].max_dims[3] = ww[0].st_dims[3] 
                                   = hdesk_G / 3;
                              ww[0].title = TOP_TITLE;
                              ww[0].subtl = SUB_TITLE;
                              ww[0].t = ww[0].s = TRUE;

                              /* open window      */     
                              r = open_window(&ww[0],wind_actv,raz_pts,
                                   screen[0],r_planes_G,&form_inc,
                                   &kbd_abort,&trigger,&TOS_ver,
                                   &hi50);
                              if (r == ABORT)
                                   close_window(&ww[0]);

                              /* set the mouse shape   */
                              graf_mouse(ARROW,(long)0x0);
                         }
                         else
                              wind_set(ww[0].wi_handle,WF_TOP,
                                       0,0,0,0);
                         break;

                    case WM_FULLED:
                    /* used to implement abort option here  */
                         fax_time_G -= 1;
                         close_window(&ww[0]);
                         break;

                    case AC_CLOSE:
                    /* used to start screen dump proper here   */
                         if ((msgbuff_G[3] == menu_id_G) &&
                             (ww[0].wi_handle != NO_WINDOW)) 
                         {
                              close_window(&ww[0]);
                              wind_update(FALSE);
                              fax_go(&ww[0],wind_actv,raz_pts,
                                   screen[0],r_planes_G,form_inc,
                                   kbd_abort,trigger,TOS_ver,hi50);
                         }
                         break;

                    case WM_CLOSED:
                    /* used to start screen dump proper here   */
                         if (msgbuff_G[3] == ww[0].wi_handle)
                         {
                              close_window(&ww[0]);
                              wind_update(FALSE);
                              fax_go(&ww[0],wind_actv,raz_pts,
                                   screen[0],r_planes_G,form_inc,
                                   kbd_abort,trigger,TOS_ver,hi50);
                         }
                         break;
                              
               } /* switch (msgbuff_G[0]) */

          }    /* if (event & MU_MESAG)   */

          /* toggle mouse button state  */
          if (event & MU_BUTTON)  
               butdown_G = !butdown_G;

          /* unfreeze AES     */        
          wind_update(FALSE);
          show_mouse();

     }

}


/*****
*
* hide_mouse-- hide the mouse, if it's visible.
*
*****/
int hide_mouse()
{            
     if (!hidden_G)
     {    
          graf_mouse(M_OFF,(long)0x0);
          hidden_G = TRUE;
     }
}

/*****
*
* show_mouse-- show the mouse, if it's hidden.
*
*****/
int show_mouse()
{
     if (hidden_G)
     {
          graf_mouse(M_ON,(long)0x0);
          hidden_G = FALSE;
     }
}

/*****
*
* open_vwork-- initialize the VDI.
*
*****/
int open_vwork()
{
     int i;    /* index variable   */

     for (i = 0; i < 10; work_in_G[i++] = 1)
          ;
     work_in_G[10] = 2;
     handle_G = phys_handle_G;
     v_opnvwk(work_in_G,&handle_G,work_out_G);
}

/*****
*
* set_clip-- set clipping rectangle for draw or redraw, and set up
*            coordinates for raster operation.
*
*****/
int set_clip(ww,x,y,w,h,redraw,raz_pts,wind_actv)
struct w_pack *ww;  /* window data                                  */
int x,y,w,h;        /* dimensions to be transformed into clip rect  */
int redraw;         /* TRUE => this is preparatory to a redraw      */
int raz_pts[];      /* source/dest coords for raster operation      */
FDB *wind_actv;     /* raster structure for screen                  */
{
     int clip[4];   /* coordinates of clipping rectangle            */

     /* find the region in the window buffer corresponding   */
     /*    to the area to be redrawn in this window          */
     wind_get(ww->wi_handle,WF_WORKXYWH,&(ww->xwork),&(ww->ywork),
              &(ww->wwork),&(ww->hwork));

     /* truncate dimensions of window extending beyond screen edge   */
     if ((x + w) > r_width_G)
          w = r_width_G;
     if ((y + h) > r_height_G)
          h = r_height_G;

     /* calculate rectangle for 'vs_clip()'  */
     clip[0] = x;
     clip[1] = y;
     clip[2] = x + w - ONE;    
     clip[3] = y + h - ONE;

     /* calculate coords for raster operation  */   
     if (redraw)
     {
          /* buffer == source      */
          raz_pts[0] = screenx_G + x - ww->xwork;           
          raz_pts[1] = screeny_G + y - ww->ywork;         
          raz_pts[2] = (raz_pts[0] + w - ONE);          
          raz_pts[3] = (raz_pts[1] + h - ONE);           
          raz_pts[4] = clip[0];
          raz_pts[5] = clip[1];
          raz_pts[6] = clip[2];    
          raz_pts[7] = clip[3];
   
     }                               
     else                           
     {                             
          /* buffer == destination */
          raz_pts[0] = clip[0];
          raz_pts[1] = clip[1];
          raz_pts[2] = clip[2];             
          raz_pts[3] = clip[3];         
          raz_pts[4] = screenx_G;      
          raz_pts[5] = screeny_G;
          raz_pts[6] = (screenx_G + w - ONE); 
          raz_pts[7] = (screeny_G + h - ONE); 
     }         

     /* set clip rectangle for GEM      */
     vs_clip(handle_G,1,clip);
}


/*****
*
* open_window-- set up and open window.
*
*****/
int open_window(ww,wind_actv,raz_pts,base,res,form_inc,kbd_abort,trigger,
                TOS_ver,hi50)
struct w_pack *ww;  /* window data                         */
FDB *wind_actv;     /* raster info for screen              */
int raz_pts[];      /* srce/dest raster coords             */
long base;          /* address of window buffer            */
int res;            /* nr of bit planes this res           */
int *form_inc;      /* user-requested spacing inc          */
int *kbd_abort;     /* TRUE => keypress aborts dump        */
int *trigger;       /* keycode to trigger TOS dump         */
int *TOS_ver;       /* TRUE => TOS version active          */
int *hi50;          /* TRUE => 6 x 6 font in use           */
{
     int r;    /* function return value      */


     /* set window's max size   */
     ww->wi_handle = wind_create(ww->w_kind,ww->max_dims[0],
                                 ww->max_dims[1],ww->max_dims[2],
                                 ww->max_dims[3]);

     /* set the window's title                                  */
     if (ww->t)
          wind_set(ww->wi_handle, WF_NAME, ww->title,0,0);

     /* set subtitle                                            */
     if (ww->s)
          wind_set(ww->wi_handle, WF_INFO, ww->subtl,0,0);

     /* draw an expanding box outline preparatory to drawing    */
     /*   the actual window                                     */
     graf_growbox(ww->st_dims[0] + ww->st_dims[2] / 2,
                  ww->st_dims[1] + ww->st_dims[3] / 2,
                  gl_wbox_G,gl_hbox_G,
                  ww->st_dims[0],ww->st_dims[1],ww->st_dims[2],
                  ww->st_dims[3]);

     /* draw window for first time                              */
     wind_open(ww->wi_handle,ww->st_dims[0],ww->st_dims[1],ww->st_dims[2],
               ww->st_dims[3]);

     /* get the dimensions of the window's working area         */
     wind_get(ww->wi_handle,WF_WORKXYWH,&(ww->xwork),&(ww->ywork),
              &(ww->wwork),&(ww->hwork));
     ww->fulled = FALSE;    /* because window has no 'old' dimensions  */
     ww->closed = FALSE;    /* flag for general window closer at end   */

     /* initialize window buffer   */
     ww->wind_buff.fd_addr = base;
     ww->wind_buff.fd_w = r_width_G;
     ww->wind_buff.fd_h = r_height_G;
     ww->wind_buff.fd_wdwidth = r_width_G / 16;
     ww->wind_buff.fd_stand = STD;
     ww->wind_buff.fd_nplanes = res;

     /* draw window first time and copy it into buffer */
     /* window is automatically redrawn at first entry into            */
     /*   'gem_loop()', so hide the mouse until the redraw is complete */
     hide_mouse();
     set_clip(ww,ww->xwork,ww->ywork,ww->wwork,ww->hwork,FALSE,raz_pts,
              wind_actv);
     r = init_fax(ww,form_inc,kbd_abort,trigger,TOS_ver,hi50);
     if (r == ABORT)
          return ABORT;

     vro_cpyfm(handle_G, XFER, raz_pts, wind_actv, &(ww->wind_buff));
     return TRUE;

}


/*****
*
* close_window-- close and delete a window.
*
*****/
int close_window(ww)
struct w_pack *ww;       /* window data      */
{
     wind_close(ww->wi_handle);
     graf_shrinkbox(ww->xwork + ww->wwork / 2, ww->ywork + ww->hwork / 2,
                    gl_wbox_G, gl_hbox_G, ww->xwork, ww->ywork,
                    ww->wwork, ww->hwork);
     wind_delete(ww->wi_handle);
     ww->closed = TRUE;
     v_clsvwk(handle_G);
     ww->wi_handle = NO_WINDOW;

     return;
}


/*****
*
* do_redraw-- redraw the application window.
*
*****/
int do_redraw(ww,xc,yc,wc,hc,wind_actv,raz_pts)
struct w_pack *ww;  /* window data                                */
int xc,yc,wc,hc;    /* msgbuff_G[4..7]: dimensions of area to be  */
                    /*  redrawn                                   */
FDB *wind_actv;     /* raster info for screen                     */
int raz_pts[];      /* srce/dest coords for raster                */
{
     GRECT t1,t2;   /* from 'obdefs.h': holds rect dimensions     */
                    /* t1 = dimensions of rectangle from rect-    */
                    /*      angle list                            */
                    /* t2 = dimensions of area to be redrawn,     */
                    /*      from parms                            */

     hide_mouse();
     wind_update(TRUE);
     t2.g_x = xc;   /* transfer parms (rather clumsily-- but      */
     t2.g_y = yc;   /*   the structures are required by           */
     t2.g_w = wc;   /*   'rc_intersect()' below, and the args as  */
     t2.g_h = hc;   /*   passed are elements of 'msgbuff')        */          

     /* get the first rectangle from rectangle list    */
     wind_get(ww->wi_handle,WF_FIRSTXYWH,&t1.g_x,&t1.g_y,&t1.g_w,&t1.g_h);

     /* keep redrawing while there are valid rectangles in the list  */
     while (t1.g_w && t1.g_h) 
     {
          /* if the rectangles intersect, redraw that area           */
          if (rc_intersect(&t2,&t1)) 
          {
               set_clip(ww,t1.g_x,t1.g_y,t1.g_w,t1.g_h,TRUE,raz_pts,
                        wind_actv);
               
               /* raster from buffer into current window    */
               vro_cpyfm(handle_G,XFER,raz_pts,&(ww->wind_buff),
                           wind_actv);
               
          }
          /* get the next rectangle from the list      */
          wind_get(ww->wi_handle,WF_NEXTXYWH,&t1.g_x,&t1.g_y,&t1.g_w,
                   &t1.g_h);
     }
     wind_update(FALSE);
     show_mouse();
}


/*****
*
* init_fax-- draw window for fax, get info, &c.
*
*****/
int init_fax(ww,form_inc,kbd_abort,trigger,TOS_ver,hi50)
struct w_pack *ww;       /* window data                     */
int *form_inc;           /* user-requested spacing inc      */
int *kbd_abort;          /* TRUE => keypress aborts dump    */
int *trigger;            /* keycode to trigger TOS dump     */
int *TOS_ver;            /* TRUE => TOS version active      */
int *hi50;               /* TRUE => 6 x 6 font in use       */
{
     int temp[4];        /* coords for drawing sample shape           */
     int cell_width,l_delta,r_delta;    /* char matrix data variables */
     int attrib[10];     /* filled by 'vqt_attributes()'              */
     int status;         /* function return                           */
     int x,y;            /* "cursor" position                         */
     char s_string[50];  /* for user input                            */
     int itemp;          /* used to convert string to integer         */
     int d_temp = FALSE; /* TRUE => this is a desktop window          */
     int r;              /* function return value                     */
     int r_ix;           /* 'Getrez()' return                         */


     status = vqt_width(handle_G,'O',&cell_width,&l_delta,&r_delta);
     vqt_attributes(handle_G,attrib);

     /* style = pattern  */
     vsf_interior(handle_G,2);

     /* style + style_index => solid    */
     vsf_style(handle_G,12);

     /* color = white    */
     vsf_color(handle_G,0);

     temp[0] = x = ww->xwork;
     temp[1] = y = ww->ywork;
     temp[2] = ww->xwork + ww->wwork - ONE;
     temp[3] = ww->ywork + ww->hwork - ONE;

     /* blank the interior  */
     v_bar(handle_G,temp);

     /* print message       */
     x = 0;
     y += attrib[9];
     v_gtext(handle_G,x,y," Hello from FAX:");
     
     if (r_ix == 0)
          x = 0;
     y += attrib[9];
     v_gtext(handle_G,x,y," (Hit 'x' to abort)");
     y += attrib[9];
     v_gtext(handle_G,x,y,"  Enter spacing:");
     y += attrib[9];
     v_gtext(handle_G,x,y,"  Desktop=2, else 0");
     y += attrib[9];
     r = get_stuff(ww,s_string,x,y,1,40,FALSE,'x');
     if (r == ABORT)
          return ABORT;
     if (!(((*form_inc = atoi(s_string)) >= 0) && (*form_inc <= 10)))
          *form_inc = 0;

     /* clear window for next      */
     v_bar(handle_G,temp);
     y = ww->ywork + attrib[9];

     v_gtext(handle_G,x,y,"Hit: 'd' (Desktop)");
     y += attrib[9];
     v_gtext(handle_G,x,y,"     '1' (1st_Word)");
     y += attrib[9];
     v_gtext(handle_G,x,y,"     'l' (Logo)");
     y += attrib[9];
     v_gtext(handle_G,x,y,"      or <enter>...");
     y += attrib[9];
     r = get_stuff(ww,s_string,x,y,1,40,FALSE,'x');
     if (r == ABORT)
          return ABORT;
     v_bar(handle_G,temp);
     switch (s_string[0])
     {
          case 'd':
          case 'D':
                    st_trim_G = std_trim_G;
                    ww_trim_G = dt_trim_G;
                    d_temp = TRUE;
                    break;
          case '1':
                    ww_trim_G = w1_trim_G;
                    st_trim_G = st1_trim_G;
                    break;
          case 'l':
          case 'L':
                    st_trim_G = stg_trim_G;
                    ww_trim_G = df_trim_G;
                    break;
          default:
                    st_trim_G = stf_trim_G;
                    ww_trim_G = df_trim_G;
                    break;
     }
     y = ww->ywork + attrib[9];

     v_gtext(handle_G,x,y,"Full FAX to abort,");
     y += attrib[9];
     v_gtext(handle_G,x,y,"Close FAX to dump...");

     fax_time_G += 1;     
     return TRUE;

}


/*****
*
* i_scrnras-- initialize mfdb for screen raster ops.
*             mfdb is a GEM structure.
*
*****/
int i_scrnras(res,ras)
int res;       /* nr of bit planes this res       */
FDB *ras;      /* will hold raster info           */
{
     /* get address of video ram   */
     ras->fd_addr = Logbase();
 
     /* other data-- cf. VDI manual p. 6-2 or GPR p. 158    */    
     ras->fd_w = r_width_G;
     ras->fd_h = r_height_G;
     ras->fd_wdwidth = r_width_G / 16;
     ras->fd_stand = STD;               
     ras->fd_nplanes = res;
     
}



/*****
*
* do_resize-- resize or move a window.
*
*****/
int do_resize(ww,msg,wind_actv,raz_pts)
struct w_pack *ww;  /* window info                             */
int msg;            /* specific window op prompting this call  */
FDB *wind_actv;     /* raster info for screen                  */
int raz_pts[];      /* srce/dest coords for raster             */
{

     hide_mouse();
     wind_update(TRUE);

     /* make sure minimum dimensions aren't exceeded     */     
     if (msgbuff_G[6] < MIN_WIDTH)
          msgbuff_G[6] = MIN_WIDTH;
     if (msgbuff_G[7] < MIN_HEIGHT)
          msgbuff_G[7] = MIN_HEIGHT;

     /* ditto max   */
     if (msgbuff_G[6] > ww->max_dims[2])
          msgbuff_G[6] = ww->max_dims[2];
     if (msgbuff_G[7] > ww->max_dims[3])
          msgbuff_G[7] = ww->max_dims[3];

     /* change dimensions     */
     wind_set(ww->wi_handle,WF_CURRXYWH,msgbuff_G[4],
              msgbuff_G[5],msgbuff_G[6],msgbuff_G[7]);

     /* get new dimensions of work area      */  
     wind_get(ww->wi_handle,WF_WORKXYWH,&(ww->xwork),&(ww->ywork),
              &(ww->wwork),&(ww->hwork));

     /* redraw if necessary   */
     if (msg == WM_SIZED)
          do_redraw(ww,ww->xwork,ww->ywork,ww->wwork,ww->hwork,
                    wind_actv,raz_pts);    

     wind_update(FALSE);
     show_mouse();

}


/*****
*
* init_svars-- initialize screen variables.
*
*****/
int init_svars()
{
     /* set buffer variables  */
     screenx_G = xdesk_G;
     screeny_G = ydesk_G;

}


/*****
*
* fix_res-- sets up resolution-dependent variables from arrays.
*           uses global variables.
*
*****/
int fix_res()
{
     int r_ix;      /*  0 == low, 1 == med, 2 == high resolution  */

     r_ix = Getrez();

     r_height_G = heights_G[r_ix];
     r_width_G = widths_G[r_ix];
     r_planes_G = planes_G[r_ix];

}

 
/*****
*
* fax_go-- entry point into 'faxlib' routines.
*
*****/
int fax_go(ww,wind_actv,raz_pts,baSE,res,form_inc,kbd_abort,trigger,
           TOS_ver,hi50)
struct w_pack *ww;  /* window data                     */
FDB *wind_actv;     /* screen buffer info              */
int raz_pts[];      /* srce/dest coords for raster     */
long baSE;          /* base of screen memory           */
int res;            /* nr of bit planes                */
int form_inc;       /* user-requested spacing inc      */
int kbd_abort;      /* TRUE => keypress aborts dump    */
int trigger;        /* keycode to trigger TOS dump     */
int TOS_ver;        /* TRUE => TOS version active      */
int hi50;           /* TRUE => 6 x 6 font in use       */
{
     int cell_width,l_delta,r_delta;    /* char matrix data variables */
     int attrib[10];     /* filled by 'vqt_attributes()'              */
     int status;         /* function return                           */
     int x,y;            /* "cursor" position                         */
     long i;             /* index variable                            */
     int keycode;        /* keypress from 'evnt_multi()'              */
     int mx,my;          /* mouse x,y from 'evnt_multi()'             */
     int event;          /* flag return from 'evnt_multi()'           */
     int top_ww;         /* handle of active window at start          */
     int tx,ty,tw,th;    /* its work dimensions                       */ 
     int time_out;       /* printer timeout from 'fax_exec()'         */
     int hash_err;       /* nr of hash errors from 'fax_exec()'       */
     int recg_err;       /* nr of recognize errors from 'fax_exec()'  */
     int result;         /* return from 'fax_exec()'                  */
     int r_ix;           /* return from 'Getrez()'                    */
     int *dummy;         /* dummy pointer to 'open_window()'          */
     extern int xshift;  /* shift factor for non-byte-aligned windows */
     int r;              /* function return value                     */
     int bad_ww = FALSE; /* TRUE => no active window                  */


     /* let GEM finish erasing the window, &c.    */
     evnt_timer(0,0);

     /* find new active window handle & work dimensions   */
     wind_get(ret_G,WF_TOP,&top_ww,&ret_G,&ret_G,&ret_G);
     if (top_ww <= 0)
     {
          tx = ty = tw = th = 0;
          bad_ww = TRUE;
     }

     /* if there's an active window, dump it      */     
     if (!bad_ww)
     {
          hide_mouse();
          wind_get(top_ww,WF_WORKXYWH,&tx,&ty,&tw,&th);

          time_out = FALSE;
          hash_err = recg_err = 0;

          /* clumsy check on screen edge dimensions:        */
          r_ix = Getrez();
          if (r_ix == 1)
          {
               ty = ty * 2;
               th = th * 2;
          }
          else if (r_ix == 0)
          {
               ty = ty * 4;
               th = th * 4;
          }

          /* 1. trim off non-standard left "border"         */
          tx += ww_trim_G[r_ix];
          tw -= ww_trim_G[r_ix];

          /* 2. trim subtitle field if necessary            */
          th -= st_trim_G[r_ix];
          ty += st_trim_G[r_ix];

          /* 3. truncate off-screen portions if necessary   */
          if ((tx + tw) > w_edge_G[r_ix])
               tw = w_edge_G[r_ix] - tx;
          if ((ty + th) > h_edge_G[r_ix])
               th = h_edge_G[r_ix] - ty;

          /* go dump the window-- I hope     */
          result = fax_exec(tx,ty,tw,th,&time_out,&hash_err,&recg_err,
                            form_inc,kbd_abort,trigger,TOS_ver,hi50);
          show_mouse();
     }

     wind_update(TRUE);

}


/*****
*
* get_stuff-- get a user-input string.
*
*****/
int get_stuff(ww,s,x,y,max,linesize,mult,abort)
struct w_pack *ww;       /* window data                          */
char *s;                 /* string space for text input          */
int x;                   /* x position of cursor to start        */
int y;                   /* y position of cursor to start        */
int max;                 /* maximum size of string               */
int linesize;            /* max nr of chars on line              */
int mult;                /* TRUE => multiple text lines allowed  */
int abort;               /* != NULL => this is abort code        */
{
     int ch;             /* character input from keyboard        */
     char o_s[2];        /* string space used for output         */
     int stop_it = FALSE;     /* input stopping condition        */
     int i;                   /* string index                    */
     int status;              /* miscellaneous use               */
     int attrib[10];          /* from 'vqt_attributes()'         */
     int cell_width, l_delta, r_delta;  /* from 'vqt_width()'    */
     int d1, d2;              /* dummies                         */
     int ux,uy,uw,uh;         /* coords from 'wind_get()'        */
     int ix,iy;               /* saved initial x,y               */

     /* get dimensions of window   */
     wind_get(ww->wi_handle,WF_WORKXYWH,&ux,&uy,&uw,&uh);

     /* save start coords          */
     ix = x;
     iy = y;

     /* get text data              */
     status = vqt_width(handle_G,'O',&cell_width,&l_delta,&r_delta);
     vqt_attributes(handle_G,attrib);
     linesize = (linesize * cell_width) + ux;

     /* misc initialization        */
     o_s[1] = '\0';
     i = 0;

     while (!stop_it)
     {
          /* position cursor and get input   */
          vrq_locator(handle_G,x,y,&d1,&d2,&ch);

          /* check for possible abort code   */
          if ((abort != NULL) && (tolower(ch) == abort))
               return ABORT;

          /* disregard button press     */
          if ((ch == 0x20) || (ch == 0x21))
               continue;

          /* collect character     */
          o_s[0] = s[i] = (char)ch;

          /* print it              */
          if (ch != '\r')
          {
               if ((ch == '\b') && (x > ix))
               {
                    /* valid backspace  */
                    o_s[0] = ' ';
                    v_gtext(handle_G,x,y,o_s);
                    x -= cell_width;
                    i -= 1;
               }
               else if ((ch != '\b') && (isprint(ch)))
               {
                    /* not a backspace  */
                    v_gtext(handle_G,x,y,o_s);
                    x += cell_width;
                    i += 1;
               }
          }
          /* if more than one line of text allowed     */
          else if (mult)
          {
               /* carriage return  */
               y += attrib[9] + ONE;
               x = ix + ONE;
               i += 1;
          }
          /* if not, carriage return => exit           */
          else
          {
               stop_it = TRUE;
               break;
          }

          /* at end of clipped text line, go down to next   */
          if (x >= (ux + uw - ONE) || (x >= linesize))
          {
               y += attrib[9] + ONE;
               x = ix + ONE;
          }

          /* do not go lower than bottom of clipped area    */
          if (y > (uy + uh - ONE))
               y -= attrib[9] + ONE;

          /* make sure cursor is in legal area              */
          if ((x < ux) || (x > ux + uw))
               x = ix + ONE;
          if ((y < uy) || (y > uy + uh))
               y = uy + ONE;

          stop_it = (i < max) ? FALSE : TRUE;

     }
     s[i] = '\0';
     return TRUE;

}

/* pre-empt SYSLIB code for following unused functions  */
fopen() {}
fclose() {}
fread() {}
fwrite() {}
fseek() {}






