            text

*--------------------------*
*   CZ Patch Librarian     *
*           by             *
*       Kirk Stover        *
*--------------------------*

*---- RESOURCE OBJECTS ----

DIALOG1     equ 0
TONEVALU    equ 2
TONEDOWN    equ 3
TONEUP      equ 4
RECEIVE     equ 7
QUIT        equ 8
SEND        equ 9

*---- GEMDOS FUNCTIONS ----

gemdos      equ   1

term        equ   $00
currdisk    equ   $19
create      equ   $3c
open        equ   $3d
close       equ   $3e
read        equ   $3f
write       equ   $40
getdir      equ   $47
setblock    equ   $4a


*----- BIOS FUNCTIONS -----

bios        equ   13

bconstat    equ   1
bconin      equ   2
bconout     equ   3
bcostat     equ   8

*--------------------------

midi        equ   3
patch_len   equ   128
max_count   equ   20000

*--------------------------

main        move.l   sp,a5             ; a5 has current stack pointer
            move.l   #user_stack,sp    ; point to our stack
            move.l   4(a5),a5          ; base page start
            move.l   $c(a5),d0         ; text segment length
            add.l    $14(a5),d0        ; data segment length
            add.l    $1c(a5),d0        ; bss segment length
            add.l    #$100,d0          ; base page offset
            move.l   d0,-(sp)          ; program length to save
            move.l   a5,-(sp)          ; starting address of program
            move.w   #0,-(sp)          ; dummy parameter
            move.w   #setblock,-(sp)   ; setblock function
            trap     #gemdos           ; call gemdos
            add.l    #12,sp            ; restore stack

            bsr      start             ; let's go!
            bsr      v_clsvwk          ; close workstation
            bsr      appl_exit         ; and application
            move.w   #term,-(sp)       ; term function
            trap     #gemdos           ; call gemdos

*--------------------------

call_aes    move.l   #aespb,d1         ; d1 -> pointer to aes pointer
            move.w   #$c8,d0           ; aes function code
            trap     #2                ; call gem
            rts                        ; return

*--------------------------

call_vdi    move.l   #vdipb,d1         ; d1 -> pointer to vdi pointer
            move.w   #$73,d0           ; vdi function code
            trap     #2                ; call gem
            rts                        ; return

*--------------------------

v_opnvwk    move.w   #100,contrl
            move.w   #0,contrl+2
            move.w   #11,contrl+6
            move.w   vdihandle,contrl+12
            move.l   #work_in,a0
            move.l   #intin,a1
            move.w   #10,d0
v_opnvwk_1  move.w   (a0)+,(a1)+
            dbra     d0,v_opnvwk_1
            bsr      call_vdi
            move.l   #intout,a0
            move.l   #work_out,a1
            move.w   #44,d0
v_opnvwk_2  move.w   (a0)+,(a1)+
            dbra     d0,v_opnvwk_2
            move.l   #ptsout,a0
            move.w   #11,d0
v_opnvwk_3  move.w   (a0)+,(a1)+
            dbra     d0,v_opnvwk_3
            move.w   contrl+12,vdihandle
            rts

*--------------------------

v_clsvwk    move.w   #101,contrl
            move.w   #0,contrl+2
            move.w   #0,contrl+6
            move.w   vdihandle,contrl+12
            bsr      call_vdi
            rts

*--------------------------

appl_init      move.l   #0,ap1resv
               move.l   #0,ap2resv
               move.l   #0,ap3resv
               move.l   #0,ap4resv
               move.w   #10,opcode
               move.w   #0,sintin
               move.w   #1,sintout
               move.w   #0,saddrin
               move.w   #0,saddrout
               bsr      call_aes
               move.w   intout,appl_id
               rts

*--------------------------

appl_exit      move.w   #19,opcode
               move.w   #0,sintin
               move.w   #1,sintout
               move.w   #0,saddrin
               move.w   #0,saddrout
               bsr      call_aes
               rts

*--------------------------

objc_draw      move.w   #42,opcode
               move.w   #6,sintin
               move.w   #1,sintout
               move.w   #1,saddrin
               move.w   #0,saddrout
               move.w   start_obj,intin
               move.w   #10,intin+2
               move.w   x,intin+4
               move.w   y,intin+6
               move.w   w,intin+8
               move.w   h,intin+10
               move.l   dialog_addr,addrin
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

form_do        move.w   #50,opcode
               move.w   #1,sintin
               move.w   #1,sintout
               move.w   #1,saddrin
               move.w   #0,saddrout
               move.w   #0,intin
               move.l   dialog_addr,addrin
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

form_dial      move.w   #51,opcode
               move.w   #9,sintin
               move.w   #1,sintout
               move.w   #0,saddrin
               move.w   #0,saddrout
               move.w   d0,intin
               move.w   #0,intin+2
               move.w   #0,intin+4
               move.w   #0,intin+6
               move.w   #0,intin+8
               move.w   x,intin+10
               move.w   y,intin+12
               move.w   w,intin+14
               move.w   h,intin+16
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

form_alert     move.w   #52,opcode
               move.w   #1,sintin
               move.w   #1,sintout
               move.w   #1,saddrin
               move.w   #0,saddrout
               move.w   d0,intin
               move.l   a0,addrin
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

form_center    move.w   #54,opcode
               move.w   #0,sintin
               move.w   #5,sintout
               move.w   #1,saddrin
               move.w   #0,saddrout
               move.l   dialog_addr,addrin
               bsr      call_aes
               move.w   intout+2,x
               move.w   intout+4,y
               move.w   intout+6,w
               move.w   intout+8,h
               rts

*--------------------------

graf_handle       move.w   #77,opcode
                  move.w   #0,sintin
                  move.w   #5,sintout
                  move.w   #0,saddrin
                  move.w   #0,saddrout
                  bsr      call_aes
                  move.w   intout,d0
                  rts

*--------------------------

graf_mouse     move.w   #78,opcode
               move.w   #1,sintin
               move.w   #1,sintout
               move.w   #1,saddrin
               move.w   #0,saddrout
               move.w   d0,intin
               move.l   a0,addrin
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

fsel_input     move.w   #90,opcode
               move.w   #0,sintin
               move.w   #2,sintout
               move.w   #2,saddrin
               move.w   #0,saddrout
               move.l   a0,addrin
               move.l   a1,addrin+4
               bsr      call_aes
               move.w   intout+2,d0
               rts

*--------------------------

rsrc_load      move.w   #110,opcode
               move.w   #0,sintin
               move.w   #1,sintout
               move.w   #1,saddrin
               move.w   #0,saddrout
               move.l   #rsrc_name,addrin
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

rsrc_free      move.w   #111,opcode
               move.w   #0,sintin
               move.w   #1,sintout
               move.w   #0,saddrin
               move.w   #0,saddrout
               bsr      call_aes
               move.w   intout,d0
               rts

*--------------------------

rsrc_gaddr     move.w   #112,opcode
               move.w   #2,sintin
               move.w   #1,sintout
               move.w   #0,saddrin
               move.w   #1,saddrout
               move.w   #0,intin
               move.w   #DIALOG1,intin+2
               bsr      call_aes
               move.w   intout,d0
               move.l   addrout,dialog_addr
               rts

*--------------------------

initialize  bsr      appl_init         ; open application
            move.w   d0,appl_id        ; and savid apid
            bsr      graf_handle       ; request a handle
            move.w   d0,grhandle       ; and save
            move.w   d0,vdihandle      ; open virtual
            bsr      v_opnvwk          ; workstation
            move.w   #currdisk,-(sp)   ; current drive function
            trap     #gemdos           ; call gemdos
            addq.l   #2,sp             ; restore stack
            add.w    #'A',d0           ; convert to ASCII
            move.l   #path_name,a0     ; point to path name
            move.b   d0,(a0)+          ; move drive # to string
            move.b   #':',(a0)+        ; build path
            move.b   #0,(a0)           ; string end
            move.w   #0,-(sp)          ; current drive
            move.l   #path_name+2,-(sp) ;point to end of path string
            move.w   #getdir,-(sp)     ; current directory function
            trap     #gemdos           ; call gemdos
            addq.l   #8,sp             ; restore stack
            move.l   #path_name,a0     ; point to path name
            move.l   #wild_card,a1     ; point to wild card
            bsr      strcat            ; concatenate the path and wild string
            move.w   #0,d0             ; arrow shape
            bsr      graf_mouse        ; turn mouse on
            bsr      rsrc_load         ; load the resource file
            tst.w    d0                ; successful?
            bne      initialize1       ;   yes, continue
            move.w   #1,d0             ; default button 1
            move.l   #rsrc_msg,a0      ; resource error string
            bsr      form_alert        ; show form alert
            addq.l   #4,sp             ; remove return address from stack
            bra      initializex       ; and exit
initialize1 bsr      rsrc_gaddr        ; get resource address
            move.l   dialog_addr,a0    ; point to resource
            move.w   #TONEVALU,d0      ; object index
            mulu     #24,d0            ; calculate offset into resource
            add.w    d0,a0             ; and add to pointer
            move.l   12(a0),a0         ; move TEDINFO pointer to a0
            move.l   (a0),tone_addr    ; save te_ptext address
initializex rts                        ; return

*--------------------------

start       bsr      initialize        ; load resource file
            bsr      do_dialog         ; do the dialog
            bsr      rsrc_free         ; free resource 
            rts                        ; return

*--------------------------

do_dialog   bsr      form_center       ; calculate dialog box coordinates
            move.w   #0,d0             ; reserve screen space option
            bsr      form_dial         ; go do it
            move.w   #1,d0             ; growing box option
            bsr      form_dial         ; go do it
            move.w   #0,start_obj      ; starting object to draw
do_dialog_1 bsr      objc_draw         ; draw the dialog box
do_dialog_2 bsr      form_do           ; let gem do the dirty work
            cmp.w    #TONEUP,d0        ; was toneup selected?
            bne      do_dialog_3       ;  no, check next
            bsr      tone_up           ; process tone up
            bra      do_dialog_1       ; go redraw
do_dialog_3 cmp.w    #TONEDOWN,d0      ; was tonedown selected?
            bne      do_dialog_4       ;  no, check next
            bsr      tone_down         ; process tone down
            bra      do_dialog_1       ; go redraw
do_dialog_4 cmp.w    #QUIT,d0          ; was quit selected?
            beq      undraw_obj        ;  yes, we are done!
            cmp.w    #SEND,d0          ; was send selected?
            bne      do_dialog_5       ;  no, check next
            bsr      undraw_obj        ; erase the dialog box
            bsr      send              ; process send to midi
            bra      do_dialog         ; go redraw entire dialog
do_dialog_5 cmp.w    #RECEIVE,d0       ; was receive selected?
            bne      do_dialog_2       ;  no, gem made a mistake
            bsr      undraw_obj        ; erase the dialog box
            bsr      receive           ; process receive from midi
            bra      do_dialog         ; go redraw entire dialog
undraw_obj  move.w   #2,d0             ; shrinking box option 
            bsr      form_dial         ; go do it
            move.w   #3,d0             ; release reserve memory option
            bsr      form_dial         ; go do it
            rts                        ; return

*--------------------------

deselect    move.l   dialog_addr,a0    ; point to the dialog
            mulu     #24,d0            ; calculate object offset
            add.w    d0,a0             ; add to pointer
            and.w    #$fffe,10(a0)     ; turn off selected bit
            rts                        ; return

*--------------------------

tone_up     move.w   tone_value,d0     ; d0 contains current tone #
            add.w    #1,d0             ; increment it
            cmp.w    #97,d0            ; past the maximum?
            bgt      set_tone_x        ;  yes, ignore it
            bra      set_tone          ;  no, go save it
tone_down   move.w   tone_value,d0     ; d0 contains current tone #
            sub.w    #1,d0             ; decrement it
            beq      set_tone_x        ; ignore if zero
set_tone    move.w   d0,tone_value     ; save new tone value
            bsr      bin_to_dec        ; make new tone value string
set_tone_x  move.w   #TONEVALU,start_obj ; point to tone value for redraw
            rts                        ; return

*--------------------------

midi_status move.w   #midi,-(sp)       ; device = midi
            move.w   #bconstat,-(sp)   ; input status function
            trap     #bios             ; call bios
            addq.l   #4,sp             ; restore stack
            tst.w    d0                ; set flags
            rts                        ; return

*--------------------------

midi_in     move.w   #0,counter        ; initialize try counter
midi_in_1   bsr      midi_status       ; is character waiting?
            bne      midi_in_2         ;  yes, go process it
            add.w    #1,counter        ; no, increment counter
            cmp.w    #max_count,counter ; maximum tries reached?
            blt      midi_in_1         ; no, try again
            move.w   #1,d0             ; default button 1
            move.l   #midierr_msg,a0   ; point to error string
            bsr      form_alert        ; show form alert
            addq.l   #4,sp             ; remove return address
            bra      midi_in_x         ; and go to exit
midi_in_2   move.w   #midi,-(sp)       ; device = midi
            move.w   #bconin,-(sp)     ; input function
            trap     #bios             ; call bios
            addq.l   #4,sp             ; restore stack
            and.w    #$00ff,d0         ; mask off high byte
midi_in_x   rts                        ; return

*--------------------------

midi_out    and.w    #$00ff,d0         ; mask off high byte
            move.w   d0,-(sp)          ; and save value to be output
midi_out_1  move.w   #midi,-(sp)       ; device = midi
            move.w   #bcostat,-(sp)    ; output status function
            trap     #bios             ; call bios
            addq.l   #4,sp             ; restore stack
            tst.w    d0                ; ok to send?
            beq      midi_out_1        ;  no, try again
            move.w   #midi,-(sp)       ; device = midi
            move.w   #bconout,-(sp)    ; output function
            trap     #bios             ; call bios
            addq.l   #6,sp             ; restore stack
            rts                        ; return

*--------------------------

empty_midi  bsr      midi_status       ; check input status
            beq      empty_x           ; if no characters waiting, we're done
            bsr      midi_in           ; retrieve input
            bra      empty_midi        ; try again
empty_x     rts                        ; return

*--------------------------

midi_error  move.w   #1,d0             ; default button 1
            move.l   #midi_msg,a0      ; point to handshake string
            bsr      form_alert        ; show form alert
            cmp.w    #1,d0             ; retry selected?
            beq      midi_err_x        ;  yes, go exit
            addq.l   #4,sp             ; remove return address from stack
midi_err_x  rts                        ; return

*--------------------------

bin_to_dec  move.l   tone_addr,a0      ; point to tone value string
            move.w   tone_value,d0     ; binary tone value
            addq.l   #3,a0             ; point to end of string + 1
            move.w   #1,d1             ; loop counter
bin_to_dec1 ext.l    d0                ; extend sign
            divs     #10,d0            ; divide by ten
            swap     d0                ; swap register
            move.b   d0,-(a0)          ; move remainder to string
            add.b    #'0',(a0)         ; convert to ASCII
            swap     d0                ; swap register
            dbra     d1,bin_to_dec1    ; loop
            rts                        ; return

*--------------------------

get_name    move.b   #0,file_name      ; nullify name string
            move.l   #path_name,a0     ; point to pathname
            move.l   #file_name,a1     ; point to filename
            bsr      fsel_input        ; go do file select
            tst.w    d0                ; was cancel selected?
            bne      get_name_1        ;  no, go process
            addq.l   #4,sp             ; remove return address from stack
            bra      get_name_x        ; and go exit
get_name_1  cmp.b    #0,file_name      ; was a filename entered?
            beq      get_name          ;  no, go do it again
            move.l   #path_name,a0     ; point to pathname
            move.l   #file_path,a1     ; point to name work area
            bsr      strpath           ; go remove any wildcard info
            move.l   #file_path,a0     ; point to name work area
            move.l   #file_name,a1     ; point to filename
            bsr      strcat            ; concatenate filename to work path
get_name_x  rts                        ; return

*--------------------------
* a0 -> tostring  a1 -> fromstring

strcat      tst.b    (a0)+             ; end of tostring?
            bne      strcat            ;  no, try next byte
            subq.l   #1,a0             ; adjust pointer
strcat_1    move.b   (a1)+,(a0)+       ; move fromstring to tostring
            bne      strcat_1          ; continue until end of fromstring
            rts                        ; return

*--------------------------
* a0 -> pathname  a1-> newpath

strpath     move.l   a1,-(sp)          ; save newpath name address
            clr.w    d1                ; zero current index
            clr.w    d2                ; zero save index
strpath_1   move.b   (a0)+,d0          ; move character from pathname
            move.b   d0,(a1)+          ; to new pathname
            beq      strpath_4         ; end of string
            cmp.b    #':',d0           ; is it a colon?
            beq      strpath_2         ;  yes, save current index
            cmp.b    #'\',d0           ; is it a backslash?
            bne      strpath_3         ;  no, increment index
strpath_2   move.w   d1,d2             ; move current index to save index
strpath_3   addq.w   #1,d1             ; increment current index
            bra      strpath_1         ; go loop
strpath_4   move.l   (sp)+,a0          ; restore newpath name address
            move.b   #0,1(a0,d2)       ; move end of string byte to it
            rts                        ; return

*--------------------------

send        move.w   #SEND,d0          ; set object index to SEND
            bsr      deselect          ; turn off button
            bsr      get_name          ; get file name
            move.w   #0,-(sp)          ; open patch file for
            move.l   #file_path,-(sp)  ;    read only
            move.w   #open,-(sp)       ;
            trap     #gemdos           ; call gemdos
            addq.l   #8,sp             ; restore stack
            move.w   d0,file_handle    ; save file handle
            tst.w    d0                ; was open successful?
            bpl      send_1            ;  yes, go process
            move.w   #1,d0             ; default to button 1
            move.l   #open_msg,a0      ; point to open error string
            bsr      form_alert        ; show form alert
            bra      send_x            ; go exit
send_1      move.l   #patch_buff,-(sp) ; point to patch buffer
            move.l   #patch_len,-(sp)  ; length of patch to be read
            move.w   file_handle,-(sp) ; file handle
            move.w   #read,-(sp)       ; read function
            trap     #gemdos           ; call gemdos
            add.l    #12,sp            ; restore stack
            move.w   file_handle,-(sp) ; file handle
            move.w   #close,-(sp)      ; close function
            trap     #gemdos           ; call gemdos
            addq.l   #4,sp             ; restore stack
send_2      bsr      empty_midi        ; flush the midi
            move.w   tone_value,d0     ; current tone value
            sub.w    #1,d0             ; decrement for midi use
            move.b   d0,receive_req+6  ; and save
            move.l   #receive_req,a3   ; point to system exclusive string
            move.w   #6,d3             ; counter for string length
send_3      move.b   (a3)+,d0          ; move system exclusive byte
            bsr      midi_out          ; and send to the midi
            dbra     d3,send_3         ; until all bytes sent
            move.w   #5,d3             ; counter for handshake string length
            move.l   #handshake,a3     ; point to handshake string
send_4      bsr      midi_in           ; retrieve byte from midi
            cmp.b    (a3)+,d0          ; do they match
            beq      send_5            ;  yes, continue
            bsr      midi_error        ;  no, show error
            bra      send_2            ;  and try again
send_5      dbra     d3,send_4         ; until end of handshake
            move.l   #patch_buff,a3    ; point to new tone patch
            move.w   #patch_len-1,d3   ; counter for patch length
send_6      move.b   (a3)+,d4          ; save tone byte
            move.b   d4,d0             ; move tone byte for conversion
            lsr.b    #4,d0             ; shift 4 bits
            bsr      midi_out          ; and send the high nibble
            move.b   d4,d0             ; restore tone byte
            and.b    #$0f,d0           ; mask off high nibble
            bsr      midi_out          ; and send the low nibble
            dbra     d3,send_6         ; until end of patch
            move.b   #$f7,d0           ; end of system exclusive byte
            bsr      midi_out          ; send it
            bsr      midi_in           ; retrieve byte from midi
            cmp.b    #$f7,d0           ; was send successful?
            beq      send_7            ;  yes, go say so
            bsr      midi_error        ; midi did not acknowledge correctly
            bra      send_2            ; go try again
send_7      move.w   #1,d0             ; default button 1
            move.l   #send_msg,a0      ; point to send ok string
            bsr      form_alert        ; show form alert
send_x      rts                        ; return

*--------------------------

receive     move.w   #RECEIVE,d0       ; set object index to RECEIVE
            bsr      deselect          ; turn off button
            bsr      empty_midi        ; flush the midi
            move.w   tone_value,d0     ; current tone value
            sub.w    #1,d0             ; decrement for midi use
            move.b   d0,send_req+6     ; and save
            move.l   #send_req,a3      ; point to system exclusive string
            move.w   #6,d3             ; counter for string length
receive_1   move.b   (a3)+,d0          ; move system exclusive byte
            bsr      midi_out          ; and send
            dbra     d3,receive_1      ; until end of string
            move.w   #5,d3             ; counter for handshake string length
            move.l   #handshake,a3     ; point to handshake string
receive_2   bsr      midi_in           ; retrieve midi byte
            cmp.b    (a3)+,d0          ; are they equal? 
            beq      receive_3         ;  yes, continue
            bsr      midi_error        ;  no, show error message
            bra      receive           ;  and try again
receive_3   dbra     d3,receive_2      ; until end of handshake
            move.b   #$70,d0           ; move acknowledge byte
            bsr      midi_out          ; and send
            move.b   #$31,d0           ; move acknowledge byte
            bsr      midi_out          ; and send
            move.w   #patch_len-1,d3   ; counter for patch length
            move.l   #patch_buff,a3    ; point to patch buffer
receive_4   bsr      midi_in           ; retrieve tone byte from midi
            move.b   d0,d4             ; and save
            bsr      midi_in           ; retrieve tone byte from midi
            lsl.b    #4,d4             ; convert to high nibble
            add.b    d4,d0             ; and add to low nibble
            move.b   d0,(a3)+          ; save tone byte in buffer
            dbra     d3,receive_4      ; until end of patch
            move.b   #$f7,d0           ; move end of system exclusive byte
            bsr      midi_out          ; and send
receive_5   bsr      get_name          ; get file name
            move.w   #0,-(sp)          ; open patch file for
            move.l   #file_path,-(sp)  ;    read only
            move.w   #open,-(sp)       ;
            trap     #gemdos           ; call gemdos
            addq.l   #8,sp             ; restore stack
            tst.w    d0                ; was open successful?
            bmi      receive_6         ;  no, file didn't exist
            move.w   d0,-(sp)          ; move file handle
            move.w   #close,-(sp)      ; close function
            trap     #gemdos           ; call gemdos
            addq.l   #4,sp             ; restore stack
            move.w   #2,d0             ; default button 2
            move.l   #exists_msg,a0    ; point to file exists string
            bsr      form_alert        ; show form alert
            cmp.w    #2,d0             ; was cancel selected?
            beq      receive_5         ;  yes, go get new name
receive_6   move.w   #0,-(sp)          ; create patch file with
            move.l   #file_path,-(sp)  ;    read/write status
            move.w   #create,-(sp)     ;
            trap     #gemdos           ; call gemdos
            addq.l   #8,sp             ; restore stack
            move.w   d0,file_handle    ; save file handle
            tst.w    d0                ; was create successful?
            bpl      receive_7         ;  yes, go process
            move.w   #1,d0             ; default button 1
            move.l   #save_msg,a0      ; point to file error string
            bsr      form_alert        ; show form alert
            bra      send_x            ; go exit
receive_7   move.l   #patch_buff,-(sp) ; point to patch buffer
            move.l   #patch_len,-(sp)  ; length of patch to be written
            move.w   file_handle,-(sp) ; file handle
            move.w   #write,-(sp)      ; write function
            trap     #gemdos           ; call gemdos
            add.l    #12,sp            ; restore stack
            move.l   d0,-(sp)          ; save # of bytes written
            move.w   file_handle,-(sp) ; file handle
            move.w   #close,-(sp)      ; close function
            trap     #gemdos           ; call gemdos
            addq.l   #4,sp             ; restore stack
            move.l   (sp)+,d0          ; move # of bytes written
            cmp.l    #patch_len,d0     ; is it equal to patch length?
            beq      receive_8         ;  yes, show ok msg
            move.w   #1,d0             ; default button 1
            move.l   #save_msg,a0      ; point to save error string
            bsr      form_alert        ; show form alert
            bra      receive_x         ; go exit
receive_8   move.w   #1,d0             ; default button 1
            move.l   #receive_msg,a0   ; point to receive ok string
            bsr      form_alert        ; show form alert
receive_x   rts                        ; return

*--------------------------

grhandle    ds.w  1
vdihandle   ds.w  1
appl_id     ds.w  1
counter     ds.w  1
tone_value  dc.w  1
start_obj   ds.w  1
x           ds.w  1
y           ds.w  1
w           ds.w  1
h           ds.w  1

send_req    dc.b  $f0,$44,$00,$00,$70,$10,$00
receive_req dc.b  $f0,$44,$00,$00,$70,$20,$00
handshake   dc.b  $f0,$44,$00,$00,$70,$30

            ds.w  0
patch_buff  ds.b  patch_len

file_handle ds.w  1
path_name   ds.b  64
file_name   ds.b  16
file_path   ds.b  80
wild_card   dc.b  '\*.SND',0

aespb       dc.l  contrl,global,intin,intout,addrin,addrout
vdipb       dc.l  contrl,intin,ptsin,intout,ptsout

dialog_addr ds.l  1
tone_addr   ds.l  1

rsrc_name   dc.b  'CZPATCH.RSC',0

rsrc_msg    dc.b  '[3][Unable to load CZPATCH.RSC][ABORT]',0
open_msg    dc.b  '[3][Unable to load patch.][ OK ]',0
save_msg    dc.b  '[3][Unable to save patch.][ OK ]',0
midi_msg    dc.b  '[3][Unable to establish|'
            dc.b  'handshake with MIDI.][RETRY|CANCEL]',0
midierr_msg dc.b  '[3][The MIDI is not responding!| '
            dc.b  $08,' Is the MIDI turned on?| '
            dc.b  $08,' Is the channel set to 1?| '
            dc.b  $08,' Is the tone value valid?][ OK ]',0
exists_msg  dc.b  '[3][The filename selected|already exists!  Do you|'
            dc.b  'want to overwrite it?][ YES | NO ]',0
send_msg    dc.b  '[1][Patch successfully|sent to MIDI.][ OK ]',0
receive_msg dc.b  '[1][Patch successfully|received from MIDI.][ OK ]',0

*--------------------------

work_in     dc.w  1,1,1,1,1,1,1,1,1,1,2
work_out    ds.w  57

contrl      ds.w  0
opcode      ds.w  1
sintin      ds.w  1
sintout     ds.w  1
saddrin     ds.w  1
saddrout    ds.l  1
            ds.w  5

global      ds.w  0
apversion   ds.w  1
apcount     ds.w  1
apid        ds.w  1
apprivate   ds.l  1
apptree     ds.l  1
ap1resv     ds.l  1
ap2resv     ds.l  1
ap3resv     ds.l  1
ap4resv     ds.l  1

intin       ds.w  128
ptsin       ds.w  128
intout      ds.w  128
ptsout      ds.w  128
addrin      ds.w  128
addrout     ds.w  128

            ds.l  300
user_stack  ds.l  1
            ds.w  10

            end

