
/*********************************************************************/
/* This file contains a small portion of 'clock.c'-- it creates an   */
/*   accessory that initializes the system according to the          */
/*   DESKTOP.INF file, and nothing else. Compile and link as an      */
/*   accessory.                                                      */
/*********************************************************************/

/*===========================================================================*/
/*  System Setup Accessory                              (c)1986 John Brochu  */
/*---------------------------------------------------------------------------*/
/*  Reads the DESKTOP.INF file and sets all parameters the Control Panel     */
/*   normally would, including printer configuration.                        */
/*---------------------------------------------------------------------------*/
/*  Link with: accstart,SETUP,aesbind,osbind          Written with Alcyon C  */
/*---------------------------------------------------------------------------*/

#include "osbind.h"

/*-------------------------Miscellaneous definitions-------------------------*/
#define Vsync()         xbios(37)
#define SPC             0x20
#define NXT_BYT         ((unsigned)((*buf_ptr++)-'0'))
/*---------------------------------------------------------------------------*/

/*-----------------------Global variable declarations------------------------*/
int     contrl[12], intin[128], intout[128], ptsin[128], ptsout[128];
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/******* find(), dpeek(), get_b_hdr(), & get_c_hdr() FUNCTIONS GO HERE *******/
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/

main()
{
        static char     inf_fil[]={"#:\\DESKTOP.INF"};
        int             x, handle;
        long            buffer, length, error, blk, bootdev = 0x00000446;


        appl_init();
                                                /* Look for DESKTOP.INF...   */
        inf_fil[0] = Dgetdrv() + 'A';           /* Look on current drv first.*/
        if ((error = Fopen(inf_fil, 0)) < 0) {  /* If not there, look on     */
                x = dpeek(bootdev) + 'A';       /*  boot drive if not the    */
                if (x != inf_fil[0]) {          /*  same as current drive... */
                        inf_fil[0] = x;
                        error = Fopen(inf_fil, 0);
                }
        }               
        if (error >= 0) {                               /* If DESKTOP.INF    */
                handle = error;                         /*  was found,       */
                blk = buffer = Malloc(1024L);   /*  allocate 1K block for it.*/
                if (blk==0)     Fclose(handle); /* Not enough free memory!   */
                else {                          /* If no error, load the file*/
                        length = Fread(handle, 1024L, buffer);
                        Fclose(handle);
                        get_b_hdr(buffer, length);    /* Process '#b' header */
                        get_c_hdr(buffer, length);    /* Process '#c' header */
                        Mfree(blk);             /* Free our 1K memory block  */
                }
        }
        while(1)        evnt_timer(60000,0);    /* (Timeout is one minute)   */
}

/*===========================================================================*/
