{$M+,E+}
PROGRAM Gem_Raster ;

{ gemrast.pas - Raster operation support for Personal Pascal library.

    The following routines are declared in this module:

    Copy_Opaque - Opaque raster copy operations.  The source and destination
                  bitmaps must be of the same color/monochrome format, but
                  need not be the same device format (?).
}

  CONST
    {$I gemconst.pas}

  TYPE
    {$I gemtype.pas}

    Form_Format = ( Device_Format, Standard ) ;
    Mem_Form_Def = RECORD
                     mem : long_integer ;
                     pw : integer ;
                     ph : integer ;
                     width : integer ;
                     format : Form_Format ;
                     planes : integer ;
                     res1 : integer ;
                     res2 : integer ;
                     res3 : integer ;
                   END ;
    Raster_Op = ( ROP_0, ROP_And, ROP_AndNot, ROP_Replace, ROP_NotAnd, ROP_NOP,
                  ROP_Xor, ROP_Or, ROP_Not_Or, ROP_Not_Xor, ROP_NotD,
                  ROP_OrNot, ROP_NotS, ROP_NotOr, ROP_Not_And, ROP_1 ) ;

    Ctrl_Parms = ARRAY[0..11] OF Integer;
    Int_In_Parms = ARRAY[0..15] OF Integer;
    Int_Out_Parms = ARRAY[0..45] OF Integer;
    Pts_In_Parms = ARRAY[0..11] OF Integer;
    Pts_Out_Parms = ARRAY[0..11] OF Integer;
    Inq_type = (Open_Vals, Ext_Vals);

    PROCEDURE VDI_Call(cmd,sub_cmd,nints,npts : Integer; VAR ctrl : Ctrl_Parms;
                       VAR int_in : Int_In_Parms ; VAR int_out : Int_Out_Parms;
                       VAR pts_in : Pts_In_Parms ; VAR pts_out : Pts_Out_Parms;
                       translate : Boolean);
       EXTERNAL;

  PROCEDURE Copy_Opaque( source_l, source_h, dest_l, dest_h, op,
                        sx, sy, sw, sh, dx, dy, dw, dh : integer ) ;

    VAR
      ctrl : Ctrl_Parms ;
      int_in : Int_In_Parms ;
      int_out : Int_Out_Parms ;
      pts_in : Pts_In_Parms ;
      pts_out : Pts_Out_Parms ;

    BEGIN
      ctrl[7] := source_h ;
      ctrl[8] := source_l ;
      ctrl[9] := dest_h ;
      ctrl[10] := dest_l ;
      int_in[0] := op ;
      pts_in[0] := sx ;
      pts_in[1] := sy ;
      pts_in[2] := sx+sw-1 ;
      pts_in[3] := sy+sh-1 ;
      pts_in[4] := dx ;
      pts_in[5] := dy ;
      pts_in[6] := dx+dw-1 ;
      pts_in[7] := dy+dh-1 ;
      VDI_Call( 109, 0, 1, 4, ctrl, int_in, int_out, pts_in, pts_out, false ) ;
    END ;

  BEGIN
  END.

{ End of gemrast.pas }
