*******************************************************************************
*                                                                             *
*  DESK MANAGER                                                               *
*                                                                             *
*  Determine which accessories will be active from within an AUTO folder.     *
*                                                                             *
*  Copyright 1987 Charles F. Johnson and Little Green Footballs Software      *
*                                                                             *
*******************************************************************************

* -----------------------------------
*  Last revision: 05/22/87  17:11:42
* -----------------------------------

gemdos		=	1
bios		=	13
xbios		=	14

esc		=	27
workln		=	20

max_acc		=	128

	.text

	bra	start		Skip over default drive data

defdrv:	dc.b	'X',0

start:	move	#$FF,-(sp)	Get a keypress without waiting
	move	#6,-(sp)	with Gemdos Crawio (Rawconio)
	trap	#gemdos
	addq.l	#4,sp
	tst.l	d0		Is there a keypress?
	beq	mshrnk		No, skip ahead
	move.l	d0,keysav	We have a key, so save it
	swap	d0		Get scan code to lower word
	cmp.w	#$61,d0		Is it UNDO?
	beq	ex6		Yes, exit immediately
	move	#1,keyflg	Set the flag

mshrnk:	move.l	a7,a5		GEMDOS mshrink command to release memory
	move.l	#nstack,a7	not needed by this program
	move.l	4(a5),a5	Address of basepage
	move.l	$c(a5),d0	Get length of program area
	add.l	$14(a5),d0	Add length of data area
	add.l	$1c(a5),d0	Add length of bss area
	add.l	#$100,d0	Add 256 bytes for the basepage
	move.l	d0,-(sp)	Length of area to keep
	move.l	a5,-(sp)	Start address of area to keep
	clr.w	-(sp)		Dummy word
	move	#$4a,-(sp)
	trap	#gemdos
	add.l	#12,sp
	tst.l	d0
	bne	ex6

	move	#4,-(sp)	XBIOS #4 - getrez
	trap	#xbios
	addq.l	#2,sp
	move	d0,res		Save resolution

	move	#$2A,-(sp)	Get date
	trap	#gemdos
	addq.l	#2,sp
	move	d0,d4		Save date in d4

	move.l	#dattim+2,a5	Pointer to string area
	and.w	#%111100000,d0	Mask for month
	lsr.w	#5,d0		Shift 'em
	move	d0,d2

	subq.w	#1,d0		Subtract one for indexing
	mulu	#4,d0		Length of month strings
	add.l	#months,d0	Add start of month array
	move.l	d0,a0		Move the address to where it can do some good
	move	#3,d5		Move the month name into the text area
cpmnt1:	move.b	(a0)+,(a5)+
	dbf	d5,cpmnt1

	move	d4,d0		Get the date again
	and.w	#%11111,d0	Mask for day
	move	d0,d2		Save in d2

	bsr	bindc2		Go convert to ASCII decimal
	cmp.b	#'0',-2(a5)	First character a zero?
	bne	cpmnt2		No, skip
	move.b	-(a5),-(a5)	Move 'em over
	addq.l	#1,a5
cpmnt2:	move.b	#',',(a5)+	Put in the comma
	move.b	#' ',(a5)+	And a space
	move.b	#'1',(a5)+	We're still in the 20th century, right?
	move.b	#'9',(a5)+
	move	d4,d0		Get date again
	and.w	#%1111111000000000,d0	Mask for year
	lsr.w	#8,d0		Shift it right 9 bits
	lsr.w	#1,d0
	add.w	#80,d0		Add 80 (year is always -80)
	move	d0,d2

	bsr	bindc2		Convert to ASCII decimal
	move.b	#' ',(a5)+	Move in a space
	move.b	#$7C,(a5)+	And a vertical line character
	move.b	#' ',(a5)+	And another space
	move	d4,d0		Get the date one more time
	and.w	#%11111,d0	Mask for day
	cmp.w	#9,d0		Greater than 9?
	bgt	gtime1		Yes, skip
	move.b	#' ',(a5)+	Add another space after the single-digit day

gtime1:	move	#$2C,-(sp)	Get time
	trap	#gemdos
	addq.l	#2,sp
	move	d0,d4		Save it in d4

	and.w	#%1111100000000000,d0	Mask for hour
	lsr.w	#8,d0		Shift it right 11 bits
	lsr.w	#3,d0
	move	d0,d2

	tst.w	d0		Is it zero?
	bne	do24_1		No, skip
	move	#12,d0		Put a 12 here (it's 12 midnight)
	clr.w	d6		d6 is the 24-hour time flag
	bra	do24_3		Skip ahead
do24_1:	cmp.w	#11,d0		Greater than 11?
	bgt	do24_2		Yes, skip
	clr.w	d6		Clear the flag
	bra	do24_3
do24_2:	cmp.w	#12,d0		Is it 12 noon?
	beq	d24_21		Yes, skip
	sub.w	#12,d0		Subtract 12 to get a value from 1 to 12
d24_21:	move	#1,d6		Set the flag
do24_3:	bsr	bindc2		Convert to ASCII decimal
	cmp.b	#'0',-2(a5)	Single digit hour?
	bne	do24_4		No, skip
	move.b	#' ',-2(a5)	Put a space in place of the "0"
do24_4:	move.b	#':',(a5)+	Colon separator (I don't like the sound of that)
	move	d4,d0		Get time again
	and.w	#%11111100000,d0	Mask for minutes
	lsr.w	#5,d0		Shift right 5 bits
	move	d0,d2

	bsr	bindc2		Convert to decimal
	move.b	#':',(a5)+	Put the colon in
	move	d4,d0		Get time again
	and.w	#%11111,d0	Mask for seconds
	lsl.w	#1,d0		Multiply by 2 (2 second intervals)
	move	d0,d2

	bsr	bindc2		Convert to decimal
	move.b	#' ',(a5)+	Move in a space
	tst.w	d6		AM or PM?
	bne	do24_5		Must be PM
	move.l	#ammsg,a4	Address of "am" text
	bra	do24_6
do24_5:	move.l	#pmmsg,a4	Address of "pm" text
do24_6:	move.b	(a4)+,(a5)+	Move it in
	move.b	(a4)+,(a5)+

	move.b	#' ',(a5)+	Add a space and a vertical line
	move.b	#$7C,(a5)+

	move	#3,d5		Spaces out to end of line
spclp1:	move.b	#' ',(a5)+
	dbf	d5,spclp1

	move.b	#esc,(a5)+	Move in the VT52 code to turn off inverse
	move.b	#'q',(a5)+
	clr.b	(a5)+		Set zero terminator at end of line

clear:	tst.w	res		Are we in low res?
	bne	clr2		Nope, skip ahead
	move	#1,-(sp)	Set resolution to medium
	move.l	#-1,-(sp)
	move.l	#-1,-(sp)
	move	#5,-(sp)	Xbios setscreen call
	trap	#xbios
	add.l	#12,sp
	clr.w	-(sp)		Now set color register three to black
	move	#3,-(sp)
	move	#7,-(sp)	Xbios setcolor
	trap	#xbios
	addq.l	#6,sp

clr2:	move.l	#clrhom,a0	Print title line
	bsr	print_string

	cmp.b	#'X',defdrv	Is it the first time we've run this program?
	beq	getdrv
	cmp.b	#$62,keysav+1	Did the user type HELP?
	bne	setdef

getdrv:	move.l	#nodams,a0	Print the prompt for desk accessory drive
	bsr	print_string
getdef:	move	#7,-(sp)	Get a keypress with no echo to screen
	trap	#gemdos
	addq.l	#2,sp
	and.w	#$DF,d0		Mask lowercase
	cmp.b	#'A',d0		A and C are the only legal drives
	beq	setnms
	cmp.b	#'C',d0
	bne	getdrv

setnms:	move.b	d0,defdrv
	move	#2,d5		Open for read/write
	move.l	#dskmgr,a5	Address of Desk Manager filename (DESKMGR.PRG)
	bsr	openfl		Try to open it
	bmi	ex6		Error, let's just forget the whole thing
	move	d0,handle	Save handle

fixfil:	clr.w	-(sp)		Start from beginning of file
	move	handle,-(sp)
	move.l	#30,-(sp)	Set file pointer to 30 bytes in
	move	#$42,-(sp)	Do it
	trap	#gemdos
	add.l	#10,sp
	pea	defdrv		Write one byte to the file
	move.l	#1,-(sp)	at this position
	move	handle,-(sp)
	move	#$40,-(sp)
	trap	#gemdos
	add.l	#12,sp
	bsr	closfl		And of course, don't forget to close it

setdef:	move.b	defdrv,d0
	move.b	d0,snam		Set drive specifiers in all filenames
	move.b	d0,accnm1
	move.b	d0,accnam
	move.b	d0,adrv

	move.l	#clrbot,a0	Clear the bottom of the screen
	bsr	print_string

	clr.w	d5		Just in case
	move.b	defdrv,d5
	sub.b	#$41,d5
	move	d5,-(sp)	Set default drive
	move	#$0E,-(sp)
	trap	#gemdos
	addq.l	#4,sp

	clr.w	done		Clear done flag
	clr.w	accnum		Clear accessory counter

	move.l	#array,a5	Initialize name array to spaces
	move	#1151,d5
zarr1:	move.b	#' ',(a5)+
	dbf	d5,zarr1

	move.l	#change,a3
	move.l	#choice,a4
	move.l	#array+8,a5	Set a null byte every nine bytes
	move	#127,d5		for printing to the screen
setz1:	clr.b	(a3)+		Also clear the change and choice arrays
	clr.b	(a4)+
	clr.b	(a5)
	add.l	#9,a5
	dbf	d5,setz1

	clr.w	selnum		No accessories selected
	clr.w	altflg

	move.l	#array,namadr	Set pointer to start of name array
	move.l	#snam,filnam	Set address of filespec
	bsr	sfirst		Set DTA and get first match
	tst.l	d0		Error?
	bne	exit		Yes, exit
	bsr	copynm		Copy name to arrays
files:	move	accnum,d1	Have we found the maximum # of accessories?
	cmp.w	#max_acc,d1
	beq	exit		Yes, exit
	bsr	snext		Find next filename
	tst.l	d0
	bne	exit
	bsr	copynm
	bra	files

exit:	tst.w	accnum		Got any accessories at all?
	bne	ex2		Yes, skip ahead
	move.l	#noacc,a0	Print message
	bsr	print_string
	bra	ex6		And exit

ex2:	bsr	sort		Sort the names alphabetically
	bsr	ploop0		And print them on the screen

	bsr	keyms		Set mouse to cursor key emulation

	move.l	#prompt,a0	Print help message at bottom
	bsr	print_string

acl_st:	clr.b	xpos		Init positions and counters
	clr.b	ypos
	clr.w	curacc
	move.b	#32,nampos+2
	move.b	#32,nampos+3
	move.l	#nampos,a0	Print pointer in upper left (1st name)
	bsr	print_string
	move.l	#pointr,a5
	bsr	prtptr
	tst	keyflg		Got a key waiting?
	beq	acloop		Yes, skip
	move.l	keysav,d0	Get the key
	clr.w	keyflg		Clear the flag
	bra	check1		Skip the first input call

acloop:	move	#7,-(sp)	Get a keypress (no echo to screen)
	trap	#gemdos
	addq.l	#2,sp

check1:	cmp.b	#esc,d0		Is it ESC?
	beq	aclx1		Yes, exit
	cmp.b	#13,d0		Is it RETURN?
	bne	acl0
gosel:	bsr	selnam		Go toggle the filename
	move	#1,altflg
	bra	acloop

acl0:	swap	d0		Get scan code into lower word
	cmp.b	#$74,d0		Left button?
	beq	gosel		Yes, go select the name
	cmp.b	#$75,d0		Right button?
	beq	aclx1

acl1:	cmp.b	#$4B,d0		Left arrow?
	bne	acl2		No, skip
	move.l	#eraptr,a5	Erase old pointer
	bsr	prtptr
	clr.l	d4
	move	curacc,d4	Get current accessory
	divu	#8,d4		Divide by 8 (8 names per line)
	swap	d4		Get remainder to low word
	tst	d4		Is it zero?
	beq	printp		Yes, we're at the left edge...exit
	subq.w	#1,curacc	Subtract one
printp:	bsr	setpos		Go set the cursor position
	move.l	#pointr,a5	Print pointer at new spot
	bsr	prtptr
	bra	acloop

acl2:	cmp.b	#$4D,d0		Right arrow
	bne	acl3
	move.l	#eraptr,a5	Erase the old pointer
	bsr	prtptr
	clr.l	d4
	move	curacc,d4	Get current acc
	addq.w	#1,d4		Increment it
	divu	#8,d4		Divide by 8 (# of names on a line)
	swap	d4		Get remainder
	tst	d4		Is it zero (at end of line)?
	beq	printp		Yes, skip
	move	accnum,d1	Get end of names
	subq.w	#1,d1
	cmp.w	curacc,d1	Are we at the end?
	beq	printp		Yes, forget it
notend:	addq.w	#1,curacc	Increment current acc
	bra	printp		And go print the pointer

acl3:	cmp.b	#$48,d0		Up arrow
	bne	acl4
	move.l	#eraptr,a5	Erase old pointer
	bsr	prtptr
	cmp.w	#8,curacc	On the top line?
	blt	printp		Yes, skip
	subq.w	#8,curacc	Subtract 8 (length of one line)
	bra	printp		Go print it

acl4:	cmp.b	#$50,d0		Down arrow
	bne	acl5
	move.l	#eraptr,a5
	bsr	prtptr
	addq.w	#8,curacc	Add length of one line
	move	accnum,d1	Get number of accs
	cmp.w	curacc,d1	Compare to current acc
	bgt	printp		Not on bottom line, skip
	subq.w	#8,curacc	Set pointer back
	bra	printp

acl5:	cmp.b	#$47,d0		Clr Home?
	bne	acloop		Nope, back to the top
	bsr	zchoic		Zero out the choice array
	move.l	#eraptr,a5	Erase the pointer
	bsr	prtptr
	bsr	ploop0		Go print 'em again
	clr.w	selnum		None selected
	move	#1,altflg
	bra	acl_st		Back to the top

aclx1:	bsr	resrel		Reset mouse to relative mode

	tst.w	altflg		Anything changed at all?
	beq	ex4_1		Nope, go exit
	move.l	#renmsg,a0	Print "Renaming accessories"
	bsr	print_string

	clr.w	curacc		Acc counter to zero
	move.l	#choice,chptr	Set pointer to choice array
rloop1:	move.l	chptr,a0	Get pointer
	tst.b	(a0)		Selected?
	beq	rloop2		No, skip ahead
	move.l	#acc,a4		Move address of ".ACC" extension to a4
	bra	rloop3		And skip ahead
rloop2:	move.l	#acx,a4		Address of ".ACX" extension
rloop3:	bsr	renam		Go rename it
	addq.l	#1,chptr	Increment pointer to choice array
	addq.w	#1,curacc	Increment current acc
	move	accnum,d0
	cmp.w	curacc,d0	All done?
	bne	rloop1		No, finish up

ex4_1:	move.l	#lastms,a0	Print final message
	bsr	print_string

ex6:	clr	-(sp)		Return to desktop
	trap	#gemdos

* Subroutines

print_string:
	move.l	a0,-(sp)	Print a string of characters with GEMDOS
	move	#9,-(sp)	Enter with a0= address of string
	trap	#gemdos
	addq.l	#6,sp
	rts

bindc2:	move.l	a5,a0		Pointer to ASCII text output buffer
	move	#1,d1
bd2_1:	move.b	#'0',(a0)+	Initialize to ASCII zeros
	dbf	d1,bd2_1
	move	#1,d1
bd2_2:	ext.l	d0		Extend to long
	divs	#10,d0		Divide by 10
	swap	d0		Get remainder to low word
	move.b	d0,-(a0)	Move to text area
	add.b	#'0',(a0)	Adjust it to ASCII
	swap	d0		Get quotient back to low word
	dbra	d1,bd2_2	Loop until done
bd2_3:	addq.l	#2,a5
	rts

zchoic:	move.l	#choice,a5	Zero out the choice array
	move.l	#change,a4
	move.l	#127,d5
zcho1:	tst.b	(a5)+		Was this already un-selected?
	beq	zchoi2		Yes, skip
	eor.b	#1,(a4)		Mark this acc as having changed
	clr.b	-1(a5)		And clear the choice byte
zchoi2:	addq.l	#1,a4		Increment pointer to change array
	dbf	d5,zcho1
	rts

keyms:	move.l	#keybrd,-(sp)	Set mouse to cursor key emulation
	move	#2,-(sp)
	move	#25,-(sp)
	trap	#xbios
	addq.l	#8,sp
	rts

resrel:	move.l	#mousey,-(sp)	Hopefully this sets the mouse back to its
	clr.w	-(sp)		natural state (relative mode)
	move	#25,-(sp)
	trap	#xbios
	addq.l	#8,sp
	move.l	#-1,-(sp)	Get pointer to SKEYTRAN
	move.l	#-1,-(sp)
	move.l	#-1,-(sp)
	move	#16,-(sp)
	trap	#xbios
	add.l	#14,sp
	move.l	d0,a5
	clr.b	29(a5)		Clear KEYREP (byte)
	clr.w	30(a5)		and KDELAY1 (word)
	rts

sfirst:	bsr	setdta
	clr.w	-(sp)		SFIRST - search for first name in
	move.l	filnam,-(sp)	directory that matches the filespec
	move	#$4E,-(sp)
	trap	#gemdos
	addq.l	#8,sp
	rts

snext:	bsr	setdta
	move	#$4F,-(sp)	SNEXT - find next match for filespec
	trap	#gemdos		(the filename is returned in the DTA area)
	addq.l	#2,sp
	rts

setdta:	pea	dta		Set address of GEMDOS DTA area
	move	#$1A,-(sp)
	trap	#gemdos
	addq.l	#6,sp
	rts

copynm:	move.l	#dta+30,a5	Address of DTA buffer+30=filename
	move.l	namadr,a4
	move	#7,d5
setnam:	move.b	(a5)+,d0	Copy name from DTA area
	cmp.b	#'.',d0		Period?
	beq	set3		Yes, exit
	move.b	d0,(a4)+	Move character
	dbf	d5,setnam	Count down and loop
	addq.l	#1,a5
set3:	move.l	#acc+1,a0	Address of "ACC" text
	move	#2,d5		Three characters to check
set4:	cmp.b	(a0)+,(a5)+	Is this acc already installed?
	bne	set5		No, skip ahead
	dbf	d5,set4
	cmp.w	#6,selnum	Do we already have 6 accessories?
	beq	set5		Yes, skip
	addq.w	#1,selnum	Increment selection counter
	move.l	#choice,a0	Address of choice array
	move	accnum,d0	ACC counter used as index
	move.b	#1,0(a0,d0.w)	Mark this acc as selected
set5:	add.l	#9,namadr	Increment pointer to name array
	addq.w	#1,accnum	Count accessories
	rts

ploop0:	move.l	#choice,a5
	move.l	#array,namadr	Set pointer to start of name array
	move.b	#32,nampos+2	Initialize print positions
	move.b	#33,nampos+3
	move	accnum,d5	Get number of accs
	subq.w	#1,d5		Subtract one for dbf count
ploop1:	move.l	#nampos,a0	Position the cursor
	bsr	print_string
	tst.b	(a5)+		Is this accessory selected?
	beq	pl_1		No, skip
	move.l	#invmsg,a0	Set to inverse
	bsr	print_string
	bra	ploop2
pl_1:	move.l	#regmsg,a0	Not selected, regular print
	bsr	print_string
ploop2:	move.l	namadr,a0	Print 1st eight characters of name
	bsr	print_string
	add.b	#10,nampos+3	Increment X print position
	move.b	nampos+3,d0
	cmp.b	#113,d0		Done 8 names on this line?
	bne	ploop3		No, skip
	move.b	#33,nampos+3	Set position back to left side
	addq.b	#1,nampos+2	Increment Y print position
ploop3:	add.l	#9,namadr	Increment pointer to array
	dbf	d5,ploop1
	move.l	#regmsg,a0
	bra	print_string

* Rename routine
* Enter with: a4= address of extension (.ACC or .ACX)

renam:	clr.l	d0		Clear work register
	move	curacc,d0	Get current acc number
	move.l	#change,a0	Start of change array
	tst.b	0(a0,d0)	Was this name changed?
	beq	renrts		No, exit
	mulu	#9,d0		Multiply current accessory by nine
	add.l	#array,d0	Add start of name array
	move.l	d0,a0		Move to an address register so we can use it
	move.l	#acc1,a1	Address of old filename
	move.l	#acc2,a2	Address of new filename
	move	#7,d0
renl1:	move.b	(a0),(a1)+	Move this name to both areas
	move.b	(a0)+,(a2)+
	dbf	d0,renl1
	clr.l	d0		Clear work register again
	move.l	#snam+4,a0	Address of ".AC?" extension
	move.l	#acc1,a1	Old filename address
	move	#7,d5		Eight characters
renl2:	move.b	(a1),d0		Get a character
	cmp.b	#32,d0		Is it a space?
	beq	renl3		Yes, skip ahead
	addq.l	#1,a1		Increment pointer
	dbf	d5,renl2	Keep looking
renl3:	move	#3,d5
renl4:	move.b	(a0)+,(a1)+	Move in the AC? extension
	dbf	d5,renl4
	clr.b	(a1)		Set terminator

	move.l	#acc2,a5	
	move	#7,d5		8 characters
ren1:	move.b	(a5),d0		Search for space character
	cmp.b	#32,d0
	beq	rename		Got it, exit
	addq.l	#1,a5		Increment pointer
	dbf	d5,ren1		Count and loop
rename:	move	#3,d5
ren2:	move.b	(a4)+,(a5)+	Move extension (.ACC or .ACX)
	dbf	d5,ren2
	clr.b	(a5)		Mark end of filename
	pea	accnam		Rename that accessory!
	pea	accnm1
	clr.w	-(sp)
	move	#$56,-(sp)
	trap	#gemdos
	add.l	#12,sp
renrts:	rts

selnam:	clr.l	d1		Clear work register
	move	curacc,d1	Get this acc number
	move.l	d1,d0		Save in d0
	mulu.w	#9,d1		Multiply by 9 to get pointer to filename
	add.l	#array,d1	Add start of file array
	move.l	d1,a5		Save in a5 for next routine
	move.l	#change,a4	Start of change array in a4
	bchg	#0,0(a4,d0)	Toggle this flag
	move.l	#choice,a3	Start of choice array
	bchg	#0,0(a3,d0)	Toggle this one too
	bne	selreg		It was selected before, skip ahead
	cmp.w	#6,selnum	Already got 6 accessories selected?
	bne	not6ac		No, skip
	bchg	#0,0(a4,d0)	Toggle both of the flags back
	bchg	#0,0(a3,d0)
	move	#7,-(sp)	One day soon, you'll hear that little
	move	#2,-(sp)	bell ring
	trap	#gemdos
	addq.l	#4,sp
	rts
not6ac:	addq.w	#1,selnum	Increment number of selected accessories
	move.l	#invmsg,a0	Print it in inverse
	bra	sel1
selreg:	subq.w	#1,selnum	Decrement count of selected accs
	move.l	#regmsg,a0	Print in normal text
sel1:	bsr	print_string	Print the VT52 inverse/normal codes
	move.b	nampos+2,namp2+2 Move current position into string
	move.b	nampos+3,namp2+3
	addq.b	#1,namp2+3
	move.l	#namp2,a0	Print the VT52 position codes
	bsr	print_string
	move.l	a5,a0		Now print this name
	bsr	print_string
	move.l	#regmsg,a0	Turn off inverse
	bra	print_string

setpos:	clr.l	d5		Clear work register
	move	curacc,d5	Get current acc
	divu	#8,d5		Divide by 8 (8 accs per line)
	move.b	d5,nampos+2	Set X position
	add.b	#32,nampos+2	VT52 expects you to add 32 to this
	swap	d5		Get remainder to lower word
	and.l	#$FFFF,d5	Mask off high byte
	mulu	#10,d5		Multiply by 10 (10 chars per name)
	move.b	d5,nampos+3	Set Y position
	add.b	#32,nampos+3
	rts

prtptr:	move.l	#nampos,a0	Set cursor position
	bsr	print_string

	cmp.l	#eraptr,a5	Are we drawing or erasing the pointer
	bne	prtp2		Drawing, skip ahead
	move.l	a5,a0		Erase it
	bra	print_string
prtp2:	move	#3,-(sp)	Print the right arrow with BIOS bconout
	move	#5,-(sp)
	move	#3,-(sp)
	trap	#bios
	addq.l	#6,sp
	move.l	a5,a0		Move the cursor past the name with a
	bsr	print_string	VT52 escape sequence
	move	#4,-(sp)	Print the left arrow with bconout
	move	#5,-(sp)
	move	#3,-(sp)
	trap	#bios
	addq.l	#6,sp
	rts

* Bubble sort routine

sort:	clr.l	d0
	move	accnum,d0
	mulu	#9,d0
	move.l	d0,end
	sub.l	#9,d0
	move.l	d0,mend
	move.l	#array,a0
	move.l	#0,d0
	move.l	#9,d1
	move.l	#choice,a3
	clr.l	d3
	move.l	#1,d4
sort1:	lea	0(a0,d0),a1
	lea	0(a0,d1),a2
sort2:	cmp.b	(a1)+,(a2)+
	blt	swap
	beq	sort2
sort3:	addq.l	#1,d4
	add.l	#9,d1
	cmp.l	end,d1
	bne	sort1
	addq.l	#1,d3
	move.l	d3,d4
	addq.l	#1,d4
	add.l	#9,d0
	move.l	d0,d1
	add.l	#9,d1
	cmp.l	mend,d0
	bne	sort1
	rts
swap:	lea	0(a0,d0),a1
	lea	0(a0,d1),a2
	lea	0(a3,d3),a4
	lea	0(a3,d4),a5
	move	#8,d2
swap2:	move.b	(a1),d5
	move.b	(a2),(a1)+
	move.b	d5,(a2)+
	dbf	d2,swap2
	move.b	(a4),d5
	move.b	(a5),(a4)
	move.b	d5,(a5)
	bra	sort3

* Open a file
* Enter with: a5= address of filename
*	      d5= read/write mode

openfl:	move	d5,-(sp)
	move.l	a5,-(sp)
	move	#$3D,-(sp)
	trap	#gemdos
	addq.l	#8,sp
	tst.w	d0
	rts

* Read a file
* Enter with: a5= address of buffer
*	      d5= number of bytes to read

readfl:	move.l	a5,-(sp)
	move.l	d5,-(sp)
	move	handle,-(sp)
	move	#$3F,-(sp)
	trap	#gemdos
	add.l	#12,sp
	tst.l	d0
	rts

* Close a file

closfl:	move	handle,-(sp)
	move	#$3E,-(sp)
	trap	#gemdos
	addq.l	#4,sp
	tst.w	d0
	rts

	.data
	.even

clrhom:	dc.b	esc,'E',esc,'f',esc,'Y',workln-2+32,0+32
	dc.b	esc,'p   DESK MANAGER  '
	dc.b	$BD,' 1987 Charles F. Johnson '
	dc.b	'                                     '
	dc.b	esc,'Y',workln-2+32,47+32
dattim:	dc.b	$7C,'                     ',0,0,0,0,0,0,0,0,0,0,0,0,0,0

ammsg:	dc.b	'am'
pmmsg:	dc.b	'pm'

prompt:	dc.b	esc,'Y',workln+32,1+32,esc,'J'
	dc.b	esc,'Y',workln+32,21+32
	dc.b	'Arrow keys/Mouse: Move pointer'
	dc.b	esc,'Y',workln+1+32,19+32
	dc.b	'Return/Left Button: Select accessories'
	dc.b	esc,'Y',workln+2+32,29+32
	dc.b	'Clr Home: Clear all selections'
	dc.b	esc,'Y',workln+3+32,21+32
	dc.b	'Esc/Right Button: Exit',0

nodams:	dc.b	esc,'Y',workln+32,0+32,esc,'J',esc,'Y',workln+1+32,17+32
	dc.b	'Which drive holds the accessories (',esc,'pA',esc,'q'
	dc.b	' or ',esc,'pC',esc,'q)?',0

clrbot:	dc.b	esc,'Y',workln+32,1+32,esc,'J',0

renmsg:	dc.b	esc,'Y',workln+32,0+32,esc,'J',esc,'Y',workln+1+32,27+32
	dc.b	'Renaming accessories...',0

nampos:	dc.b	esc,'Y',0,0,0
pointr:	dc.b	esc,'C',esc,'C',esc,'C',esc,'C'
	dc.b	esc,'C',esc,'C',esc,'C',esc,'C',0
eraptr:	dc.b	' ',esc,'C',esc,'C',esc,'C',esc,'C'
	dc.b	esc,'C',esc,'C',esc,'C',esc,'C',' ',0

namp2:	dc.b	esc,'Y',0,0,0
invmsg:	dc.b	esc,'p',0
regmsg:	dc.b	esc,'q',0

lastms:	dc.b	esc,'Y',workln+32,0+32,esc,'J',esc,'Y',workln+1+32,25+32
	dc.b	'Continuing boot process...',10,13,10,13,0

dskmgr:	dc.b	'\AUTO\DESKMGR.PRG',0

noacc:	dc.b	esc,'Y',workln+32,0+32,esc,'J',esc,'Y',workln+1+32,26+32
	dc.b	'No accessories on drive '
adrv:	dc.b	'X...',0

snam:	dc.b	'X:\*.AC?',0

accnm1:	dc.b	'X:\'
acc1:	dc.b	'            ',0
accnam:	dc.b	'X:\'
acc2:	dc.b	'            ',0

acx:	dc.b	'.ACX'
acc:	dc.b	'.ACC'

months:	dc.b	'Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec '

keybrd:	dc.b	$0A,22,18
mousey:	dc.b	$08

	.bss
	.even

filnam:	ds.l	1
namadr:	ds.l	1
chptr:	ds.l	1
end:	ds.l	1
mend:	ds.l	1
keysav:	ds.l	1

keyflg:	ds.w	1
done:	ds.w	1
altflg:	ds.w	1
accnum:	ds.w	1
curacc:	ds.w	1
selnum:	ds.w	1
res:	ds.w	1
handle:	ds.w	1
xpos:	ds.b	1
ypos:	ds.b	1
dta:	ds.b	44

array	ds.b	max_acc*9
choice	ds.b	max_acc
change	ds.b	max_acc

        ds.l	300
nstack:
	ds.l	1
	ds.w	10
