START     BSR       SETDRVA
          TST.W     D0        ;DID ERROR OCCUR?
          BMI       EXIT      ;IF SO TAKE BRANCH

CHDIR     PEA       PATH      ;ADDRESS OF PATH NAME
          MOVE.W    #$3B,-(SP);CHANGE DIRECTORY
          TRAP      #1        ;GEMDOS
          ADDQ.L    #6,SP     ;POP STACK
          TST.W     D0        ;DID ERROR OCCUR?
          BNE       EXIT      ;IF SO TAKE BRANCH

GETDTA    PEA       DTA       ;ADDRESS OF DTA BUFFER
          MOVE.W    #$1A,-(SP);SET DISK TRANSFER ADDRESS
          TRAP      #1        ;GEMDOS
          ADDQ.L    #6,SP     ;POP STACK

SFIRST    MOVE.W    #0,-(SP)  ;NORMAL (R/W) FILE
          PEA       FILENAME  ;ADDRESS OF FILENAME
          MOVE.W    #$4E,-(SP);SEARCH FOR FIRST FILE
          TRAP      #1        ;GEMDOS
          ADDQ.L    #8,SP     ;POP STACK
          TST.W     D0        ;DID ERROR OCCUR?
          BNE       EXIT      ;IF SO TAKE BRANCH

          BRA.S     OPEN

LOOP      BSR       SETDRVA

SNEXT     MOVE.W    #$4F,-(SP);SEARCH FOR NEXT FILE
          TRAP      #1        ;GEMDOS
          ADDQ.L    #2,SP     ;POP STACK
          TST.W     D0        ;DID ERROR OCCUR?
          BNE       EXIT      ;IF SO, TAKE BRANCH

OPEN      MOVE.W    #0,-(SP)  ;FILE CAN BE READ ONLY
          PEA       NAME      ;ADDR OF CURRENT FILE NAME
          MOVE.W    #$3D,-(SP);OPEN
          TRAP      #1        ;GEMDOS
          ADDQ.L    #8,SP     ;POP STACK
          MOVE.W    D0,D7     ;STORE HANDLE
          TST.W     D0        ;DID ERROR OCCUR?
          BMI.S     EXIT      ;IF SO TAKE BRANCH

READ      PEA       BUFFER    ;ADDRESS OF DATA BUFFER
          MOVE.L    SIZE,-(SP);SIZE OF CURRENT FILE
          MOVE.W    D7,-(SP)  ;HANDLE
          MOVE.W    #$3F,-(SP);READ
          TRAP      #1        ;GEMDOS
          ADD.L     #12,SP    ;POP STACK
          TST.L     D0        ;DID ERROR OCCUR?
          BMI.S     EXIT      ;IF SO TAKE BRANCH

          BSR.S     CLOSE
          TST.W     D0        ;DID ERROR OCCUR?
          BNE.S     EXIT      ;IF SO TAKE BRANCH

SETDRVD   MOVE.W    #3,-(SP)  ;DRIVE D
          MOVE.W    #$0E,-(SP);SET CURRENT DRIVE
          TRAP      #1        ;GEMDOS
          ADDQ.L    #4,SP     ;POP STACK
          TST.W     D0        ;DID ERROR OCCUR?
          BMI.S     EXIT      ;IF SO TAKE BRANCH

CREATE    MOVE.W    #0,-(SP)  ;NORMAL (R/W) FILE
          PEA       NAME      ;ADDRESS OF "*.*"
          MOVE.W    #$3C,-(SP);CREATE
          TRAP      #1        ;GEMDOS
          ADDQ.L    #8,SP     ;POP STACK
          MOVE.W    D0,D7     ;STORE HANDLE
          TST.W     D0        ;DID ERROR OCCUR?
          BMI.S     EXIT      ;IF SO TAKE BRANCH

WRITE     PEA       BUFFER    ;ADDRESS OF DATA BUFFER
          MOVE.L    SIZE,-(SP);SIZE OF FILE
          MOVE.W    D7,-(SP)  ;HANDLE
          MOVE.W    #$40,-(SP);WRITE
          TRAP      #1        ;GEMDOS
          ADD.L     #12,SP    ;POP STACK
          TST.L     D0        ;DID ERROR OCCUR?
          BMI.S     EXIT      ;IF SO TAKE BRANCH

          BSR.S     CLOSE
          TST.W     D0        ;DID ERROR OCCUR?
          BNE.S     EXIT      ;IF SO TAKE BRANCH
               
          BRA       LOOP      ;CONTINUE UNTIL DONE

EXIT      MOVE.W    #$0,-(SP) ;TERM
          TRAP      #1        ;GEMDOS

SETDRVA   MOVE.W    #0,-(SP)  ;DRIVE A
          MOVE.W    #$0E,-(SP);SET CURRENT DRIVE
          TRAP      #1        ;GEMDOS
          ADDQ.L    #4,SP     ;POP STACK
          RTS

CLOSE     MOVE.W    D7,-(SP)  ;HANDLE
          MOVE.W    #$3E,-(SP);CLOSE
          TRAP      #1        ;GEMDOS
          ADDQ.L    #4,SP     ;POP STACK
          RTS

          DATA
PATH      DC.B      'BOOT',0

FILENAME  DC.B      '*.*',0

          BSS
DTA       DS.W      13
SIZE      DS.W      2
NAME      DS.W      7

BUFFER    DS.W      0

          END
