program simple_to_1st_Word (simple, FirstWord);
   {Program to convert from straight ASCII to 1st Word file format}
   {by Rod Smith, December 1986; Revised March 1987}

const
   {$I GEMCONST.PAS}
   STRETCH_SPACE = 28; {1st Word's "stretch" space}
   INDENT_SPACE  = 29; {1st Word's "indent" space}
   VAR_SPACE     = 30; {1st Word's "variable" space}
   FIX_SPACE     = 32; {1st Word's "fixed" space}
   F_BOLD        = 01;
   F_ULINE       = 08;
   F_SUPSCRPT    = 16;
   F_SUBSCRPT    = 32;
   ASCII         = 1; {simple ASCII file}
   STWRITER      = 2; {STWriter file}
   WORDSTAR      = 3; {WordStar file}

type
   {$I GEMTYPE.PAS}

var
   file_simple, file_1st, def_path: string;
   simple, FirstWord:               text;
   source, status, i:               integer;
   junk:                            char;

{$I GEMSUBS.PAS}

{****************************************************************}

function CurrentDrive: integer;
   {returns the current disk drive}
GEMDOS ($19);

{****************************************************************}

function type_transfer: integer;
   {returns the type of transfer}
var dialog: Dialog_Ptr;
    title, author,
    copy1, copy2, copy3,
    prompt,
    simple, ST_Writer, WS,
    OK_btn, cancel_btn:  integer;
begin
   dialog := New_Dialog (13, 0, 0, 38, 14);
   title := Add_DItem (dialog, G_Text, None, 1, 1, 36, 1, 0, BLACK * 256);
   Set_DText (dialog, title, '1st Convert Utility', System_Font, TE_Center);
   author := Add_DItem (dialog, G_Text, None, 1, 2, 36, 1, 0, BLACK * 256);
   Set_DText (dialog, author, 'by Rod Smith', System_Font, TE_Center);
   copy1 := Add_DItem (dialog, G_Text, None, 1, 4, 36, 1, 0, BLACK * 256);
   Set_DText (dialog, copy1, 'Portions of this product are', Small_Font,
              TE_Center);
   copy2 := Add_DItem (dialog, G_Text, None, 1, 5, 36, 1, 0, BLACK * 256);
   Set_DText (dialog, copy2, 'copyright (c) 1986 OSS and CCD.', Small_Font,
              TE_Center);
   copy3 := Add_DItem (dialog, G_Text, None, 1, 6, 36, 1, 0, BLACK * 256);
   Set_DText (dialog, copy3, 'Used by permission.', Small_Font, TE_Center);
   prompt := Add_DItem (dialog, G_Text, None, 1, 8, 36, 1, 0, BLACK * 256);
   Set_DText (dialog, prompt, 'The source file is from:', System_Font,
              TE_Center);
   simple := Add_DItem (dialog, G_Button, Radio_Btn | Selectable,
                       2, 10, 10, 1, 1, BLACK * 256);
   Set_DText (dialog, simple, 'ASCII', System_Font, TE_Center);
   Obj_SetState (dialog, simple, Selected, FALSE);
   ST_Writer := Add_DItem (dialog, G_Button, Radio_Btn | Selectable,
                          14, 10, 10, 1, 1, BLACK * 256);
   Set_DText (dialog, ST_Writer, 'STWriter', System_Font, TE_Center);
   WS := Add_DItem (dialog, G_Button, Radio_Btn | Selectable,
                    26, 10, 10, 1, 1, BLACK * 256);
   Set_DText (dialog, WS, 'WordStar', System_Font, TE_Center);
   OK_btn := Add_DItem (dialog, G_Button, Selectable | Default | Exit_Btn,
                        10, 12, 8, 1, 3, BLACK * 256);
   Set_DText (dialog, OK_btn, 'OK', System_Font, TE_Center);
   cancel_btn := Add_DItem (dialog, G_Button, Selectable | Exit_Btn,
                            20, 12, 8, 1, 1, BLACK * 256);
   Set_DText (dialog, cancel_btn, 'Cancel', System_Font, TE_Center);
   Center_Dialog (dialog);
   if Do_Dialog (dialog, 0) = cancel_btn then Halt;
   if Obj_State (dialog, simple) = Selected then type_transfer := ASCII;
   if Obj_State (dialog, ST_Writer) = Selected then type_transfer := STWRITER;
   if Obj_State (dialog, WS) = Selected then type_transfer := WORDSTAR;
   End_Dialog (dialog);
   Delete_Dialog (dialog);
end; {type_transfer}

{****************************************************************}

procedure GetInfo (var file_simple, file_1st, def_path: string);
   {returns the filenames for the source and destination files}
var junk:     integer;
    sans_ext: string;
begin {GetInfo}
   file_simple := '';
   junk := Do_Alert ('[0][Filename of the source file...][ Ready ]', 1);
   if not Get_In_File (def_path, file_simple) then Halt;
   junk := pos ('.', file_simple);
   if (junk > 1)
      then sans_ext := copy (file_simple, 1, junk - 1)
      else sans_ext := file_simple;
   file_1st := concat (sans_ext, '.DOC');
   junk := Do_Alert ('[0][Filename of the 1st Word file...][ Ready ]', 1);
   if not Get_In_File (def_path, file_1st)
      then GetInfo (file_simple, file_1st, def_path);
end; {GetInfo}

{****************************************************************}

procedure HandleLine (source: integer; var status: integer);
   {procedure to do the real work of the program}
var new_char: char;
    column:   integer;
{---------------------------------------------}
function new_line (spaces: integer): integer;
begin
   if (spaces > 0)
      then writeln (FirstWord, ' ')
      else writeln (FirstWord);
   new_line := 1;
end; {new_line}
{---------------------------------------------}
procedure toggle_code (code: integer; var status: integer);
begin
   if ((status & code) = code)
      then status := status - code
      else status := status + code;
   write (FirstWord, chr(27), chr(status));
end; {toggle_code}
{---------------------------------------------}
procedure new_page;
begin
   writeln (FirstWord); {avoids formatting problems later}
   write (FirstWord, chr (12)); {new page marker}
end; {new_page}
{---------------------------------------------}
function fix_char (new_char: char): char;
var testchr: integer;
begin
   testchr := ord (new_char);
   if ((testchr > 160) and (testchr < 255)) then begin
      testchr := testchr - 128; {strip the high bit}
      new_char := chr (testchr);
   end; {if}
   fix_char := new_char;
end; {fix_char}
{---------------------------------------------}
procedure do_simple (new_char: char);
begin
   case ord (new_char) of
      FIX_SPACE: write (FirstWord, chr (VAR_SPACE));
      else:      write (FirstWord, new_char);
   end; {case}
end; {do_simple}
{---------------------------------------------}
procedure do_STWriter (new_char: char;
                       var status, column: integer);
const NUL       = 00; {code for <RETURN>}
      CENTER    = 03; {code for center line}
      EJECT     = 05; {code for page eject}
      PARAGRAPH = 16; {code for new paragraph}
      UNDERLINE = 29; {code for underlining on/off}
      SUPER     = 27; {"up-arrow"}
      SUB       = 28; {"down-arrow"}
{...........................................}
procedure next_line (column: integer);
var counter: integer;
    junk:    char;
begin
   repeat
      read (simple, junk);
   until (junk = chr (NUL));
   column := 1;
end; {next_line}
{...........................................}
procedure up_arrow (var status: integer);
begin
   if ((status & F_SUBSCRPT) = F_SUBSCRPT)
      then toggle_code (F_SUBSCRPT, status)
      else toggle_code (F_SUPSCRPT, status);
end; {up_arrow}
{...........................................}
procedure down_arrow (var status: integer);
begin
   if ((status & F_SUPSCRPT) = F_SUPSCRPT)
      then toggle_code (F_SUPSCRPT, status)
      else toggle_code (F_SUBSCRPT, status);
end; {down_arrow}
{...........................................}
procedure center_line (var column, status: integer);
var count, i: integer;
    letter:   char;
    line:     string;
begin
   letter := 'A'; {dummy constant}
   line := '';
   while (letter <> chr (NUL)) do begin
      read (simple, letter);
      line := concat (line, letter);
   end; {while}
   count := (66 - length (line)) div 2; {# spaces to pad}
   for i := 1 to count do write (FirstWord, chr (INDENT_SPACE));
   for i := 1 to length (line) do
      if line [i] = chr (UNDERLINE)
         then toggle_code (F_ULINE, status)
         else write (FirstWord, line [i]);
   writeln (FirstWord);
   column := 1;
end; {center_line}
{...........................................}
begin {do_STWriter}
   case ord (new_char) of
      FIX_SPACE: write (FirstWord, chr (VAR_SPACE));
      NUL:       column := new_line (1);
      CENTER:    center_line (column, status);
      EJECT:     new_page; {page eject}
      PARAGRAPH: write (FirstWord, '     '); {^P, new paragraph}
      UNDERLINE: toggle_code (F_ULINE, status);
      1, 2, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 17, 18, 19, 20,
      21, 22, 23, 24, 25, 26:
                 next_line (column); {control characters; ignore line}
      SUPER:     up_arrow (status); {either start sup-scripting, or end sub-}
      SUB:       down_arrow (status); { "     "   sub-    "      "   "  sup-}
      else:      write (FirstWord, new_char);
   end; {case}
end; {do_STWriter}
{---------------------------------------------}
procedure do_WordStar (new_char: char;
                       var status, column: integer);
const BOLDFACE   = 002; {^B, boldface toggle}
      DBL_STRIKE = 004; {^D, double strike toggle}
      UNDERLINE  = 019; {^S, underline toggle}
      SUPSCRPT   = 020; {^T, superscript toggle}
      SUBSCRPT   = 022; {^V, subscript toggle}
      DOT        = 046; {'.', for 'dot commands'}
      GARBAGE    = 138; {don't know what it is, but appears after new page}
      MET_RET    = 141; {WordStar's <RETURN>}
      MET_SPACE  = 160; {WordStar's "stretch" space}
{.........................................}
procedure check_dot (column: integer);
var code: string [2]; {'cause codes are 2 chars. in length after '.'}
begin
   if (column <> 1)
      then write (FirstWord, '.')
      else begin
         readln (simple, code);
         if ((code = 'PA') or (code = 'pa'))
            then new_page; {page break}
      end; {else}
end; {check_dot}
{.........................................}
begin
   case ord (new_char) of
      FIX_SPACE:  write (FirstWord, chr (VAR_SPACE));
      MET_SPACE:  write (FirstWord, chr (STRETCH_SPACE));
      MET_RET:    column := new_line (0); {w/in paragraph newline}
      UNDERLINE:  toggle_code (F_ULINE, status);
      BOLDFACE,
      DBL_STRIKE: toggle_code (F_BOLD, status);
      SUPSCRPT:   toggle_code (F_SUPSCRPT, status);
      SUBSCRPT:   toggle_code (F_SUBSCRPT, status);
      DOT:        check_dot (column); {check to see if it's a 'dot command'}
      GARBAGE:    ; {null statement; ignore character}
      else:       write (FirstWord, new_char);
   end; {case}
end; {do_WordStar}
{---------------------------------------------}
procedure past75 (var status, column: integer);
   {goes until next space, then starts a new line}
   {always returns a '1'}
var next_char: char;
begin
   next_char := 'A'; {dummy constant}
   repeat
      read (simple, next_char);
      next_char := fix_char (next_char);
      if (next_char <> ' ') then case source of
         ASCII:    do_simple (next_char);
         STWRITER: do_STWriter (next_char, status, column);
         WORDSTAR: do_WordStar (next_char, status, column);
         end; {case; if}
   until ((eoln (simple)) or (next_char = ' '));
   write (FirstWord, chr (VAR_SPACE)); {makes next line part of same para.}
   if (not eoln (simple)) then writeln (FirstWord); {start a new line}
   column := 1;
end; {past75}
{---------------------------------------------}
begin {HandleLine}
   column := 1;
   new_char := 'A'; {dummy value}
   while not eoln (simple) do begin
      read (simple, new_char);
      new_char := fix_char (new_char);
      case source of
         ASCII:    do_simple (new_char); {simple file}
         STWRITER: do_STWriter (new_char, status, column); {STWriter file}
         WORDSTAR: do_WordStar (new_char, status, column); {WordStar file}
      end; {case}
      column := column + 1;
      if column > 75 then past75 (status, column);
   end; {while}
   readln (simple); {start the next line}
   if ((column = 1) or (source <> ASCII) or eoln (simple))
      then writeln (FirstWord)
      else writeln (FirstWord, chr (VAR_SPACE));
end; {HandleLine}

{****************************************************************}
{****************************************************************}

begin {simple_to_1st_Word}
   if Init_GEM >= 0 then begin
      Set_Mouse (M_ARROW);
      def_path := Concat ((chr (CurrentDrive + ord ('A'))), ':\*.*');
      repeat
         status := 128;
         source := type_transfer; {what type of original file?}
         GetInfo (file_simple, file_1st, def_path);
         Set_Mouse (M_BEE);
         reset (simple, file_simple);
         rewrite (FirstWord, file_1st);
         if (source = STWRITER)
            then for i := 1 to 34 do read (simple, junk); {dispose of junk}
         while not eof (simple) do
            HandleLine (source, status);
         Set_Mouse (M_ARROW);
      until (Do_Alert ('[2][Convert another file?][ Yes | No ]',1) = 2);
      Exit_GEM;
   end; {if Init_GEM...}
end. {simple_to_1st_Word}
