*******************************************************************************
*                                                                             *
*  ART GALLERY                                                                *
*                                                                             *
*  A GEM program/desk accessory by Charles F. Johnson                         *
*                                                                             *
*  Copyright 1987 Little Green Footballs Software                             *
*                                                                             *
*******************************************************************************

* -----------------------------------
*  Last revision: 05/18/87  19:35:20
* -----------------------------------

* Object type equates

G_BOX		=	20
G_TEXT		=	21
G_BOXTEXT	=	22
G_IMAGE		=	23
G_PROGDEF	=	24
G_IBOX		=	25
G_BUTTON	=	26
G_BOXCHAR	=	27
G_STRING	=	28
G_FTEXT		=	29
G_FBOXTEXT	=	30
G_ICON		=	31
G_TITLE		=	32

* Object flag equates

NONE		=	$00
SELECTABLE	=	$01
DEFAULT		=	$02
EXIT		=	$04
EDITABLE	=	$08
RBUTTON		=	$10
LASTOB		=	$20
TOUCHEXIT	=	$40
HIDETREE	=	$80
INDIRECT	=	$0100

* Object status	equates

NORMAL		=	$00
SELECTED	=	$01
CROSSED		=	$02
CHECKED		=	$04
DISABLED	=	$08
OUTLINED	=	$10
SHADOWED	=	$20

* Object index equates

degbt	=	7
neobt	=	8
tinybt	=	9
exitbt	=	10

	.text

	move.l	sp,a5		Save old stack pointer
	move.l	#ustack,sp	Install my stack

	clr.w	accflg		Clear the accessory/program flag (paranoia)

	move.l	#s_read,aespb	AES shel_read function returns filename of
	move.l	#buff1,addrin	program in buff1
	move.l	#buff2,addrin+4
	bsr	aes

	move.l	#buff1,a0	Address of filename
	move	#8,d0
chknam:	cmp.b	#".",(a0)+	Search for the period before the extension
	beq	chkn1		Got it
	dbf	d0,chknam
chkn1:	move.l	#acctxt,a1	We're going to compare it to "ACC"
	move	#2,d0
chkn2:	cmp.b	(a0)+,(a1)+	Is it "ACC"?
	bne	contin		No, skip ahead
	dbf	d0,chkn2
	move	#1,accflg	Set the flag to indicate accessory

contin:	tst	accflg		Accessory or program?
	bne	ap_init		Acc, skip ahead

	move.l	4(a5),a5	GEMDOS Mshrink call to release memory
	move.l	$c(a5),d0	back to the system
	add.l	$14(a5),d0
	add.l	$1c(a5),d0
	add.l	#$100,d0
	move.l	d0,-(sp)
	move.l	a5,-(sp)
	clr.w	-(sp)
	move	#$4a,-(sp)
	trap	#1
	add.l	#12,sp
	bra	getres		Skip ahead

ap_init:
	clr.l	ap1rsv		appl_init
	clr.l	ap2rsv
	clr.l	ap3rsv
	clr.l	ap4rsv
	move.l	#a_init,aespb
	bsr	aes

	move.l	#m_reg,aespb	menu_register
	move.w	intout,intin
	move.l	#accmsg,addrin
	bsr	aes
	move.w	intout,menuid

getres:	move.w	#4,-(sp)	Get current resolution
	trap	#14
	addq.l	#2,sp
	move.w	d0,res

	move.w	#$19,-(sp)	Get current drive
	trap	#1
	addq.l	#2,sp
	add.b	#65,d0		Convert to ASCII
	move.l	#degdir,a3
	move.l	#neodir,a4
	move.l	#tnydir,a5
	move.b	d0,(a3)+	Store in directory areas
	move.b	d0,(a4)+
	move.b	d0,(a5)+

	move.l	#degext,a0
	move.l	#neoext,a1
	move.l	#tnyext,a2
	move.w	#7,d5
cpydir:	move.b	(a0)+,(a3)+	Copy the default paths into the
	move.b	(a1)+,(a4)+	directory areas
	move.b	(a2)+,(a5)+
	dbf	d5,cpydir

	cmp.w	#2,res		High res?
	bne	quest		No, skip
	move.b	#'3',degdir+7	Set DEGAS directory to "PI3"
	move.w	#DISABLED,neostt Disable "NEO" button
	bra	search		Skip
quest:	move.b	#'?',degdir+7

search:	move.l	#$A000,a5	This section searches for the fsel_input
s_1:	move.l	#itmtxt,a4	text "ITEM SELECTOR", then searches
	move.l	#12,d5		backwards for the pointer to this text
s_2:	move.b	(a5),d0		in the fsel object tree. New string
	cmp.b	(a4),d0		addresses can be poked into this location.
	beq	s_3
	addq.l	#1,a5
	bra	s_2
s_3:	move.l	a5,a0
s_4:	cmp.b	(a5)+,(a4)+
	bne	s_1
	dbf	d5,s_4
	cmp.b	#"F",-1(a0)
	bne	s_1

	move.l	a0,d0
	move.l	a0,iasav
	move.l	a0,d1
	and.l	#$FFFFFFFE,d1
	move.l	d1,a0
s_5:	subq.l	#2,a0
	move.l	(a0),d1
	cmp.l	d1,d0
	bne	s_5
	move.l	a0,itmadr

	move.w	8(a0),ilensv	Save original string length

fixem:	move.l	#r_obfx,aespb	Convert the object coordinates from
	move.l	#picbox,addrin	character offsets to pixel offsets
	move.w	#objnum,d5
fxpic:	move.w	d5,intin
	bsr	aes
	dbf	d5,fxpic

	tst	accflg		Are we an accessory?
	beq	savcol

evntms:	move.l	#e_mesg,aespb	evnt_mesag (All we want is an AC_OPEN)
	move.l	#mspipe,addrin	Pass address of message pipe
	bsr	aes

	cmp.w	#40,mspipe	Is this an AC_OPEN message?
	bne	evntms		No, go back
	move.w	mspipe+8,d0	Is it for this accessory?
	cmp.w	menuid,d0
	bne	evntms		No, go back

	move.l	#w_updt,aespb	Call wind_update to block user actions
	move.w	#1,intin
	bsr	aes

	move.w	#$19,-(sp)	Get current drive
	trap	#1
	addq.l	#2,sp
	move.w	d0,curdrv	Save it

	move.w	#0,-(sp)	Get current pathname
	move.l	#curpth,-(sp)
	move.w	#$47,-(sp)
	trap	#1
	addq.l	#8,sp

savcol:	clr.w	d5		Save the colors so we can put 'em
	move.w	#15,d4		back when we're done
	move.l	#colsav,a5
collp:	move.w	#-1,-(sp)
	move.w	d5,-(sp)
	move.w	#7,-(sp)
	trap	#14
	addq.l	#6,sp
	move.w	d0,(a5)+
	addq.l	#1,d5
	dbf	d4,collp

	move.w	#2,-(sp)	Get screen address
	trap	#14
	addq.l	#2,sp
	move.l	d0,screen

	tst	accflg
	bne	do_win
	bsr	arrow
	bra	drawit

do_win:	move.l	#w_get,aespb	Create a window the size of the desktop
	move.l	#intin,a5	work area
	clr.w	(a5)
	move.w	#4,2(a5)
	bsr	aes
	move.w	intout+2,wx	The desktop work area coordinates
	move.w	intout+4,wy
	move.w	intout+6,ww
	move.w	intout+8,wh
	move.l	#w_crea,aespb	Create it!
	clr.w	(a5)
	move.w	wx,2(a5)
	move.w	wy,4(a5)
	move.w	ww,6(a5)
	move.w	wh,8(a5)
	bsr	aes
	tst.w	intout		Error? (Probably too many windows open)
	bmi	ex3		Yes, bail out
	move.w	intout,whandl
	move.l	#w_open,aespb	Now let's actually open the window. Whew.
	move.w	whandl,(a5)
	move.w	wx,2(a5)
	move.w	wy,4(a5)
	move.w	ww,6(a5)
	move.w	wh,8(a5)
	bsr	aes

	cmp.w	#2,res		High res?
	bne	scr1		No, skip
	move.w	#379,d5		Number of longwords to save
	bra	scr2
scr1:	move.w	#439,d5
scr2:	move.l	screen,a4	Save the menu bar
	move.l	#scrbuf,a5
scr3:	move.l	(a4)+,(a5)+
	dbf	d5,scr3

drawit:	bsr	mouscl		Clear screen

	bsr	drawbx		Draw the dialog box

	clr.l	d0
	move.w	selobj,d0
	mulu	#24,d0
	add.l	#picbox,d0
	move.l	d0,a0
	clr.w	10(a0)		Reset the selected object

	cmp.w	#exitbt,selobj	Exit?
	beq	ex2

	bsr	mouscl		Clear the screen again

	cmp.w	#degbt,selobj	DEGAS picture?
	bne	ckpic1
	move.l	#degdir,diradr	Set directory area
	move.l	#dfile,filadr	Set filename area
	move.l	#i_deg,txtadr	Set text address
	move.w	#id_len,itmlen	And text length
	bra	fsel
ckpic1:	cmp.w	#neobt,selobj	Neochrome picture?
	bne	ckpic2
	move.l	#neodir,diradr
	move.l	#nfile,filadr
	move.l	#i_neo,txtadr
	move.w	#in_len,itmlen
	bra	fsel
ckpic2:	move.l	#tnydir,diradr	If it isn't a Tiny picture here, we're in
	move.l	#tfile,filadr	big trouble
	move.l	#i_tny,txtadr
	move.w	#it_len,itmlen

fsel:	move.l	itmadr,a0	Change the "ITEM SELECTOR" text to something
	move.l	txtadr,(a0)	a bit more meaningful
	move.w	itmlen,8(a0)
	or.w	#1,-2(a0)

	bsr	mouscl		Clear the screen again!

	move.l	#f_sel,aespb	Let's call fsel_input with opcode 90
	move.l	diradr,addrin
	move.l	filadr,addrin+4
	bsr	aes

	bsr	mouscl		And yet again

	move.l	itmadr,a0	Restore the fsel text line
	move.l	iasav,(a0)
	and.w	#$FE,-2(a0)
	move.w	ilensv,8(a0)

ckfil:	move.l	filadr,a0
	tst.b	(a0)		Is there a filename here?
	beq	drawit		No, go draw the dialog box again
	cmp.w	#1,intout+2	OK button?
	bne	drawit		Nope!

	clr.w	d0		Set current drive from output of
	move.l	diradr,a0	fsel routine
	move.b	(a0),d0
	sub.b	#65,d0
	move.w	d0,-(sp)
	move.w	#$0E,-(sp)
	trap	#1
	addq.l	#4,sp
	move.l	diradr,a0
	addq.l	#2,a0		Also set pathname from fsel
	move.l	#pathnm,a1
	move.l	#63,d5
pathlp:	tst.b	(a0)
	beq	plx1
	move.b	(a0)+,(a1)+
	dbf	d5,pathlp
plx1:	move.l	#63,d5
plp2:	cmp.b	#"\",-(a1)
	beq	plx2
	dbf	d5,plp2
plx2:	addq.l	#1,a1
	clr.b	(a1)
	pea	pathnm
	move.w	#$3B,-(sp)
	trap	#1
	addq.l	#6,sp

	clr.w	-(sp)		How about if we open the chosen file?
	move.l	filadr,-(sp)
	move.w	#$3D,-(sp)
	trap	#1
	addq.l	#8,sp
	tst.w	d0		Error?
	bmi	drawit		File not found!
	move.w	d0,handle	Save file handle

goshow:	dc.w	$A00A		Hide mouse
	bsr	clears		Clear screen
	clr.w	rotflg		Clear rotation flag

	cmp.w	#degbt,selobj	Was it DEGAS?
	bne	gosh1		No, skip
	bsr	degas		Show it already!
	bra	exit		And bail
gosh1:	cmp.w	#neobt,selobj	Neochrome?
	bne	gosh2		No
	bsr	neo		Show Neo
	bra	exit
gosh2:	bsr	do_tiny		The only thing left

exit:	dc.w	$A009		Show mouse
	bra	fsel		Do it again

ex2:	tst	accflg
	beq	pro_ex

	cmp.w	#2,res		Restore the menu bar
	bne	scrx1
	move.w	#379,d5
	bra	scrx2
scrx1:	move.w	#439,d5
scrx2:	move.l	screen,a4
	move.l	#scrbuf,a5
scrx3:	move.l	(a5)+,(a4)+
	dbf	d5,scrx3

	move.l	#w_clos,aespb	Close window so the application gets a
	move.w	whandl,intin	redraw message
	bsr	aes
	move.l	#w_del,aespb
	bsr	aes
ex3:	move.w	curdrv,-(sp)	Reset current drive and pathname
	move.w	#$0E,-(sp)
	trap	#1
	addq.l	#4,sp
	move.l	#curpth,-(sp)
	move.w	#$3B,-(sp)
	trap	#1
	addq.l	#6,sp

	move.l	#w_updt,aespb	Allow user actions again
	clr.w	intin
	bsr	aes

	bra	evntms		Go back and wait for another message!

pro_ex:	clr.w	-(sp)		The program version exits here
	trap	#1

* Subroutines

* DEGAS pictures

degas:
	move.l	#picrez,a5	Get resolution
	move.l	#2,d5		Word
	bsr	readfl

	move.w	picrez,d0	Check possible resolution values
	move.l	#d_legal,a5
	move.w	#5,d5
cklegl:	cmp.w	(a5)+,d0
	beq	dres0		It's a real DE picture
	dbf	d5,cklegl
	bra	bad1		If we get here, this ain't no DE picture!

dres0:	cmp.w	#2,res		Are we in high res?
	bne	dres1		No, skip
	cmp.b	#2,picrez+1	Is the picture in high res?
	beq	deg1		Yes, everythang's cool
	bra	resend		No, let's end this charade
dres1:	cmp.b	#2,picrez+1	Is the pic in high res and we're not?
	beq	resend		Bail out!

deg1:	bsr	getcol		Get color palette from file

deg2:	bsr	rescol		Go set colors and resolution

	btst	#7,picrez	Compressed picture (high bit set)?
	beq	not_cm		No, skip

	move.l	#ctlbuf,a5	Read picture data and animation tables
	move.l	#36000,d5
	bsr	readfl

	move.l	#ctlbuf,a5	Pointer to picture data
	move.l	screen,a4	Pointer to screen

	tst.b	picrez+1	Low res?
	bne	ckmed
	move.l	#3,d5		d5 = nplanes (# of color planes)
	move.l	#199,d4		d4 = scanlines (# of scan lines)
	move.l	#160,d3		d3 = nbytes (# of bytes per line)
	move.l	#6,d2		d2 = offset (Offset to next word in plane)
	bra	deg_d1
ckmed:	cmp.b	#1,picrez+1	Medium res?
	bne	ckhigh
	move.l	#1,d5
	move.l	#199,d4
	move.l	#160,d3
	move.l	#2,d2
	bra	deg_d1
ckhigh:	move.l	#0,d5		Gotta be high res here or something's
	move.l	#399,d4		seriously wrong
	move.l	#80,d3
	move.l	#0,d2

deg_d1:	move.w	d5,nplane	Save number of color planes

deg_decomp:
	clr.l	d1		d1 = sc_ix (scan line index)
dd_2:	clr.l	d0
	move.b	(a5)+,d0	Get a control byte
	bmi	d_repeat
dd_3:	move.l	a4,a3		Screen pointer
	add.l	d1,a3		Add index
	move.b	(a5)+,(a3)	Move byte to screen
	addq.l	#1,d1		Increment index
	btst	#0,d1		Index even?
	bne	dd_4		No, skip
	add.l	d2,d1		Increment to next word in this plane
dd_4:	dbf	d0,dd_3
	bra	scanend

d_repeat:
	neg.b	d0		Complement the count value
	move.b	(a5)+,d6	Get data byte to d6
dd_5:	move.l	a4,a3		Pointer to screen memory
	add.l	d1,a3		Add index
	move.b	d6,(a3)		Store byte to screen
	addq.l	#1,d1		Increment index
	btst	#0,d1		Index even (done a word)?
	bne	dd_6		No, skip
	add.l	d2,d1		Set to next word in the plane
dd_6:	dbf	d0,dd_5		Do the rest

scanend:
	cmp.l	d3,d1		Index less than number of bytes per line?
	blt	dd_2		Yes, branch back
	sub.l	d3,d1		Subtract # of bytes, then add 2 to
	add.l	#2,d1		point to beginning of next plane
	dbf	d5,dd_2		Count planes
	move.w	nplane,d5	Reset plane counter
	add.l	d3,a4		Increment screen pointer to next scan line
	dbf	d4,deg_decomp	Count scan lines

	move.l	#ltbl,a4	a5 should now be pointing to the animation
	move.w	#31,d5		tables (right after the picture data)
cpyani:	move.b	(a5)+,(a4)+	Copy animation tables to the proper area
	dbf	d5,cpyani

	bra	adjchn		And skip ahead

not_cm:	move.l	screen,a5	Read picture data to screen memory
	move.l	#32000,d5
	bsr	readfl

	move.l	#ltbl,a5	Try to read 32 more bytes
	move.l	#33,d5		(Rotation data for DEGAS Elite file)
	bsr	readfl
	cmp.l	#32,d0		Did we read 32?
	bne	degw		No, not a DE file

adjchn:	move.l	#deltbl,a5	Adjust the channel delays
	move.w	#3,d5
deg3:	move.w	#129,d0
	sub.w	(a5),d0
	move.w	d0,(a5)+
	dbf	d5,deg3

	move.l	#ltbl,a5	Now let's check the animation data to
	move.l	#rtbl,a4	make sure we don't have garbage
	move.l	#dirtbl,a3
	move.w	#3,d5
ck_ani:	move.w	(a4)+,d0	Get right color limit
	bmi	anioff		If less than zero, turn it off
	cmp.w	#15,d0		Greater than 15?
	bgt	anioff		Turn it off
	move.w	(a5)+,d1	Get left color limit
	bmi	anioff		If less than zero, turn it off
	cmp.w	#15,d1		Greater than 15?
	bgt	anioff		Off! Off!
	cmp.w	d1,d0		Is right less than/equal to left?
	ble	anioff		Yes, turn the channel off
	tst.w	(a3)		Is the direction flag less than zero?
	bmi	anioff		Yes, turn it off!
	cmp.w	#2,(a3)		Greater than 2?
	ble	ck_a1		No, skip
anioff:	move.w	#1,(a3)		Turn this channel's rotation flag off
ck_a1:	addq.l	#2,a3		Increment pointer to direction table
	dbf	d5,ck_ani	Count channels

	move.w	#2,rotflg	Set flag for DE

degw:	bsr	waiter		Wait for button press
	bra	do_rts

* Neochrome pictures

neo:	move.l	#picrez,a5	Get resolution
	move.l	#2,d5
	bsr	readfl		(Stored as a longword for some weird reason)
	bsr	readfl

nres1:	tst.w	picrez		Neochrome only works in low res
	bne	bad1		So, no way Jose

neo1:	bsr	getcol

	move.l	#datbuf,a5	Just some junk here
	move.l	#92,d5		(Rotation info, etc.)
	bsr	readfl
	tst.b	datbuf+12
	beq	deg2
	move.b	datbuf+13,cycle
	move.b	datbuf+15,cycle+1
	bsr	setrot

	bsr	rescol		Go set colors and resolution

	move.l	screen,a5	Read the picture directly to the screen
	move.l	#32000,d5
	bsr	readfl

	bra	degw

* TINY pictures

do_tiny:
	move.l	#picrez,a5	Once again, the resolution is first
	move.l	#1,d5		But this time, it's a byte
	bsr	readfl
	cmp.b	#3,picrez	Greater than 2? (Indicates rotation info)
	blt	do_t2		No, skip

	sub.b	#3,picrez	Subtract 3 for real resolution
	move.l	#cycle,a5	Read 4 bytes of rotation info
	move.l	#4,d5
	bsr	readfl
	bsr	setrot


do_t2:	move.b	picrez,picrez+1	Let's make this byte value into a word
	clr.b	picrez
	cmp.w	#2,res		Make sure our resolutions match
	bne	ckres1
	cmp.w	#2,picrez
	beq	do_col
resend:	move.l	#wrong,a5
goalrt:	dc.w	$A009
	move.w	#1,d5
	bsr	alert
	dc.w	$A00A
	bra	do_rts
ckres1:	cmp.w	#2,picrez
	beq	resend

do_col:	bsr	getcol

	move.l	#ctlcnt,a5	Get the number of control bytes
	move.l	#2,d5		Word value
	bsr	readfl
	move.l	#datcnt,a5	Get the number of data words
	move.l	#2,d5		Word value
	bsr	readfl

	cmp	#10667,ctlcnt	Make sure the file's OK
	bhi	bad1
	cmp	#16000,datcnt
	bls	do_t3

bad1:	move.l	#badfil,a5	This file stinks!
	bra	goalrt

do_t3:	move.l	#ctlbuf,a5	Read in the control bytes
	clr.l	d5
	move.w	ctlcnt,d5
	bsr	readfl
	move.l	d0,actctl	Save number of bytes actually read

	lsl	datcnt		Multiply by 2 to get number of data bytes
	move.l	#datbuf,a5	Read in the data words
	clr.l	d5
	move.w	datcnt,d5
	bsr	readfl
	move.l	d0,actdat	Save number actually read

	clr.l	d5
	move.w	ctlcnt,d5	Did we read as many bytes as we were
	cmp.l	actctl,d5	supposed to?
	bne	bad1		No, what a screwed-up file this is!
	move.w	datcnt,d5
	cmp.l	actdat,d5
	bne	bad1

	bsr	decompress	Go decompress it
	bsr	waiter		Wait for the button

do_rts:	move.w	handle,-(sp)	Close the file and return
	move.w	#$3E,-(sp)
	trap	#1
	addq.l	#4,sp

yahoo:	rts

* The Tiny decompression routine

decompress:
	bsr	rescol

	clr.l	d0		d0 = index into screen memory
	move.l	screen,a0	a0 -> start of screen memory

	move.w	ctlcnt,d1	Get number of control bytes
	subq.w	#1,d1		Subtract one for dbf

	move.l	#ctlbuf,a1	a1 -> control buffer
	move.l	#datbuf,a2	a2 -> data buffer
decom1:	clr.w	d3		Make sure the high byte is clean
	move.b	(a1)+,d3	Get a byte of control data
	tst.b	d3		Is it less than zero?
	bpl	decom2		No, skip
	neg.b	d3		Complement it (My, you look nice!)
	bsr	unique		This is the count of unique data
	bra	next		next?

decom2:	tst.b	d3		Is it zero?
	beq	decom3		Yes, skip ahead
	cmp.b	#1,d3		Is it one?
	bne	decom4		No, skip over

decom3:	move.b	(a1)+,d4	If it's zero or one, the next two bytes
	lsl.w	#8,d4		are the count
	move.b	(a1)+,d4
	subq.w	#2,d1		Adjust the counter
	exg	d4,d3		Exchange 'em
	tst.b	d4		Was the control byte zero?
	bne	dc3_1		No, skip
	bsr	repeat		Zero means repeating data
	bra	next
dc3_1:	bsr	unique		One means unique data
	bra	next

decom4:	bsr	repeat		If we get here, d3 is a simple repeat count

next:	dbf	d1,decom1	Count down and loop
	rts

unique:	subq.w	#1,d3		Adjust count for dbf
u1:	move.w	(a2)+,d5	Read unique words from data area
	bsr	toscreen	and put 'em on screen
	dbf	d3,u1		Count down and loop
	rts			Done

repeat:	subq.w	#1,d3		Adjust count
	move.w	(a2)+,d5	Get the repeating data word
rpt1:	bsr	toscreen	And put it on screen
	dbf	d3,rpt1		Count down and loop
	rts

toscreen:
	move.w	d0,d4		Get index offset
	lsl	d4		Multiply by 2 (we're dealing with words here!)
	move.w	d5,0(a0,d4)	Put the data on screen
	add.w	#80,d0		Increment the index
	cmp	#15999,d0	At bottom of this column?
	ble	to_rts		No, skip
	sub	#15996,d0	Set index back to top +1 line
	cmp	#79,d0		At end of row?
	ble	to_rts		No, skip
	sub	#79,d0		Back to start of next row
to_rts:	rts

rescol:	pea	setres		Gotta do this in supervisor mode
	move.w	#38,-(sp)	XBIOS Supexec
	trap	#14
	addq.l	#6,sp
resc2:	move.w	colors,d0
	move.l	#blank,a1
	move.w	#15,d1
resc3:	move.w	d0,(a1)+
	dbf	d1,resc3
	pea	blank		Now set the blank color palette
	move.w	#6,-(sp)
	trap	#14
	addq.l	#6,sp
	move.w	#37,-(sp)	Wait for vertical blank so colors will
	trap	#14		change right away
	addq.l	#2,sp
	rts

real_col:
	pea	colors
	move.w	#6,-(sp)
	trap	#14
	addq.l	#6,sp
	rts

setrot:	clr.l	d0		Clear these registers
	clr.l	d1
	move.b	cycle,d0	Get start and end colors (low/high nibble)
	lsr.b	#4,d0		Start color
	move.l	d0,strtco	Save it
	move.b	cycle,d1
	and.b	#$0F,d1		End color
	move.l	d1,endcol	Save it
	sub.b	d0,d1		Are they the same?
	beq	rot2		Yes, exit without setting rotflg

	move.w	d1,numcol	Set number of colors to rotate
	clr.w	dirflg		Clear direction flag
	tst.b	cycle+1		Positive?
	bpl	rot1		Yes, skip
	neg.b	cycle+1		Complement it
	move.w	#-1,dirflg	Set direction flag to negative
rot1:	move.w	#1,rotflg	Set rotation flag
	bra	rot3
rot2:	clr.w	rotflg
rot3:	rts

waiter:	tst.w	rotflg		Wanna rotate?
	beq	wait1		No, skip ahead

	pea	setvbi		Go to super mode to execute VBI
	move.w	#38,-(sp)	set-up
	trap	#14
	addq.l	#6,sp
	tst.w	d0		Did we find an open VBI vector?
	bpl	wait1		Yes, skip
	clr.w	rotflg		Clear rotation flag

wait1:	bsr	real_col	Turn on the picture

	move.l	#e_mult,aespb	Let's wait for a left button click or a
	move.l	#intin,a5	keypress
	move.w	#%000011,(a5)
	move.w	#1,2(a5)
	move.w	#1,4(a5)
	move.w	#1,6(a5)
	bsr	aes
	btst	#1,intout+1
	beq	colbak
	clr.w	6(a5)		Oh yes, let's wait for the release too
	bsr	aes

colbak:	tst.w	rotflg		Were we rotating?
	beq	wait2		No, skip
	pea	resvbi		Reset the VBI vector in super mode
	move.w	#38,-(sp)
	trap	#14
	addq.l	#6,sp

wait2:	pea	colsav		Restore colors
	move.w	#6,-(sp)
	trap	#14
	addq.l	#6,sp
	pea	resres		Do this in supervisor mode
	move.w	#38,-(sp)
	trap	#14
	addq.l	#6,sp
	rts

* Vertical blank stuff

setvbi:	move.l	$456,a0		Get pointer to vbi queue
	move.w	#7,d0		8 routines allowed
setv1:	tst.l	(a0)		Got a zero?
	beq	setv2		Yes, go set our routine
	addq.l	#4,a0		Increment pointer
	dbf	d0,setv1	Count down and loop
	rts			Return - d0=negative if no free vector
setv2:	clr.w	vbicnt		Clear the timer
	clr.l	timtbl		And the DE timer table
	clr.l	timtbl+4
	move.l	#vblank,(a0)	Install our vertical blank routine
	move.l	a0,vbiptr	Save pointer to make replacing it easier
	rts

resvbi:	move.l	vbiptr,a0	Remove our vertical blank routine
	move.l	#0,(a0)		from the queue
	rts

vblank:	cmp.w	#2,rotflg
	beq	degvb

	addq.b	#1,vbicnt	Increment the timer
	move.b	vbicnt,d0	Get delay value
	cmp.b	cycle+1,d0	Time to do a rotation?
	bne	vbexit		No, skip ahead
	clr.b	vbicnt		Clear the timer again
	tst.w	dirflg		Which direction?
	bpl	vbplus		Positive, skip ahead		
	move.l	strtco,d0	Get starting color
	bra	vb1
vbplus:	move.l	endcol,d0
vb1:	lsl	d0		Multiply by 2
	add.l	#$FF8240,d0	Add start of hardware color registers
	move.l	d0,a0		Move address over
	move.w	(a0),temp	Save first color value
	move.w	numcol,d1	Get number of colors to rotate
	subq.w	#1,d1		Subtract 1 for dbf count
	tst.w	dirflg
	bpl	vb4
vb2:	move.w	2(a0),(a0)+	Rotate 'em!
	dbf	d1,vb2		Count down
vb3:	move.w	temp,(a0)
vbexit:	rts			Return from vertical blank interrupt
vb4:	move.w	-2(a0),(a0)	Rotate 'em the other way!
	subq.l	#2,a0
	dbf	d1,vb4		Count colors
	bra	vb3

degvb:	move.l	#3,d5
degvb2:	move.l	d5,d4		Get index
	add.l	d4,d4		Double it
	move.l	d4,a5		Move to address register
	add.l	#dirtbl,a5	Pointer to direction table
	cmp.w	#1,(a5)		If 1, this channel is turned off
	beq	dnext

	move.l	d4,a4
	add.l	#timtbl,a4	Pointer to channel timer
	addq.w	#1,(a4)		Increment it
	move.w	(a4),d0		Let's see what it is
	cmp.w	-8(a4),d0	Equal to delay value?
	bne	dnext		No, go to next channel
	clr.w	(a4)		Clear it and proceed

	move.l	d4,a4
	add.l	#rtbl,a4	Pointer to end color table
	move.w	(a4),d0		Get the end color
	sub.w	-8(a4),d0	Subtract start color from it
	move.w	d0,numcol	This is the number to rotate

	clr.l	d0
	tst.w	(a5)		Test direction table
	bne	degvb3		Not left, skip
	move.w	#-1,dirflg	Set direction flag
	move.w	-8(a4),d0	Get color register number
	bra	degvb4
degvb3:	clr.w	dirflg
	move.w	(a4),d0
degvb4:	bsr	vb1		Go do the rotation

dnext:	dbf	d5,degvb2	Count down 4 rotation channels
	rts

resres:	move.b	res+1,$FF8260	Reset resolution by changing hardware register
	rts

setres:	move.b	picrez+1,$FF8260 Change the resolution
	rts

getcol:	move.l	#colors,a5	Get the color palette
	move.l	#32,d5

* Read a file
* Enter with: a5= address of buffer
*	      d5= number of bytes to read

readfl:	move.l	a5,-(sp)
	move.l	d5,-(sp)
	move.w	handle,-(sp)
	move.w	#$3F,-(sp)
	trap	#1
	add.l	#12,sp
	tst.l	d0
	rts

mouscl:	dc.w	$A00A		Hide mouse
	bsr	clears		Clear screen
showms:	dc.w	$A009		Show mouse
	rts

clears:	move.l	screen,a5
	move.l	#7999,d5
clrlp:	clr.l	(a5)+
	dbf	d5,clrlp
	rts

arrow:	move.l	#g_mous,aespb	This is only needed if we assemble this
	clr.w	intin		as a .PRG
	bra	aes

* Dialog box drawing routine
* Draws the main dialog box (picbox)
*
* a5 is clobbered on exit

drawbx:	move.l	#f_cntr,aespb	First, let's call form_center
	move.l	#picbox,addrin
	bsr	aes

	move.w	intout+2,cx
	move.w	intout+4,cy
	move.l	#picbox,a0	Let's move the box up a bit from its
	sub.w	#4,cy		supposedly centered coordinates...without
	sub.w	#4,18(a0)	a menu bar it looks too low on the screen.
	cmp.w	#2,res
	bne	db2
	sub.w	#4,cy
	sub.w	#4,18(a0)
db2:	move.w	intout+6,cw
	addq.w	#4,cw
	move.w	intout+8,ch
	addq.w	#4,ch

	move.l	#f_dial,aespb	Form_dial
	move.l	#intin,a5
	clr.w	(a5)		Reserve screen space
	clr.l	2(a5)		No growing/shrinking boxes, so just
	clr.l	6(a5)		zero out the start coordinates
	move.w	cx,10(a5)
	move.w	cy,12(a5)
	move.w	cw,14(a5)
	move.w	ch,16(a5)
	bsr	aes

	move.l	#o_cdrw,aespb	Objc_draw
	clr.w	(a5)		Root object gets drawn first
	move.w	#5,2(a5)	Up to 5 levels of subordinate objects
	move.w	cx,4(a5)
	move.w	cy,6(a5)
	move.w	cw,8(a5)
	move.w	ch,10(a5)
	bsr	aes

	move.l	#f_do,aespb	Call form_do to get user input
	clr.w	(a5)		No editable text field
	bsr	aes		Do it!
	move.w	intout,selobj	Save selected object
	rts

* form_alert
* Enter with a5= address of definition string
*	     d5= number of default box

alert:	move.l	a5,addrin	Set address of string
	move.w	d5,intin	Set default box
	move.l	#f_alrt,aespb	Display alert box

aes:	move.l	#aespb,d1	The subroutine that calls the AES
	move.l	#$c8,d0
	trap	#2
	rts

	.data
	.even

aespb:	dc.l	contrl,global,intin,intout,addrin,addrout

* TEDINFO structures

tinf0:	dc.l	stlog,dummy,dummy
	dc.w	5,6,2,$1000,0,-1,16,1
tinf1:	dc.l	title,dummy,dummy
	dc.w	3,6,0,$1000,0,-1,12,1
tinf2:	dc.l	author,dummy,dummy
	dc.w	5,6,2,$1000,0,-1,22,1

* Object tree for main dialog box

picbox:	dc.w	-1,1,1,G_BOX,NONE,SHADOWED
	dc.l	$21132
	dc.w	0,0,39,14

	dc.w	0,2,10,G_BOX,NONE,NORMAL
	dc.l	$FF1100
	dc.w	2,1,35,12

	dc.w	6,3,5,G_BOX,NONE,NORMAL
	dc.l	$FF1171
	dc.w	0,0,35,3

	dc.w	4,-1,-1,G_TEXT,NONE,NORMAL
	dc.l	tinf0
	dc.w	10,0,15,1

	dc.w	5,-1,-1,G_TEXT,NONE,NORMAL
	dc.l	tinf1
	dc.w	12,1,11,1

	dc.w	2,-1,-1,G_TEXT,NONE,NORMAL
	dc.l	tinf2
	dc.w	7,2,21,1

	dc.w	7,-1,-1,G_STRING,NONE,NORMAL
	dc.l	which
	dc.w	6,4,22,1

	dc.w	8,-1,-1,G_BUTTON,$5,NORMAL
	dc.l	degms
	dc.w	2,6,9,2

	dc.w	9,-1,-1,G_BUTTON,$5
neostt:	dc.w	NORMAL
	dc.l	neoms
	dc.w	13,6,9,2

	dc.w	10,-1,-1,G_BUTTON,$5,NORMAL
	dc.l	tnyms
	dc.w	24,6,9,2

	dc.w	1,-1,-1,G_BUTTON,$27,NORMAL
	dc.l	exitms
	dc.w	13,9,9,2

pbadr:	dc.l	picbox

objnum	=	(pbadr-picbox)/24-1

* Text for dialog objects

stlog:	dc.b	'ST-Log Presents',0
title:	dc.b	'ART GALLERY',0
author:	dc.b	'by Charles F. Johnson'
dummy:	dc.b	0
which:	dc.b	'Which type of picture?',0
degms:	dc.b	'DEGAS',0
neoms:	dc.b	'NEO',0
tnyms:	dc.b	'TINY',0
exitms:	dc.b	'EXIT',0

	.even

	ds.w	1
	dc.l	itmtxt		* Dummy pointer (safety factor for fsel search)

itmtxt:	dc.b	'ITEM SELECTOR',0

accmsg:	dc.b	'  Art Gallery',0

badfil:	dc.b	'[3][This file has an incorrect |format!| ][ Sorry! ]'

wrong:	dc.b	"[3][This picture's in the wrong |resolution!| ][ Sorry! ]"

i_deg:	dc.b	' Which DEGAS picture? '
id_dum:	dc.b	0
id_len	=	(id_dum-i_deg)*8

i_neo:	dc.b	' Which NEOCHROME picture? '
in_dum:	dc.b	0
in_len	=	(in_dum-i_neo)*8

i_tny:	dc.b	' Which TINY picture? '
it_dum:	dc.b	0
it_len	=	(it_dum-i_tny)*8

degext:	dc.b	':\*.P??',0
neoext:	dc.b	':\*.NEO',0
tnyext:	dc.b	':\*.TNY',0

acctxt:	dc.b	'ACC'

	.even

a_init:	dc.w	10,0,1,0,0
e_mesg:	dc.w	23,0,1,1,0
e_mult:	dc.w	25,16,7,1,0
m_reg:	dc.w	35,1,1,1,0
o_cdrw:	dc.w	42,6,1,1,0
f_do:	dc.w	50,1,2,1,0
f_dial:	dc.w	51,9,1,1,0
f_alrt:	dc.w	52,1,1,1,0
f_cntr:	dc.w	54,0,5,1,0
g_mous:	dc.w	78,1,1,1,0
f_sel:	dc.w	90,0,2,2,0
w_crea:	dc.w	100,5,1,0,0
w_open:	dc.w	101,5,5,0,0
w_clos:	dc.w	102,1,1,0,0
w_del:	dc.w	103,1,1,0,0
w_get:	dc.w	104,2,5,0,0
w_updt:	dc.w	107,1,1,0,0
r_obfx:	dc.w	114,1,1,1,0
s_read:	dc.w	120,0,1,2,0

d_legal:
	dc.w	$8000,$8001,$8002,$0000,$0001,$0002

	.bss
	.even

screen:	ds.l	1
itmadr:	ds.l	1
iasav:	ds.l	1
txtadr:	ds.l	1
diradr:	ds.l	1
filadr:	ds.l	1
vbiptr:	ds.l	1
strtco:	ds.l	1
endcol:	ds.l	1

accflg:	ds.w	1
rotflg:	ds.w	1
dirflg:	ds.w	1
vbicnt:	ds.w	1
numcol:	ds.w	1
temp:	ds.w	1
itmlen:	ds.w	1
ilensv:	ds.w	1
curdrv:	ds.w	1
handle:	ds.w	1
res:	ds.w	1
menuid:	ds.w	1
whandl:	ds.w	1
wx:	ds.w	1
wy:	ds.w	1
ww:	ds.w	1
wh:	ds.w	1
selobj:	ds.w	1
cx:	ds.w	1
cy:	ds.w	1
cw:	ds.w	1
ch:	ds.w	1

nplane:	ds.w	1
picrez:	ds.w	1
cycle:	ds.l	1
colors:	ds.w	16
blank:	ds.w	16
ctlcnt:	ds.w	1
datcnt:	ds.w	1
actctl:	ds.l	1
actdat:	ds.l	1

contrl:	ds.w	12
intin:	ds.w	128
intout:	ds.w	128
global:
apvrsn:	ds.w	1
apcont:	ds.w	1
apid:	ds.w	1
apprvt:	ds.l	1
apptre:	ds.l	1
ap1rsv:	ds.l	1
ap2rsv:	ds.l	1
ap3rsv:	ds.l	1
ap4rsv:	ds.l	1
addrin:	ds.w	128
addrout:ds.w	128

colsav:	ds.w	16

ltbl:	ds.w	4
rtbl:	ds.w	4
dirtbl:	ds.w	4
deltbl:	ds.w	4
timtbl:	ds.w	4

mspipe:	ds.b	16

dfile:	ds.b	16
nfile:	ds.b	16
tfile:	ds.b	16

degdir:	ds.b	64
neodir:	ds.b	64
tnydir:	ds.b	64

pathnm:	ds.b	64

curpth:	ds.b	64

scrbuf:	ds.b	1760

ctlbuf:	ds.b	10680
datbuf:	ds.w	16000

buff1:	=	datbuf
buff2:	=	datbuf+256

	ds.l	300
ustack:	ds.l	1
	ds.w	10

	.end
