
******************************************************************
*
* A Text-Enciphering Program: Part 1
*
*   by Douglas Weir  Copyright (c) 1987 ST-Log
*
******************************************************************

        text

        move.l          #sign_on,-(a7)          sign on message
        move.w          #9,-(a7)                code=print string
        trap            #1                      do it
        addq.l          #6,a7                   pop args

        move.l          #c_string,-(a7)         string space address
        bsr             encipher                encipher a string
        addq.l          #4,a7                   pop arg

        move.l          #p_string,-(a7)         print string address
        move.w          #9,-(a7)                code=print string
        trap            #1                      do it
        move.w          #0,-(a7)                code=exit program
        trap            #1                      do it

encipher:
        link            a6,#0                   frame pointer
        movem.l         d0-d4/a0-a5,-(a7)       save registers
        
        movea.l         8(a6),a4                point to string space
        movea.l         #ciphers,a3             point to cipher table
        movea.l         #incs,a5                point to increments
        clr.l           d2                      reset inc index
        move.w          #I_PHASE,d3             reset phase counter
        move.w          #S_SIZE,d4              absolute counter
        move.b          #CR,last_ch             initialize last char
e_loop:
        move.w          #1,-(a7)                code=conin
        trap            #1                      do it
        addq.l          #2,a7                   pop arg
        cmpi.b          #CR,d0                  carriage return?
        beq             e_end                   if so
        cmpi.b          #TAB,d0                 tab?
        bne.b           e_nxt00                 if not
        move.b          #SPACE,d0               else insert space
        move.b          d0,last_ch              last char too
        bra.b           e_raw                   and write it

e_nxt00:
        cmpi.b          #BS,d0                  backspace?
        bne.b           e_nxt0                  if not
        move.b          last_ch,d0              else get last char
        move.w          d0,-(a7)                push it
        move.w          #2,-(a7)                code=conout
        trap            #1                      do it
        addq.l          #4,a7                   pop args
        bra.b           e_loop                  and start over
e_nxt0:
        move.b          d0,last_ch              save raw char
        cmpi.b          #A,d0                   lower than 'A'?
        bcs.b           e_raw                   if so, just write it
        cmpi.b          #Z1,d0                  else: upper case?
        bcc.b           e_nxt1                  if not
        addi.w          #U_CONV,d0              else convert to lower case
        bra.b           e_nxt2                  and continue
e_nxt1:
        cmpi.w          #a,d0                   non-alphabetic?
        bcs.b           e_raw                   if so, write it
        cmpi.w          #z1,d0                  else: lower case?
        bcc.b           e_raw                   if not, write it as is

e_nxt2:
        subi.w          #C_CONV,d0              else make it an index
        move.b          0(a5,d2.w),d1           get current increment
        add.w           d1,d0                   add it to index
        cmpi.w          #C_MAX,d0               over maximum?
        bcs.b           e_nxt3                  if not
        subi.w          #C_MAX,d0               else correct it

e_nxt3:
        move.b          0(a3,d0.w),d0           get enciphered code
e_raw:  move.b          d0,(a4)+                write it
        subq.w          #1,d3                   decrement phase counter
        bne.b           e_test                  if phase not exhausted
        move.w          #I_PHASE,d3             else restart counter
        addq.l          #1,d2                   and increment index
        cmpi.w          #I_COUNT,d2             over maximum?
        bcs.b           e_test                  if not
        subi.w          #I_COUNT,d2             else wrap around

e_test:
        dbra            d4,e_loop               go till end

e_end:  
        move.b          #LF,(a4)+               append line feed
        move.b          #CR,(a4)+               and carriage return
        move.b          #0,(a4)                 and null

        movem.l         (a7)+,d0-d4/a0-a5       restore registers
        unlk            a6                      deallocate frame
        rts                                     and return

        data

sign_on         dc.b    'encipher...',10,13,0
last_ch         ds.b    1               holds last char typed

p_string        dc.b    10,13           line feed, carriage return
c_string        ds.b    100             space for enciphered string
S_SIZE          equ     *-c_string      length of string

ciphers         dc.b    'abcdefghijklmnopqrstuvwxyz'
C_MAX           equ     *-ciphers       length of table
C_CONV          equ     97              'a' - 97 = 0
U_CONV          equ     32              'A' + 32 = 'a'

incs            dc.b    10,5,2,7,9,1    ciphering increments
I_COUNT         equ     *-incs          size of table
I_PHASE         equ     3               3 chars enciphered per inc

A               equ     65              ASCII 'A'
Z1              equ     91              ASCII 'Z' + 1
a               equ     97              ASCII 'a'
z1              equ     123             ASCII 'z' + 1

CR              equ     13              carriage return
LF              equ     10              line feed
TAB             equ     9               tab
BS              equ     8               backspace
SPACE           equ     32              space

                 

