PROGRAM Decimal_Destroyer;

{**************************************
 ****      DECIMAL DESTROYER       ****
 ****   Written by Kevin Kennedy   ****
 ****           using              ****
 ****      Personal Pascal         ****
 ****            by                ****
 ****          O.S.S.              ****
 **************************************}

 CONST
  {$I GEMCONST.PAS}

 TYPE
  converted = STRING [5];
  {$I GEMTYPE.PAS}

 VAR
  level,ml,dia : INTEGER;
  range : REAL;

 {$I GEMSUBS.PAS}

{**** O.S. FUNCTION CALLS ****}

 FUNCTION physbase : LONG_INTEGER;
  XBIOS(2);

 PROCEDURE setscreen(a,b : LONG_INTEGER ; c : INTEGER);
  XBIOS(5);

 FUNCTION sound_chip(data,register : INTEGER) : INTEGER;
  XBIOS(28);

 FUNCTION random : LONG_INTEGER;
  XBIOS(17);

{**** SOUND PROCEDURE ****}

 PROCEDURE sound(tone : LONG_INTEGER ; volume,register,noise:INTEGER);
  VAR
   dummy,msb,lsb,enable,toneh,tonel,sel,ensve : INTEGER;
  BEGIN
   ensve := sound_chip(ensve,7);
   toneh := INT(tone DIV 256);
   tonel := INT(tone MOD 256);
   lsb := ensve & 64;
   msb := ensve & 128;
   CASE register OF
    0 : sel := 62 ;
    3 : sel := 55 ;
   END;
   enable := lsb+msb+sel;
   dummy := sound_chip(enable,7+128);
   dummy := sound_chip(volume,8+128);
   IF register<3 THEN
    BEGIN
     dummy := sound_chip(tonel,0+register+128);
     dummy := sound_chip(toneh,1+register+128);
    END
   ELSE
    dummy := sound_chip(noise,6+128);
  END;

{**** MISC. FUNCTIONS & PROCEDURES ****}

 PROCEDURE conv(in1 : REAL ; VAR out : converted) ;
  VAR
   cnv : INTEGER;
  BEGIN
   FOR cnv := 1 TO 4 DO
    BEGIN
     out[cnv] := Chr(Trunc(in1)+48);
     in1 := (in1-Trunc(in1)) * 10;
    END;
  END;


 FUNCTION establish_difficulty(level : INTEGER) : INTEGER;
  VAR
   temp : INTEGER;
  BEGIN
   CASE
    level OF
     1:range := 1;
     2,3:range := (INT(random &    3) +   1) * 0.5;
     4,5:range := (INT(random &    7) +   1) * 0.25;
     6,7:range := (INT(random & 1023) + 500) * 0.001;
    END;
   CASE
    level OF
     2,4,6 : establish_difficulty := 2;
     1,3,5,7 : establish_difficulty := 4;
    END;
  END;


 PROCEDURE show_tally(number,hits : INTEGER);
  VAR
   dialog1,dialog2,dialog3 : STRING;
   dialog4 : STR255;
   p : REAL;
   x : INTEGER;

  BEGIN
   dialog1 := '[1][       GAME OVER|Out of __ you destroyed __.|';
   p := hits / number * 100;
   dialog2 := '       TRY AGAIN';
   IF p > 89 THEN dialog2 := '       EXCELLENT';
   IF (p > 79) AND (p < 90) THEN dialog2 := '        VERY GOOD';
   IF (p > 59) AND (p < 80) THEN dialog2 := '          FINE';
   IF (p > 40) AND (p < 60) THEN dialog2 := '          SO-SO';
   x := number DIV 10;
   dialog1[29] := CHR(number DIV 10 + 48);
   dialog1[30] := CHR(number MOD 10 + 48);
   dialog1[46] := CHR(hits DIV 10 + 48);
   dialog1[47] := CHR(hits MOD 10 + 48);
   dialog3 := '][ OK ]';
   dialog4 := CONCAT(dialog1,dialog2,dialog3);
   dia := Do_Alert(dialog4,1);
  END;

{**** ANIMATION PROCEDURES ****}

 PROCEDURE clip;
  BEGIN
   Set_Clip(60,1,209,148);
  END;

 PROCEDURE unclip;
  BEGIN
   Set_Clip(0,0,639,200);
  END;


 PROCEDURE draw_rocket(x,y : INTEGER);
  BEGIN
   clip;
   Line_Color(2);
   Line(x+2,y+2,x+4,y);
   Line_To(x+6,y+2);
   Line(x,y+11,x+1,y+10);
   Line(x+7,y+10,x+8,y+11);
   Line_Color(0);
   Line(x,y+16,x+2,y+14);
   Line_To(x+6,y+14);
   Line_To(x+8,y+16);
   unclip;
  END;


 PROCEDURE draw_asteroid(x,y : INTEGER);
  BEGIN
   clip;
   Line_Color(6);
   Line(x,y+10,x+2,y+12);
   Line_To(x+3,y+11);
   Line_To(x+5,y+13);
   Line_To(x+7,y+11);
   Line_To(x+8,y+12);
   Line_To(x+10,y+10);
   Plot(x,y+4);
   Plot(x,y+7);
   Plot(x+11,y+8);
   Line_Color(0);
   Plot(x,y+9);
   Plot(x,y+5);
   Line(x,y+3,x+1,y+2);
   Line_To(x+2,y+2);
   Line_To(x+4,y);
   Line_To(x+6,y+2);
   Line_To(x+7,y+2);
   Line_To(x+8,y+1);
   Line_To(x+9,y+1);
   Line_To(x+11,y+3);
   unclip;
  END;

{**** Graphics procedures ****}

 PROCEDURE colors;
  BEGIN
   Set_Color(0,0,0,1000);
   Set_Color(1,0,0,0);
   Set_Color(2,1000,0,0);
   Set_Color(3,1000,0,0);
   Set_Color(6,0,1000,1000)
  END;

 PROCEDURE draw_screen;
  VAR
   out,r : converted;
   cpy : INTEGER;
  BEGIN
   unclip;
   colors;
   Clear_Screen;
   Line_Color(1);
   Paint_Color(3);
   Frame_Round_Rect(49,0,230,150);
   Line(64,140,64,148);
   Line(164,145,164,148);
   Line(264,140,264,148);
   Text_Color(2);
   Draw_String(160,160,'Misses Left:');
   r := '';
   r := Chr(ml+48);
   Draw_String(272,160,r);
   Draw_String(40,140,'0');
   r := '';
   conv(range,r);
   Draw_String(340,140,r);
   out := '_.___';
   out[1] := r[1];
   FOR cpy := 2 TO 4 DO
    out[cpy+1] := r[cpy];
   Draw_String(279,140,out);
   Draw_String(30,160,'Level:');
   Draw_String(78,160,CHR(level+48));
  END;

 PROCEDURE rumble;
  VAR
   lloop : INTEGER;
   pb : LONG_INTEGER;
  BEGIN
   pb := physbase;
   FOR lloop := 1 TO 1000 DO
    BEGIN
     IF Odd(lloop)
       THEN setscreen(-1,pb-1280,-1)
       ELSE setscreen(-1,pb,-1);
     sound(0,15-lloop DIV 57,3,lloop);
    END;
   sound(0,0,3,0);
   setscreen(-1,pb,-1);
  END;


 FUNCTION input(rng : REAL) : REAL ;
  LABEL 2,3;
  VAR
   gb : DIALOG_PTR;
   ln1,ln2,du1,conv,te : INTEGER;
   tx1 : STR255;
   input2 : REAL;
  BEGIN
   gb := New_Dialog(3,2,21,35,4);
   ln1 := Add_DItem(gb,G_Text,0,0,1,33,1,0,401);
   Set_DText(gb,ln1,'Enter a number within the ranges',3,TE_Center);
   ln2 := Add_DItem(gb,G_FText,15,14,2,5,1,0,401);
   Set_DEdit(gb,ln2,'_.___','9999','',3,TE_Center);
   2 : du1 := Do_Dialog(gb,ln2);
   Get_DEdit(gb,ln2,tx1);
   FOR conv := 1 TO 4 DO
    BEGIN
     te := Ord(tx1[conv])-48;
     IF (te<0) OR (te>9) THEN tx1[conv] := '0';
    END;
   input2 := 0;
   input2 := (Ord(tx1[1])-48)+((Ord(tx1[2])-48)* 0.1)+((Ord(tx1[3])-48)* 0.01)+
             ((Ord(tx1[4])-48)* 0.001);
   input := input2;
   IF (input2 >-0.999) AND (input2 < rng+0.001) THEN GOTO 3;
   dia := Do_Alert('[1][ Number is|out of range][ OK ]',1);
   GOTO 2;
   3 : End_Dialog(gb);Delete_Dialog(gb);
   Paint_Color(0);
   Paint_Rect(0,165,319,35);
  END;

 PROCEDURE explode(xpos,ypos : INTEGER);
  VAR
   radius,r,g,b : INTEGER;
  PROCEDURE oval;
   BEGIN
    r := Int(random & 1000);
    g := Int(random & 1000);
    b := Int(random & 1000);
    Frame_Oval(xpos,ypos,radius,radius);
    Set_Color(1,r,g,b);
    sound(0,10,3,Int(random & 31));
   END;
  BEGIN
   clip;
   Line_Color(1);
   FOR radius := 0 TO 30 DO
    BEGIN
     oval;
    END;
   Line_Color(0);
   FOR radius := 30 DOWNTO 0 DO
    BEGIN
     oval;
    END;
   sound(0,0,3,0);
   unclip;
   draw_screen;
  END;

 PROCEDURE move_asteroid(xpos,ypos,ydest : INTEGER);
  VAR
   ay : INTEGER;
  BEGIN
   FOR ay := ypos TO ydest DO
    BEGIN
     draw_asteroid(xpos,ay);
     sound(ay,10,0,0);
    END;
   sound(0,0,0,0);
  END;

 PROCEDURE launch(xpos,ydest : INTEGER);
  VAR
   ay : INTEGER;
  BEGIN
   FOR ay := 160 DOWNTO ydest DO
    BEGIN
     draw_rocket(xpos,ay);
     sound(0,10,3,ay DIV 5*Ord(ay>0));
    END;
   sound(0,0,3,0);
  END;

{*******************************************************************}
{***********************    main game    ***************************}
{*******************************************************************}

 PROCEDURE do_game(active : INTEGER ; VAR h : INTEGER);
  VAR
   asteroid_ary : ARRAY [1..4,1..3] OF INTEGER;
   drop,gme,shoot,ax,hit : INTEGER;
   num : REAL;

  PROCEDURE setpars(asteroid : INTEGER);
   BEGIN
   asteroid_ary[asteroid,1] := 1;
   asteroid_ary[asteroid,2] := Round(Int(random & 255) * 0.784)+61;
   asteroid_ary[asteroid,3] := -10;
  END;

  PROCEDURE smash(asteroid : INTEGER);
   VAR
    move,astx,asty: INTEGER;
    alert_txt : str255;
    alert2 : converted;
    astnum : REAL;
   BEGIN
    astx := asteroid_ary[asteroid,2];
    asty := asteroid_ary[asteroid,3];
     move_asteroid(astx,asty,143);
    rumble;
    astnum := (astx-61)*range/200;
    alert_txt :=
    '[1][You missed. You|should have tried|around _.___][ RETURN ]';
    conv(astnum,alert2);
    alert_txt[46] := alert2[1];
    FOR move := 2 TO 4 DO
     alert_txt[46 + move] := alert2[move];
    dia := Do_Alert(alert_txt,1);
    asteroid_ary[asteroid,1] := 0;
   END;

  PROCEDURE clear_ary;
   VAR
    er,er2 : INTEGER;
   BEGIN
    FOR er := 1 TO 4 DO
      FOR er2 := 1 TO 3 DO asteroid_ary[er,er2] := 0;
    drop := 0;
   END;

  PROCEDURE ads(asteroid : INTEGER);
   BEGIN
    asteroid_ary[asteroid,3] := asteroid_ary[asteroid,3] + 37;
    move_asteroid(asteroid_ary[asteroid,2],asteroid_ary[asteroid,3]-37,
    asteroid_ary[asteroid,3]);
   END;

  PROCEDURE advance;
   VAR
    asteroid : INTEGER;
   BEGIN
    FOR asteroid := 1 TO 4 DO
     IF asteroid_ary[asteroid,1] <> 0 THEN ads(asteroid);
   END;

  FUNCTION check_hit(msx : INTEGER) : INTEGER;
   VAR
    asteroid,hit,asx : INTEGER;
   BEGIN
    hit := 0;
    FOR asteroid := 1 TO 4 DO
     BEGIN
      asx := asteroid_ary[asteroid,2];
      IF (asteroid_ary[asteroid,1] <> 0) AND (msx+4 < asx+12)
      AND (msx+4 > asx) AND (hit = 0) THEN
       hit := asteroid;
     END;
    check_hit := hit;
   END;

  PROCEDURE blowup(asteroid,msx : INTEGER);
   BEGIN
    hit := hit + 1;
    launch(msx,asteroid_ary[asteroid,3]+6);
    explode(asteroid_ary[asteroid,2]+6,asteroid_ary[asteroid,3]+6 );
    asteroid_ary[asteroid,1]:= 0;
   END;

  PROCEDURE miss(msx : INTEGER);
   BEGIN
    launch(msx,-20);
   END;

  FUNCTION check_miss : INTEGER;
   VAR
    asteroid,astmp : INTEGER;
   BEGIN
    FOR asteroid := 1 TO 4 DO
     BEGIN
      IF (asteroid_ary[asteroid,1] <> 0)
      AND (asteroid_ary[asteroid,3] > 130) THEN
       check_miss := 1;
     END;
   END;

  FUNCTION ground_hit : INTEGER;
   VAR
    asteroid,hit : INTEGER;
   BEGIN
    hit := 0;
    asteroid := 0;
    WHILE (hit = 0) AND (asteroid < 4) DO
     BEGIN
      asteroid := asteroid + 1;
      IF (asteroid_ary[asteroid,3] > 100)
      AND (asteroid_ary[asteroid,1] <>0) THEN hit := asteroid;
     END;
    ground_hit := hit;
   END;




  FUNCTION ast_left : INTEGER;
   VAR
    asteroid,lft : INTEGER;
   BEGIN
    lft := 0;
    FOR asteroid := 1 TO 4 DO
     BEGIN
      IF asteroid_ary[asteroid,1] <> 0 THEN
       lft := lft + 1;
     END;
    ast_left := lft;
   END;


  BEGIN
   clear_ary;
   hit := 0;
   draw_screen;
   LOOP
    drop := drop + 1;
    IF drop < active + 1 THEN
     setpars(drop);
    advance;
    EXIT IF (ast_left < 1) OR (ml < 1) ;
    num := input(range);
    ax := Round(num*200/range)+60;
    shoot := check_hit(ax);
    IF shoot <> 0
     THEN
      blowup(shoot,ax)
     ELSE
      miss(ax);
    IF ground_hit <> 0 THEN
     BEGIN
      smash(ground_hit);
      ml := ml -1;
     END;
    draw_screen;
   END;
   h := hit;
  END;



 PROCEDURE main; {main control loop}
  VAR
   hit : BOOLEAN;
   hits,astnum,totalh,totasts : INTEGER;
  BEGIN
   totalh := 0;
   totasts := 0;
   draw_screen;
   ml := 5;
   dia := Do_Alert(
   '[2][What level do you|want to start on?|   1=easy][ 1 | 2 | 4 ]',1);
   level := TRUNC(dia * 1.49);
   LOOP
    astnum := establish_difficulty(level);
    do_game(astnum,hits);
    totasts := totasts + astnum;
    totalh := totalh + hits;
    EXIT IF (ml < 1) OR (level > 6);
    level := level + 1;
   END;
   show_tally(totasts,totalh);
  END;



 BEGIN
  IF Init_Gem >= 0 THEN
   BEGIN
    dia := Do_Alert(
   '[1][Decimal Destroyer by|Kevin Kennedy using|Personal Pascal by OSS][ OK ]'
    ,1);
    Hide_Mouse;
    Clear_Screen;
    draw_screen;
    REPEAT
     main;
     dia := Do_Alert('[2][Do you want to play again?][ YES | NO ]',1);
    UNTIL dia = 2;
    Set_Color(1,1000,1000,1000);
    Set_Color(0,0,0,0);
     Set_Color(3,0,0,700);
    Show_Mouse;
    Exit_Gem ;
   END
 END.

