* =================
*  ST Font Printer
* =================
*
* by Charles F. Johnson
*
* Print text files, labels, and type lines using either the ST medium-res
* font, Atari 8-bit fonts, or DEGAS fonts.
*
* For Epson- or IBM-compatible printers.
*
* Last revision: 11/12/87  19:12:00


* Equates

* Object equates from RCS .H file

tdesk	=	3	Desk menu heading
mtitle	=	10	Object in TREE #0
mquit	=	19	Object in TREE #0
mlodde	=	21	Object in TREE #0
mlod8b	=	22	Object in TREE #0
mprint	=	29	Object in TREE #0
copyrt	=	9	Object in TREE #1
extyes	=	3	Object in TREE #3
extno	=	4	Object in TREE #3
errbox	=	3	Object in TREE #4
pfnam	=	2	Object in TREE #5
pecont	=	5	Object in TREE #6
typlin	=	30	Object in TREE #0
pline	=	2	Object in TREE #7
plokbt	=	3	Object in TREE #7
plcnbt	=	4	Object in TREE #7
ep10bt	=	4	Object in TREE #8
sgibbt	=	5	Object in TREE #8
ook	=	23	Object in TREE #2
ocancl	=	29	Object in TREE #2
mshowf	=	27	Object in TREE #0
bignam	=	3	Object in TREE #9
madrlb	=	31	Object in TREE #0
line2	=	5	Object in TREE #10
line3	=	6	Object in TREE #10
line4	=	7	Object in TREE #10
line1	=	4	Object in TREE #10
labnum	=	9	Object in TREE #10
adupbt	=	11	Object in TREE #10
addnbt	=	10	Object in TREE #10
omargn	=	26	Object in TREE #2
upbt	=	25	Object in TREE #2
dnbt	=	27	Object in TREE #2
image1	=	3	Object in TREE #1
image2	=	4	Object in TREE #1
drivea	=	1	Object in TREE #11
mopt	=	33	Object in TREE #0
msettp	=	34	Object in TREE #0
msetdr	=	36	Object in TREE #0
typok	=	6	Object in TREE #8
biglod	=	5	Object in TREE #9
bigabt	=	6	Object in TREE #9
mwdeg	=	24	Object in TREE #0
mw8bt	=	25	Object in TREE #0
extbt	=	13	Object in TREE #10
prtbt	=	14	Object in TREE #10
nfound	=	2	Object in TREE #12
writok	=	4	Object in TREE #12
writcn	=	5	Object in TREE #12
pfnums	=	4	Object in TREE #5
tonmbt	=	2	Object in TREE #13
todtbt	=	3	Object in TREE #13
totmbt	=	4	Object in TREE #13
tookbt	=	5	Object in TREE #13
tontbt	=	6	Object in TREE #13
osmall	=	4	Object in TREE #2
olarge	=	5	Object in TREE #2
opfyes	=	8	Object in TREE #2
opfno	=	9	Object in TREE #2
orsno	=	12	Object in TREE #2
orsyes	=	13	Object in TREE #2
osysbt	=	15	Object in TREE #2
ousrbt	=	16	Object in TREE #2
ninbt	=	20	Object in TREE #2
eigbt	=	21	Object in TREE #2
sixbt	=	22	Object in TREE #2

* Line-A opcodes

init_a	=	$A000	Get system addresses
textblt	=	$A008	Text block transfer
showms	=	$A009	Show mouse cursor
hidems	=	$A00A	Hide mouse cursor

fnt8x8	=	4	Offset from start of font address table
fontad	=	76	Header offset to address of font data
esc	=	27

* Equates for Line A TEXTBLT call

wmode	=	36
textfg	=	106
textbg	=	114
fbase	=	84
fwidth	=	88
sourcex	=	72
sourcey	=	74
destx	=	76
desty	=	78
delx	=	80
dely	=	82
style	=	90
litemsk	=	92
skewmsk	=	94
weight	=	96
roff	=	98
loff	=	100
scale	=	102
xdda	=	64
ddainc	=	66
scaldir	=	68
chup	=	104
mono	=	70
scrtchp	=	108
scrpt2	=	112

_nflops	=	$4A6	System variable - number of connected floppy drives

ot_sav	=	3	Extended object type - (save status word)


* Program start

	text

	move.l	a7,a5		Release memory our program doesn't need
	move.l	#ustack,a7	with MSHRINK (GEMDOS $4A)
	move.l	4(a5),a5
	move.l	$C(a5),d0
	add.l	$14(a5),d0
	add.l	$1C(a5),d0
	add.l	#$0100,d0
	move.l	d0,-(sp)
	move.l	a5,-(sp)
	clr.w	-(sp)
	move.w	#$4A,-(sp)
	trap	#1
	add.l	#12,sp

	tst.l	d0		Error releasing memory?
	beq	contn1		No, on to the next step
	bra	realx		Split

contn1:	move.w	#4,-(sp)	Check screen resolution
	trap	#14
	addq.l	#2,sp
	tst.w	d0
	bne	contn2		If not low res, continue on
	move.l	#wrong,a5	Show alert box with resolution message
	move.w	#1,d5
	bsr	alert
	bra	realx		And get outta here

contn2:	move.w	d0,res		Save resolution

	move.w	#2,-(sp)	Get address of screen RAM
	trap	#14
	addq.l	#2,sp
	move.l	d0,screen

	clr.w	d5		Save the colors so we can put 'em
	move.w	#3,d4		back when we're done
	move.l	#colsav,a5
collp:	move.w	#-1,-(sp)
	move.w	d5,-(sp)
	move.w	#7,-(sp)
	trap	#14
	addq.l	#6,sp
	move.w	d0,(a5)+
	addq.l	#1,d5
	dbf	d4,collp

	pea	palete		Now set our colors
	move.w	#6,-(sp)
	trap	#14
	addq.l	#6,sp

	clr.l	ap1rsv		appl_init
	clr.l	ap2rsv
	clr.l	ap3rsv
	clr.l	ap4rsv
	move.l	#a_init,aespb
	bsr	aes

	move.l	#g_hand,aespb	graph_handle
	bsr	aes

	move.w	#100,contrl	open_vwork
	clr.w	contrl+2
	move.w	#11,contrl+6
	move.w	intout,contrl+12 Pass handle returned from graph_handle
	move.l	#intin,a5
	move.l	#9,d5
vwrklp:	move.w	#1,(a5)+
	dbf	d5,vwrklp
	move.w	#2,(a5)
	bsr	vdi

	move.w	contrl+12,ghandl Save VDI handle

	move.l	#r_load,aespb	Load .RSC file with rsrc_load
	move.l	#rscnam,addrin
	bsr	aes
	tst.w	intout
	bne	ga1		No error, skip
	move.l	#norsc,a5	Couldn't find resource file, so let
	move.w	#1,d5		'em know
	bsr	alert
	bra	real2

ga1:	move.l	#mntree,a5	Get addresses of object trees
	clr.l	d5
	move.l	#13,d4
gadrlp:	bsr	g_addr
	move.l	addrout,(a5)+	Save address of tree
	addq.w	#1,d5
	dbf	d4,gadrlp

	move.l	mntree,a4	Save addresses of object status words for
	move.l	#mshowf,d5	"Show User Font", "Write DEGAS Font",
	bsr	obspec		and "Write 8-bit Font" in drop-down menu
	move.l	a5,showsv
	move.l	#mshowf,d5
	bsr	obstat
	move.l	a5,shstsv
	move.l	#mwdeg,d5
	bsr	obstat
	move.l	a5,mwdesv
	move.l	#mw8bt,d5
	bsr	obstat
	move.l	a5,mw8bsv

	move.l	pltree,a4
	move.l	#pline,d5
	bsr	clrlin

	move.l	lbtree,a4	Initialize the TEDINFO strings in the
	move.l	#line1,d5	label box
	bsr	clrlin
	move.l	#line2,d5
	bsr	clrlin
	move.l	#line3,d5
	bsr	clrlin
	move.l	#line4,d5
	bsr	clrlin

	move.w	#10,-(sp)	Get drive status into d0
	trap	#13		(BIOS #10 - drvmap)
	addq.l	#2,sp

	move.l	dvtree,a4	Set buttons in dialog according to
	move.l	#drivea,d4	active drives
	clr.l	d1
	move.l	#15,d3		16 possible drives
drvlp1:	move.l	d4,d5
	bsr	obstat		Get pointer to status word
	btst	d1,d0		Is this drive present?
	beq	drvlp2		No, skip
	move.w	#%100000,(a5)	Set to NORMAL and SHADOWED
	bra	drvlp3		Skip
drvlp2:	move.w	#%101000,(a5)	Set to DISABLED and SHADOWED
drvlp3:	addq.l	#1,d4
	addq.l	#1,d1
	dbf	d3,drvlp1	Do the rest of the buttons

	clr.l	-(sp)		Go to supervisor mode to check a
	move.w	#$20,-(sp)	system variable
	trap	#1
	addq.l	#6,-(sp)
	move.w	_nflops,d1	This variable holds the _actual_ number
	cmp.w	#2,d1		of connected floppies - is it 2?
	beq	got2d		Yes, skip ahead
	move.l	#drivea+1,d5
	bsr	obstat
	move.w	#%101000,(a5)	Disable the drive B: button
got2d:	move.l	d0,-(sp)	Go back to user mode
	move.w	#$20,-(sp)
	trap	#1
	addq.l	#6,sp

	move.w	#$19,-(sp)	Get current drive
	trap	#1
	addq.l	#2,sp
	add.b	#65,d0		Convert to ASCII
	move.b	d0,fdir		Shove this letter into the first character
	move.b	d0,pdir		of each fsel pathname
	move.b	d0,ddir
	bsr	buildp		And build the rest of the path

	move.l	#char1,a5	Set up ASCII table strings for
	move.l	#1,d0		screen font display
	move	#62,d5
fstr1:	move.b	d0,(a5)+
	addq.b	#1,d0
	dbf	d5,fstr1
	clr.b	(a5)+
	move	#63,d5
fstr2:	move.b	d0,(a5)+
	addq.b	#1,d0
	dbf	d5,fstr2
	clr.b	(a5)

	dc.w	init_a		Line-A init call
	move.l	-$16(a0),fsavt
	move.l	-$1C4(a0),a5	Save original font pointers
	move.l	$4C(a5),fsav1
	move.l	$54(a5),a5
	move.l	$4C(a5),fsav2

	move.l	fnt8x8(a1),a2	Set pointer to start of 2nd font
	move.l	fontad(a2),sysfad  Store address of system font

	move.l	sysfad,a5
	move.l	#usrfnt,a4	Copy the system font to the user
	move.l	#511,d5		font buffer
cpfdat:	move.l	(a5)+,(a4)+
	dbf	d5,cpfdat
	bsr	cnv16		Set up default 8x16 font as well
	move.w	#1,perflg	Set perforation skip flag
	move.w	#1,rspflg	Set printer reset flag
	clr.w	tlflag		Clear type-a-line flag
	clr.w	fntflg		Clear font flag
	clr.w	lsflag		Clear line spacing flag
	clr.w	nofflg		Clear "Filename print" flag

	move.l	#$A000,a5	This section searches for the fsel_input
s_1:	move.l	#itmtxt,a4	text "ITEM SELECTOR", then searches
	move.l	#12,d5		backwards for the pointer to this text
s_2:	move.b	(a5),d0		in the fsel object tree. New string
	cmp.b	(a4),d0		addresses can be poked into this location.
	beq	s_3
	addq.l	#1,a5
	bra	s_2
s_3:	move.l	a5,a0
s_4:	cmp.b	(a5)+,(a4)+
	bne	s_1
	dbf	d5,s_4
	move.l	a0,d0
	move.l	a0,iasav
	move.l	a0,d1
	and.l	#$FFFFFFFE,d1
	move.l	d1,a0
s_5:	subq.l	#2,a0
	move.l	(a0),d1
	cmp.l	d1,d0
	bne	s_5
	move.l	a0,itmadr

	move.w	8(a0),ilensv	Save original string length

	move.l	#w_get,aespb	Use wind_get to find the coordinates
	clr.w	intin		of the desktop window
	move.w	#4,intin+2
	bsr	aes
	move.l	#intout+2,a5
	move.w	(a5)+,xdesk
	move.w	(a5)+,d5
	cmp.w	#2,res		Move the window down just a bit so a bit
	bne	wg2		of the background shows between it and the
	addq.w	#4,d5		menu bar (I don't know why, I just like
	bra	wg3		the way it looks)
wg2:	addq.w	#2,d5
wg3:	move.w	d5,ydesk
	move.w	(a5)+,wdesk
	move.w	(a5),d5
	cmp.w	#2,res
	bne	wg4
	subq.w	#4,d5
	bra	wg5
wg4:	subq.w	#2,d5
wg5:	move.w	d5,hdesk

	move.l	#w_crea,aespb	wind_create
	move.l	#intin,a5
	move.w	#%010011,(a5)+	Show name, close box, and info line
	move.w	xdesk,(a5)+
	move.w	ydesk,(a5)+
	move.w	wdesk,(a5)+
	move.w	hdesk,(a5)
	bsr	aes
	move.w	intout,whandl	Save window handle

	move.l	#wtitle,a4	Draw window title and info line
	bsr	wndset
	bsr	w_set2

menu:	move.l	#m_bar,aespb	Call menu_bar (AES #30) to set up the menu
	move.w	#1,intin	(0=erase bar, 1=draw bar)
	move.l	mntree,addrin	Menu tree address
	bsr	aes
	move.l	#w_updt,aespb	Disable drop-downs immediately
	move.w	#1,intin
	bsr	aes
	bsr	finger		Set pointing finger
	bsr	wndopn		Open the window
	bsr	savscr		Save the screen

	move.l	titree,a4	Put copyright symbol in title
	move.l	#copyrt,d5
	bsr	obspec
	move.l	(a5),a5		TEDINFO pointer
	move.l	(a5),a5		Pointer to text
	move.b	#189,10(a5)
	move.w	#tdesk,mntitl
	cmp.w	#2,res
	bne	gotitl
	move.l	#image1,d5	Move Analog logo down a bit if we're
	bsr	obspec		in high resolution
	add.w	#12,6(a5)
	move.l	#image2,d5
	bsr	obspec
	add.w	#12,6(a5)
gotitl:	bra	dotitl

evnt1:	move.l	#w_updt,aespb	Enable drop-down menus
	clr.w	intin
	bsr	aes

evntms:	move.l	#e_mult,aespb	Use evnt_multi to wait for a message
	move.w	#%010000,intin
	move.l	#mspipe,addrin	Address of message pipe (16-byte buffer)
	bsr	aes

	move.w	intout,d0
	cmp.w	#%010000,d0	Is this a message?
	bne	evntms		No, go back

menchk:	move.l	#w_get,aespb	Call wind_get to see if another window
	move.w	#10,intin+2	is currently active
	bsr	aes
	move.w	intout+2,d0
	cmp.w	whandl,d0	Is our window active?
	beq	menc2		Yes, skip ahead
	move.w	mspipe+6,mntitl	Reset selected menu item
	bsr	normal
	bra	evntms		And ignore this message!

menc2:	cmp.w	#10,mspipe	Was a menu item selected?
	beq	mensel		Yes, go and process
	cmp.w	#22,mspipe	Close box?
	bne	ckrdrw
	move.w	mspipe+6,d5
	cmp.w	whandl,d5
	bne	evntms
	move.w	#tdesk+1,mntitl
	move.l	#w_updt,aespb	Disable drop-downs
	move.w	#1,intin
	bsr	aes
	bra	exit
ckrdrw:	cmp.w	#20,mspipe	Redraw message?
	bne	evntms		Nope, go back
	move.w	mspipe+6,d5
	cmp.w	whandl,d5	For this program?
	bne	evntms		No, back
	bsr	resscr		Replace screen from buffer
	bra	evntms

mensel:	move.l	#w_updt,aespb	Disable drop-downs
	move.w	#1,intin
	bsr	aes

	move.w	mspipe+6,mntitl	Save menu title index
	move.w	mspipe+8,obindx	Save object index

	bsr	normal		Reset menu

	cmp.w	#mtitle,obindx	Title selected from "Desk"?
	bne	mchk2		No, skip ahead
dotitl:	move.w	#$040,d5	Change color
	bsr	chngco
	move.l	titree,boxadr	Draw the title box
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo		Wait for click
	bsr	closbx		Erase the box
	and.w	#$7FFF,selobj	Mask high bit (double-click)
	move.w	#%110000,state
	bsr	change		Reset selected object
	bra	evnt1

mchk2:	cmp.w	#mquit,obindx	Want to leave?
	beq	exit

	cmp.w	#mwdeg,obindx	Write DEGAS font?
	bne	mchk31
	bsr	writde
	bra	evnt1

mchk31:	cmp.w	#mw8bt,obindx	Write 8-bit font?
	bne	mchk32
	bsr	writ8b
	bra	evnt1

mchk32:	cmp.w	#mlodde,obindx	Load DEGAS font?
	bne	mchk33		No
	bsr	loadde
	bra	evnt1

mchk33:	cmp.w	#mshowf,obindx	Toggle the displayed font?
	bne	mchk4
	eor.b	#1,shoflg	Flip the flag bit
	tst.b	shoflg
	beq	showu		Go show the system font
	move.l	showsv,a5	Get address of menu string pointer
	move.l	#shosys,(a5)	Put new string address in there
	bsr	setfnt		Go show the user-loaded font
	bra	su2		Skip ahead
showu:	move.l	showsv,a5
	move.l	#shonam,(a5)
	bsr	resetf		Show the system font
su2:	move.l	#wtitle,a4	Re-draw the window title
	bsr	wndset
	bsr	w_set2		And the info line
	bsr	savscr		Save the new screen
	bra	evnt1

mchk4:	cmp.w	#mlod8b,obindx	Load 8-bit font?
	bne	mchk5		Nope
	bsr	load8b
	bra	evnt1

mchk5:	cmp.w	#mopt,obindx	Set print options?
	bne	mchk6		No
	move.l	#wpopt,a4
	bsr	wndset
	move.l	optree,a4	First save all the object status
	move.l	#os_sav,a5	words that can be affected by checking
ck_ot1:	move.w	6(a4),d0	for extended object type 3
	lsr.w	#8,d0
	cmp	#ot_sav,d0
	bne	ck_ot2
	move.w	10(a4),(a5)+
ck_ot2:	add.l	#24,a4
	cmp.l	extree,a4
	bne	ck_ot1

	move.l	optree,a4
	move.l	#omargn,d5
	bsr	obspec		Also save the two ASCII characters
	move.l	(a5),a5		in the editable box
	move.l	(a5),a5
	move.l	a5,temp		Save this for later
	move.b	(a5),lmsav
	move.b	1(a5),lmsav+1

	move.w	#$601,d5	Set color
	bsr	chngco
	move.l	optree,boxadr	Draw the options dialog box
	clr.w	edtflg
	bsr	drawbx
	bsr	drawud		Re-draw the up and down buttons
opst:	bsr	formdo		Get user's input
	cmp.w	#ook,selobj	Did the user select OK?
	beq	optok		Yes, go process it
	cmp.w	#ocancl,selobj	CANCEL?
	beq	optcnc		Yes, skip ahead
	and.w	#$7FFF,selobj	Mask off high bit (in case of double-click)
	move.l	temp,a5		a5= pointer to margin text (2 digits)
	move.l	#1,d5		Set digit counter
	add.l	d5,a5		Point to last digit
	cmp.w	#upbt,selobj	Was it "up"?
	bne	o_dn1		No, skip
o_up1:	cmp.b	#'9',(a5)	If the digit is "9" reset it to "0"
	bne	o_up2
	move.b	#'0',(a5)
	bra	o_up3
o_up2:	addq.b	#1,(a5)		Increment the margin text
	bra	mredrw		and re-draw it
o_up3:	subq.l	#1,a5		Set pointer to next digit
	dbf	d5,o_up1
mredrw:	move.l	optree,drtree
	clr.w	depth		Re-draw the margin text
	move.w	#omargn,strtob
	move.w	#1,mod_xy
	move.w	#2,mod_wh
	bsr	obdraw
	bra	opst
o_dn1:	cmp.b	#'0',(a5)	This is the corresponding routine for
	bne	o_dn2		the down button
	move.b	#'9',(a5)
	bra	o_dn3
o_dn2:	subq.b	#1,(a5)
	bra	mredrw
o_dn3:	subq.l	#1,a5
	dbf	d5,o_dn1
	bra	mredrw

optcnc:	clr.w	state
	bsr	change
	move.l	optree,a4	Let's restore all the object status words
	move.l	#os_sav,a5
rs_ot1:	move.w	6(a4),d0
	lsr.w	#8,d0
	cmp	#ot_sav,d0
	bne	rs_ot2
	move.w	(a5)+,10(a4)
rs_ot2:	add.l	#24,a4
	cmp.l	extree,a4
	bne	rs_ot1

	move.l	optree,a4	Also restore the margin text
	move.l	#omargn,d5
	bsr	obspec
	move.l	(a5),a5
	move.l	(a5),a5
	move.b	lmsav,(a5)+
	move.b	lmsav+1,(a5)

	clr.w	mod_xy
	clr.w	mod_wh

	move.w	#osmall,strtob	Now let's re-draw all these thingies!
	clr.w	depth
	move.l	optree,drtree
	bsr	obdraw
	move.w	#olarge,strtob
	bsr	obdraw
	move.w	#opfyes,strtob
	bsr	obdraw
	move.w	#opfno,strtob
	bsr	obdraw
	move.w	#orsyes,strtob
	bsr	obdraw
	move.w	#orsno,strtob
	bsr	obdraw
	move.w	#osysbt,strtob
	bsr	obdraw
	move.w	#ousrbt,strtob
	bsr	obdraw
	move.w	#sixbt,strtob
	bsr	obdraw
	move.w	#eigbt,strtob
	bsr	obdraw
	move.w	#ninbt,strtob
	bsr	obdraw
	move.w	#1,mod_xy
	move.w	#2,mod_wh
	move.w	#omargn,strtob
	bsr	obdraw
	clr.w	mod_xy
	clr.w	mod_wh
	move.w	#ook,strtob
	bsr	obdraw
	move.w	#ocancl,strtob
	bsr	obdraw
	bra	opst

optok:	clr.w	state		We come here on an OK button
	bsr	change		Reset selected object
	
* Here we start checking the object status flags

	move.l	optree,a4
	move.l	#osmall,d5	SMALL button
	bsr	obstat
	move.w	(a5),d0		Get status
	and.w	#$0001,d0	Bit zero set? (SELECTED)
	beq	large		No, skip ahead
	move.l	#nszsm,a0
	move.b	#76,grmode
	bra	sz1
large:	move.l	#nszlg,a0
	move.b	#75,grmode
sz1:	move.l	#isize,a1
	move.l	#4,d0
sz2:	move.b	(a0)+,(a1)+
	dbf	d0,sz2

opt2:	move.l	#opfyes,d5
	bsr	obstat		SKIP PERF
	move.w	(a5),d0
	and.w	#$0001,d0
	beq	noskip
	move.l	#nyes,a0
	move.w	#1,perflg
	bra	perf1
noskip:	move.l	#nno,a0
	clr.w	perflg
perf1:	move.l	#iperf,a1
	move.l	#2,d0
perf2:	move.b	(a0)+,(a1)+
	dbf	d0,perf2

opt3:	move.l	#omargn,d5
	bsr	obspec		LEFT MARGIN
	move.l	(a5),a5		Pointer to TEDINFO structure
	move.l	(a5),a5		Pointer to text string
	move.l	a5,a0
	move.b	(a0)+,imrgn
	move.b	(a0),imrgn+1
	bsr	cnvasc		Convert ASCII decimal to binary
	move.b	d0,margin

	move.l	optree,a4
	move.l	#orsyes,d5	RESET PRINTER
	bsr	obstat
	move.w	(a5),d0
	and.w	#$0001,d0
	beq	norest
	move.w	#1,rspflg
	move.l	#nyes,a0
	bra	rest1
norest:	clr.w	rspflg
	move.l	#nno,a0
rest1:	move.l	#irest,a1
	move.l	#2,d0
rest2:	move.b	(a0)+,(a1)+
	dbf	d0,rest2

opt4:	tst.b	ufont
	beq	opt5
	move.l	#ifont,a0
	move.l	#7,d0
eraif:	move.b	#' ',(a0)+
	dbf	d0,eraif
	move.l	#osysbt,d5	Which font
	bsr	obstat
	move.w	(a5),d0
	and.w	#$0001,d0
	beq	itsusr
	clr.w	fntflg
	move.l	#nsys,a0
	bra	fnt1
itsusr:	move.w	#1,fntflg
	move.l	#fdinam,a0
fnt1:	move.l	#ifont,a1
	move.l	#7,d0
fnt2:	tst.b	(a0)
	beq	opt5
	move.b	(a0)+,(a1)+
	dbf	d0,fnt2

opt5:	move.l	#sixbt,d5	Line spacing buttons
	bsr	obstat
	move.w	(a5),d0
	and.w	#$0001,d0
	beq	notsix
	clr.w	lsflag
	move.l	#n16in,a0
	bra	spac1
notsix:	move.l	#eigbt,d5
	bsr	obstat
	move.w	(a5),d0
	and.w	#$0001,d0
	beq	noteig
	move.w	#1,lsflag
	move.l	#n18in,a0
	bra	spac1
noteig:	move.w	#2,lsflag
	move.l	#n19in,a0
spac1:	move.l	#ispac,a1
	move.l	#5,d0
spac2:	move.b	(a0)+,(a1)+
	dbf	d0,spac2

opt6:	move.w	#3,diflag	Release dialog screen memory
	bsr	dial
	bsr	ress2		Re-draw the screen
	bsr	w_set2		Re-draw the window info line
	bsr	savscr		Save the new screen
	bsr	setgbc		Set color back
	move.w	#2,diflag	Draw shrinking box
	bsr	dial
	move.l	#e_mult,aespb	Intercept the re-draw message
	move.w	#%010000,intin	from form_dial (above)
	move.l	#mspipe,addrin
	bsr	aes
	bra	evnt1

mchk6:	cmp.w	#mprint,obindx	Print file?
	bne	mchk7		No, skip
	bsr	printf		Go print it
	bra	evnt1

mchk7:	cmp.w	#typlin,obindx	Type a line?
	bne	mchk8
	move.l	#wtypl,a4
	bsr	wndset		Change window title
	move.l	pltree,boxadr	Draw the type-a-line box
	move.w	#pline,edtflg
	bsr	drawbx
	bsr	formdo
	bsr	closbx
	bsr	resscr		Erase it
	clr.w	state
	bsr	change
	cmp.w	#plcnbt,selobj	CANCEL?
	beq	evnt1		Yes, back to top
gettx:	move.l	#wtypl,a4
	bsr	wndset
	move.l	pltree,a4
	move.l	#pline,d5
	bsr	obspec
	move.l	(a5),a5
	move.l	(a5),a5
	move.l	#buffer,a4	Copy line of text to print buffer area
	move.l	#120,d5
cpytyp:	tst.b	(a5)
	beq	cpyt2
	move.b	(a5)+,(a4)+
	dbf	d5,cpytyp
cpyt2:	move.b	#10,(a4)+	Put line feed/carriage return at end
	move.b	#13,(a4)+
	clr.b	(a4)
tst1:	bsr	prstat		Check printer status
	bne	typit		No error, skip
	bsr	perror		Go tell the user to turn on the durn printer!
	beq	tst1		Go check again if "Continue"
	bra	evnt1
typit:	move.w	#1,tlflag	Set type-a-line flag
	move.l	#wtypl,a4
	move.l	a4,wtsav	Save address of window title
	bsr	wndset
	bsr	printf		Go print it
	bsr	resscr		Restore the screen
	bra	evnt1

mchk8:	cmp.w	#msettp,obindx	Set printer type?
	bne	mchk9		No, skip
	move.l	#wptyp,a4
	bsr	wndset
	move.w	#$700,d5	Set colors
	bsr	chngco
	move.l	tptree,boxadr	Draw "printer type" box
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo		Get input
	bsr	closbx		Erase it
	and.w	#$7FFF,selobj	Strip off high bit
	move.w	#%110000,state	Reset object
	bsr	change
	move.l	tptree,a4
	move.l	#ep10bt,d5
	bsr	obstat
	move.w	(a5),d0
	and.w	#$0001,d0	Is it the Epson/10x button?
	beq	setsg		No, skip ahead
	move.b	#'M',pmargn+1	Set printer codes
	move.b	#3,sixlen
	move.b	#3,eiglen
	move.b	#3,ninlen
	bra	evnt1
setsg:	move.b	#'l',pmargn+1
	move.b	#5,sixlen
	move.b	#5,eiglen
	move.b	#5,ninlen
	bra	evnt1

mchk9:	cmp.w	#madrlb,obindx	Address labels?
	bne	mchk10		No, skip
lablst:	move.l	#wadrlb,a4	Set window title line
	bsr	wndset
	move.w	#$052,d5	Set dialog box color
	bsr	chngco
	move.l	lbtree,boxadr	Draw the box
	move.w	#line1,edtflg	Set index of 1st editable field
	bsr	drawbx
	tst.b	shoflg
	beq	lblst1
	bsr	resetf		Redraw up and down buttons in case
	move.l	lbtree,drtree	an 8-bit font is loaded
	clr.w	depth
	move.w	#adupbt,strtob
	move.w	#1,mod_xy
	move.w	#2,mod_wh
	bsr	obdraw
	move.w	#addnbt,strtob
	bsr	obdraw
	bsr	setfnt

lblst1:	bsr	formdo		Get input
	and.w	#$7FFF,selobj	Mask high bit (double-click)
	cmp.w	#extbt,selobj
	beq	lblx1
	cmp.w	#prtbt,selobj
	beq	lblx1
	move.l	lbtree,a4
	move.l	#labnum,d5
	bsr	obspec
	move.l	(a5),a5
	move.l	(a5),a5
	move.l	#1,d5		Set digit counter
	add.l	d5,a5		Set pointer to last digit
	cmp.w	#adupbt,selobj
	bne	l_dn1
l_up1:	cmp.b	#'9',(a5)
	bne	l_up2
	move.b	#'0',(a5)
	bra	l_up3
l_up2:	addq.b	#1,(a5)
	bra	lredrw
l_up3:	subq.l	#1,a5
	dbf	d5,l_up1
lredrw:	move.l	lbtree,drtree
	clr.w	depth
	move.w	#labnum,strtob
	move.w	#1,mod_xy
	move.w	#2,mod_wh
	bsr	obdraw
	bra	lblst1
l_dn1:	cmp.b	#'0',(a5)
	bne	l_dn2
	move.b	#'9',(a5)
	bra	l_dn3
l_dn2:	subq.b	#1,(a5)
	bra	lredrw
l_dn3:	subq.l	#1,a5
	dbf	d5,l_dn1
	bra	lredrw

lblx1:	bsr	closbx		Get rid of de box
	move.w	#%110000,state
	bsr	change
	cmp.w	#extbt,selobj	Exit?
	beq	labxit		Yes, skip
	move.l	lbtree,a4	Get the number of labels desired
	move.l	#labnum,d5
	bsr	obspec
	move.l	(a5),a5
	move.l	(a5),a5
	bsr	cnvasc
	tst.l	d0
	beq	lablst
	move.w	d0,lblnum

	move.l	#buffer,a3
	move.l	#line1,d5	Copy the four lines in the label dialog box
	bsr	cpylab		to the print buffer
	move.l	#line2,d5
	bsr	cpylab
	move.l	#line3,d5
	bsr	cpylab
	move.l	#line4,d5
	bsr	cpylab
	move.b	#10,(a3)+	Put 2 CR/LFs at the end
	move.b	#13,(a3)+
	move.b	#10,(a3)+
	move.b	#13,(a3)+
	clr.b	(a3)		Mark end with zero
lst1:	bsr	prstat
	bne	lbl2
	bsr	perror
	beq	lst1
	bra	labxit

lbl2:	move.l	#wadrlb,a4
	move.l	a4,wtsav	Save address of title line
	bsr	wndset
	bsr	bee
lbl3:	move.w	#2,tlflag	Set flag for print routine
	bsr	printf		Go print it
	subq.w	#1,lblnum	Count down
	tst.w	lblnum		Done em all?
	bne	lbl3		Nope, go back for more
	bsr	finger
	bra	lablst
labxit:	bra	evnt1		Exit

mchk10:	cmp.w	#msetdr,obindx	Set drive?
	bne	mchk11		No, skip
	move.l	dvtree,a4	First, de-select all the drive buttons
	move.l	#1,d4
	move.l	#15,d3
clrbu1:	move.l	d4,d5
	bsr	obstat
	and.w	#$FFFE,(a5)
	addq.l	#1,d4
	dbf	d3,clrbu1
	move.w	#$19,-(sp)	Now get the current drive
	trap	#1
	addq.l	#2,sp
	move.l	d0,d5
	addq.l	#1,d5
	move.l	dvtree,a4	Set button of current drive
	bsr	obstat
	ori.w	#%000001,(a5)
	move.l	#wsetd,a4	Set window title
	bsr	wndset
	move.w	#$047,d5	Color
	bsr	chngco
	move.l	dvtree,boxadr
	clr.w	edtflg
	bsr	drawbx		Draw the box
	bsr	formdo
	bsr	closbx
	and.w	#$7FFF,selobj
	move.w	#%110000,state
	bsr	change
	move.l	dvtree,a4	Now check all the object statuses
	move.l	#drivea,d4	to see which drive was selected
	move.l	#15,d3
ckdrv1:	move.l	d4,d5
	bsr	obstat
	move.w	(a5),d0
	btst	#0,d0
	bne	ckdrv2
	addq.l	#1,d4
	dbf	d3,ckdrv1
	bra	ckdrv3
ckdrv2:	subq.b	#1,d4		Use GEMDOS setdrv call to set current drive
	move.w	d4,-(sp)
	move.w	#$0E,-(sp)
	trap	#1
	addq.l	#4,sp
	add.b	#65,d4
	move.b	d4,fdir		Move it into all the fsel lines too!
	move.b	d4,pdir
	move.b	d4,ddir
	bsr	buildp		Go build the pathname
ckdrv3:	bra	evnt1		Back to the top

mchk11:
	bra	evnt1

* Subroutines

* ASCII decimal to binary longword conversion
*
* Enter with:	a5= address of decimal string
*
* Exit with:	d0= converted number

cnvasc:	clr.l	d0
cnvl1:	cmpi.b	#"9",(a5)
	bhi	notdec
	cmpi.b	#"0",(a5)
	blo	notdec
	lsl.l	#1,d0
	move.l	d0,d1
	lsl.l	#2,d0
	add.l	d1,d0
	move.b	(a5)+,d1
	andi.l	#$0F,d1
	add.l	d1,d0
	bra	cnvl1
notdec:	rts

* Binary longword to decimal ASCII conversion
*
* Enter with: a0 -> ASCII string area
*	      d0 =  number to convert (long)

bindec:	movem.l	d0-d2,-(sp)
	add.l	#9,a0
	move	#8,d2
bdl1:	move.l	#10,d1
	bsr	ldiv
	move.b	d1,-(a0)
	add.b	#'0',(a0)
	dbra	d2,bdl1
	movem.l	(sp)+,d0-d2
	rts

* 32-bit division routine
*
* Enter with: d0= dividend
*	      d1= divisor
*
* Exit with:  d0= quotient
*	      d1= remainder

ldiv:	movem.l	d2-d3,-(sp)
	clr.l	d2
	clr.l	d3
	tst.l	d0
	bge	x1
	addq.l	#1,d3
	neg.l	d0
x1:	tst.l	d1
	bge	ldl1
	addq.l	#1,d3
	neg.l	d1
ldl1:	cmp.l	d0,d1
	bgt	ldl2
	sub.l	d1,d0
	addq.l	#1,d2
	bra	ldl1
ldl2:	btst	#0,d3
	beq	x2
	neg.l	d2
	neg.l	d0
x2:	move.l	d0,d1
	move.l	d2,d0
	movem.l	(sp)+,d2-d3
	rts

bindc2:	move.l	#ascdec,a1
	move	#1,d1
bd2_1:	move.b	#'0',(a1)+
	dbf	d1,bd2_1
	move.l	#ascdec+2,a0
	move	#1,d1
bd2_2:	ext.l	d0
	divs	#10,d0
	swap	d0
	move.b	d0,-(a0)
	add.b	#'0',(a0)
	swap	d0
	dbra	d1,bd2_2
	rts

buildp:	move.l	#fdext,a0	Build default pathnames in fsel
	move.l	#pdext,a1	directory areas
	move.l	#ddext,a2
	move.l	#fdir+1,a3
	move.l	#pdir+1,a4
	move.l	#ddir+1,a5
	move	#7,d5
build2:	move.b	(a0)+,(a3)+
	move.b	(a1)+,(a4)+
	move.b	(a2)+,(a5)+
	dbf	d5,build2
	rts

clrlin:	bsr	obspec		Enter with:
	move.l	(a5),a5		a4= address of object tree
	move.l	(a5),a5		d5= object index of editable field
	clr.b	(a5)
	rts

cpylab:	move.l	lbtree,a4	Copy address label text to the print
	bsr	obspec		buffer
	move.l	(a5),a5
	move.l	(a5),a5
	move.l	#40,d5
cpylb2:	tst.b	(a5)
	beq	cpyret
	move.b	(a5)+,(a3)+
	dbeq	d5,cpylb2
cpyret:	move.b	#10,(a3)+
	move.b	#13,(a3)+
	rts

chngco:	move.w	d5,-(sp)	Change color register 1
	move.w	#1,-(sp)
	move.w	#7,-(sp)
	trap	#14
	addq.l	#6,sp
	rts

drawud:	tst.b	shoflg
	beq	drudx
dud2:	bsr	resetf		Redraw the arrow buttons in the print options
	move.l	optree,drtree	box in case an alternate font is being
	clr.w	depth		displayed
	move.w	#upbt,strtob
	move.w	#1,mod_xy
	move.w	#2,mod_wh
	bsr	obdraw
	move.w	#dnbt,strtob
	bsr	obdraw
	tst.b	shoflg
	beq	drudx
	bsr	setfnt
drudx:	rts

repitm:	move.l	itmadr,a4	Replace "ITEM SELECTOR" text with string
	move.l	a5,(a4)		Enter with a5= address of string
	move.w	d5,8(a4)		   d5= length of string
	or.w	#1,-2(a4)	Set fsel title to SELECTED (inverse)
	rts

setfnt:	dc.w	init_a
	cmp.w	#2,res
	beq	sf_2
	move.l	#usrfnt,-$16(a0)
	bra	sf_3
sf_2:	move.l	#hifont,-$16(a0)
sf_3:	move.l	-$1C4(a0),a5	Set system font pointers to user fonts
	move.l	#usrfnt,$4C(a5)
	move.l	$54(a5),a5
	move.l	#hifont,$4C(a5)
	rts

resetf:	dc.w	init_a
	move.l	fsavt,-$16(a0)
	move.l	-$1C4(a0),a5	Restore system font pointers
	move.l	fsav1,$4C(a5)
	move.l	$54(a5),a5
	move.l	fsav2,$4C(a5)
	rts

printf:	tst.w	tlflag
	bne	pfl1
	move.l	#wprtf,a4
	move.l	a4,wtsav
	bsr	wndset
pfl1:	tst.w	fntflg		Is it the 'user' font?
	beq	sysfnt		No, skip ahead

setusr:	move.l	#usrfnt,fntptr	Set pointer to user font
	bra	prtf2

sysfnt:	move.l	sysfad,fntptr	Set font pointer

prtf2:	tst.w	tlflag		Is it "type-a-line"?
	bne	prtf5		Yes, skip
	move.l	#i_prt,a5
	move.w	#ip_len*8,d5
	bsr	repitm
	bsr	clrfil		Call file selector to get input
	move.l	#pdir,a0
	move.l	#i_prt1,t_adr1
	move.l	#i_prt2,t_adr2
	bsr	fsel

	tst.b	file		Is there a filename?
	bne	prtf3		Yes, skip
	rts			Return

prtf3:	cmp.w	#1,intout+2	OK button?
	beq	prtf4		Yes, skip
	rts			Return

prtf4:	move.l	wtsav,a4
	bsr	wndset
	bsr	prstat
	bne	prtf42
	bsr	perror
	beq	prtf4
	clr.w	tlflag
	rts

prtf42:	move.w	#$042,d5
	bsr	chngco
	move.l	totree,boxadr
	clr.w	edtflg
	bsr	drawbx		Draw "title line options" box
doto1:	bsr	formdo
	and.w	#$7FFF,selobj	Mask high bit
	cmp.w	#tookbt,selobj	OK button?
	beq	toex1		Yes, go process
	move.l	totree,a4
	eor.w	#1,nofflg	Toggle the title line flag
	tst.w	nofflg		Zero?
	beq	enable		Yes, go enable it
	move.l	#tonmbt,d5	Disable the title line option buttons
	bsr	obstat
	move.w	#%101000,(a5)
	move.l	#todtbt,d5
	bsr	obstat
	move.w	#%101000,(a5)
	move.l	#totmbt,d5
	bsr	obstat
	move.w	#%101000,(a5)
	move.l	#tontbt,d5
	bsr	obstat
	move.w	#%100001,(a5)
	bra	doto2

enable:	move.l	#tonmbt,d5	Enable the title line option buttons
	bsr	obstat
	move.w	#%100000,(a5)
	move.l	#todtbt,d5
	bsr	obstat
	move.w	#%100000,(a5)
	move.l	#totmbt,d5
	bsr	obstat
	move.w	#%100000,(a5)
	move.l	#tontbt,d5
	bsr	obstat
	move.w	#%100000,(a5)

doto2:	clr.w	mod_xy		Redraw the buttons in their new states
	clr.w	mod_wh
	move.l	totree,drtree
	clr.w	depth
	move.w	#tontbt,strtob
	bsr	obdraw
	move.w	#tonmbt,strtob
	bsr	obdraw
	move.w	#todtbt,strtob
	bsr	obdraw
	move.w	#totmbt,strtob
	bsr	obdraw
	bra	doto1
	
toex1:	bsr	closbx		Erase the box
	move.w	#%110000,state
	bsr	change		Reset selected object
	move.l	totree,a4
	tst.w	nofflg		No title line?
	beq	toex2		No, skip ahead
	clr.w	tiflag		Clear the bit vector flag
	bra	prtf5
toex2:	clr.w	d1
	move.l	#tonmbt,d5
	bsr	obstat
	move.w	(a5),d0
	btst	#0,d0		Print filename?
	beq	toex3		No, skip
	bset	#0,d1		Set bit 0
toex3:	move.l	#todtbt,d5
	bsr	obstat
	move.w	(a5),d0
	btst	#0,d0		Print date?
	beq	toex4		No, skip
	bset	#1,d1		Set bit 1
toex4:	move.l	#totmbt,d5
	bsr	obstat
	move.w	(a5),d0
	btst	#0,d0		Print time?
	beq	toex5		No, skip
	bset	#2,d1		Set bit 2
toex5:	move.w	d1,tiflag	Save the bit vector flag

prtf5:	move.l	#pmargn,a5	Set printer margin
	move.l	#3,d6
	bsr	printl

	tst.w	perflg		Skip perforation?
	beq	prtf6		No, skip
	move.l	#prfcom,a5	Send codes to printer
	move.l	#3,d6
	bsr	printl

prtf6:	clr.l	d6		Get selected line spacing and send
	move.w	lsflag,d5	the proper codes to the printer
	tst.w	d5
	bne	pfls1
	move.l	#sixcom,a5
	move.b	sixlen,d6
	bra	dols
pfls1:	cmp.w	#1,d5
	bne	pfls2
	move.l	#eigcom,a5
	move.b	eiglen,d6
	bra	dols
pfls2:	move.l	#nincom,a5
	move.b	ninlen,d6
dols:	bsr	printl

	tst.w	tlflag		Type-a-line?
	bne	txl1		Yes, skip ahead
	tst.w	tiflag		Print time?
	beq	gtd1		No, skip

	move.l	#buffer,a5
	move.w	tiflag,d0
	btst	#0,d0
	beq	ti_1
	move.b	#' ',(a5)+
	move.l	#fnamms,a4
	move	#9,d5
setti1:	move.b	(a4)+,(a5)+
	dbf	d5,setti1
	move.l	#file,a4
	move	#11,d5
setti2:	tst.b	(a4)
	beq	ti_1
	move.b	(a4)+,(a5)+
	dbf	d5,setti2

ti_1:	move.w	tiflag,d0
	btst	#1,d0
	beq	ti_2
	move.b	#' ',(a5)+
	move.w	#$2A,-(sp)
	trap	#1
	addq.l	#2,sp
	move.w	d0,datsav
	and.w	#%111100000,d0
	lsr.w	#5,d0
	bsr	bindc2
	move.b	ascdec,(a5)+
	move.b	ascdec+1,(a5)+
	move.b	#'/',(a5)+
	move.w	datsav,d0
	and.w	#%11111,d0
	bsr	bindc2
	move.b	ascdec,(a5)+
	move.b	ascdec+1,(a5)+
	move.b	#'/',(a5)+
	move.w	datsav,d0
	and.w	#%1111111000000000,d0
	lsr.w	#8,d0
	lsr.w	#1,d0
	add.w	#80,d0
	bsr	bindc2
	move.b	ascdec,(a5)+
	move.b	ascdec+1,(a5)+
	move.b	#' ',(a5)+

ti_2:	move.w	tiflag,d0
	btst	#2,d0
	beq	ti_prt
	move.b	#' ',(a5)+
	move.w	#$2C,-(sp)
	trap	#1
	addq.l	#2,sp
	move.w	d0,timsav
	and.w	#%1111100000000000,d0
	lsr.w	#8,d0
	lsr.w	#3,d0
	bsr	bindc2
	move.b	ascdec,(a5)+
	move.b	ascdec+1,(a5)+
	move.b	#':',(a5)+
	move.w	timsav,d0
	and.w	#%11111100000,d0
	lsr.w	#5,d0
	bsr	bindc2
	move.b	ascdec,(a5)+
	move.b	ascdec+1,(a5)+
	move.b	#':',(a5)+
	move.w	timsav,d0
	and.w	#%11111,d0
	lsl.w	#1,d0
	bsr	bindc2
	move.b	ascdec,(a5)+
	move.b	ascdec+1,(a5)+
	move.b	#' ',(a5)+

ti_prt:	clr.b	(a5)
	tst.b	buffer
	beq	ti_p2
	move.b	#13,(a5)+
	move.b	#10,(a5)+
	move.b	#13,(a5)+
	move.b	#10,(a5)+
	clr.b	(a5)
	bsr	txl1
ti_p2:	clr.w	tiflag

gtd1:	bsr	getdat
	bne	error

	move.l	dta+26,d1
	cmp.l	#102400,d1	Is it too big?
	blo	pfc2		No, skip
	move.l	bgtree,a4
	move.l	#bignam,d5
	bsr	obspec
	move.l	#file,(a5)

	move.w	#$500,d5
	bsr	chngco
	move.l	bgtree,boxadr
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo
	bsr	closbx
	bsr	resscr
	and.w	#$7FFF,selobj
	move.w	#%110000,state
	bsr	change
	cmp.w	#bigabt,selobj
	bne	pfc1
	clr.w	tlflag
	rts

pfc1:	move.l	wtsav,a4
	bsr	wndset

pfc2:	clr.l	d5		Open the file
	move.l	#file,a5
	bsr	openfl
	bmi	error
	move.w	d0,handle

	move.l	#buffer,a5	Read text file to buffer
	move.l	#102400,d5	Maximum size= 100K
	bsr	readfl
	bmi	error
	move.l	d0,number	Save number of bytes read
	move.l	#buffer,a5
	add.l	d0,a5
	clr.b	(a5)		Set zero at end

	bsr	closfl		We're finished with this file
	bmi	error		so let's close it

	dc.w	hidems
	move.l	pmtree,a4
	move.l	#pfnam,d5
	bsr	obspec
	move.l	#file,(a5)

	move.l	#cntmsg,a5
	move.l	#nummsg,a4
	move	#8,d5
clrcm1:	move.b	#' ',(a5)+
	move.b	#'0',(a4)+
	dbf	d5,clrcm1
	clr.b	(a5)
	clr.b	(a4)

	move.l	number,d0
	move.l	#nummsg,a0
	bsr	bindec
	move.l	pmtree,a4
	move.l	#pfnums,d5
	bsr	obspec
	move.l	#nummsg,(a5)

	move.l	#nummsg,a5
	move	#8,d5
fndlen:	cmp.b	#'0',(a5)
	bne	fndl2
	addq.l	#1,a5
	dbf	d5,fndlen
	bra	dopbox
fndl2:	move.l	#nummsg,a4
	move.w	d5,d4
	move.w	d4,digcnt
	addq.w	#1,d4
fndl3:	move.b	(a5)+,(a4)+
	dbf	d5,fndl3
	clr.b	(a4)
	move.l	#cntmsg,a5
	add.l	d4,a5
	clr.b	(a5)

dopbox:	move.w	#$400,d5
	bsr	chngco
	move.l	pmtree,boxadr
	move.l	#f_cntr,aespb
	move.l	boxadr,addrin
	bsr	aes
	move.w	intout+2,cx
	move.w	intout+4,cy
	subq.w	#1,cy
	move.w	intout+6,cw
	move.w	intout+8,ch
	addq.w	#2,ch
	move.l	pmtree,a4
	move.l	#0,d5
	bsr	obspec
	subq.w	#1,6(a5)
	clr.w	edtflg
	bsr	db2

txl1:	move.l	#buffer,a1	a1 holds address of text to print
txloop:	move.l	#outbuf,a2	a2 holds address of output buffer
	move.l	#319,d5		Clear buffer
clrbuf:	clr.l	(a2)+		$500 bytes = 320 longwords
	dbf	d5,clrbuf

	move.l	#outbuf,a2	Restore buffer address
	clr.w	outcnt		Clear output counter
getb1:	clr.w	tabcnt

getbyt:	move.w	#$FF,-(sp)	Read keypress with RAWCONIO
	move.w	#6,-(sp)
	trap	#1
	addq.l	#4,sp
	swap	d0		Get scan code to lower word
	tst.w	d0
	beq	getb2		No key present, skip
	cmpi.b	#$61,d0		Is it Undo?
	bne	getb2		No, skip
	move.w	#1,lblnum
	bra	endit

getb2:	clr.l	d5		Clear out data register
	move.b	(a1)+,d5	Get character from string
	tst.b	d5		End of text? (Zero)
	bne	ckbyt2		No, skip
endit:	tst.w	tlflag
	bne	endit2
	tst.w	tiflag
	bne	endit3
	bsr	closbx
endit2:	tst.w	rspflg
	beq	endit3
	move.l	#rspcom,a5
	move.l	#2,d6
	bsr	printl
endit3:	tst.w	tlflag
	bne	endit4
	bsr	finger
endit4:	clr.w	tlflag
	rts			Return

ckbyt2:	tst.w	tlflag
	bne	ckb22
	tst.w	tiflag
	bne	ckb22
	move.l	#cntmsg,a5
	move	digcnt,d0
	add.l	d0,a5
cntl1:	cmp.b	#'9',(a5)
	bne	cntl2
	move.b	#'0',(a5)
	bra	cntl4
cntl2:	cmp.b	#' ',(a5)
	bne	cntl3
	move.b	#'1',(a5)
	bra	drwcnt
cntl3:	addq.b	#1,(a5)
	bra	drwcnt
cntl4:	subq.l	#1,a5
	dbf	d0,cntl1
drwcnt:	move.l	#cntmsg-4,-(sp)
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp

ckb22:	cmpi.b	#10,d5		Is it Linefeed?
	beq	getbyt		Yes, ignore

	cmpi.b	#13,d5		Is it carriage return?
	beq	doprint		Yes, go print the line

	cmpi.b	#12,d5		Form feed?
	bne	ckbyt3		No, skip
	move.w	#12,-(sp)	Send form feed to printer
	move.w	#5,-(sp)	and go back to top of loop
	trap	#1
	addq.l	#4,sp
	bra	getbyt

ckbyt3:	cmpi.b	#9,d5		Horizontal tab?
	bne	ckbyt4		Nope, skip it pal!
	clr.l	d4
	move.w	#8,d4
	sub.w	tabcnt,d4
	lsl.w	#3,d4
	add.w	d4,outcnt
	subq.w	#1,d4
tbloop:	clr.b	(a2)+
	dbf	d4,tbloop
	bra	getb1

ckbyt4:	addq.w	#1,tabcnt
	cmp.w	#8,tabcnt
	bne	ckbyt5
	clr.w	tabcnt

ckbyt5:	move.l	fntptr,a0	a0= start of font data
	add.l	d5,a0		Add ASCII value to get offset
	add.l	#$0700,a0	Set pointer to last byte of char

	move.l	#7,d4		d4= font byte counter (8 bytes)
bytloo:	move.b	(a0),d2		d2= font data byte
	tst.w	tiflag
	beq	noeor
	eor.b	#$FF,d2		If title line, reverse bits
noeor:	move.l	#7,d3		d3= bit counter (8 bits)
bitloo:	move.b	0(a2,d3),d1
	lsr.b	#1,d2		Shift bit into carry
	roxr.b	#1,d1		Roll bit sideways into output bytes
	move.b	d1,0(a2,d3)
	dbf	d3,bitloo	Count bits
	suba.l	#$100,a0	Decrement pointer to font data
	dbf	d4,bytloo	Count bytes

	add.l	#8,a2		Increment pointer to output buffer
	add.w	#8,outcnt	Count output bytes
	bra	getbyt

doprint	move.b	#$0D,(a2)+	Put CR at end of buffer
	move.b	#$0A,(a2)
	move.l	#6,d6		Add 5 to byte count to get
	add.w	outcnt,d6	total number of bytes to send
	move.b	outcnt,d4	The printer expects it's word
	move.b	outcnt+1,outcnt	values to be low byte/high byte
	move.b	d4,outcnt+1	so we swap outcnt and outcnt+1
	move.l	#header,a5
	bsr	printl		Go print this bad boy!
	bra	txloop		Print the rest

exit:	move.l	#wexit,a4
	bsr	wndset
	move.w	#$760,d5
	bsr	chngco
	move.l	extree,boxadr
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo
	bsr	closbx
	clr.w	state
	bsr	change
	cmp.w	#extyes,selobj	Was the 1st box chosen?
	beq	really		Yes, and away we go
	bsr	finger
	bra	evnt1		Oops, can I take that back? (Sure!)

really:	bsr	bee		Set the busy bee mouse cursor
	bsr	shmous
	bsr	wndclo
	move.l	#w_del,aespb	wind_delete
	move.w	whandl,intin
	bsr	aes

	bsr	resetf		Reset font pointers just in case

	move.l	#w_updt,aespb	Allow drop-downs
	clr.w	intin
	bsr	aes

real2:	move.l	#contrl,a5
	move.w	#101,(a5)	Close virtual screen workstation
	clr.w	2(a5)
	clr.w	6(a5)
	move.w	ghandl,12(a5)
	bsr	vdi
	move.l	#a_exit,aespb	appl_exit (not in Abacus)
	bsr	aes
	pea	colsav
	move.w	#6,-(sp)
	trap	#14
	addq.l	#6,sp

realx:	clr.w	-(sp)		Bye! I'm heading back to the
	trap	#1		desktop...


prstat:	move	#$11,-(sp)	Get printer status
	trap	#1
	addq.l	#2,sp
	tst	d0
	rts

perror:	move.w	#$410,d5
	bsr	chngco
	move.l	petree,boxadr
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo
	bsr	closbx
	bsr	resscr
	clr.w	state
	bsr	change
	cmp.w	#pecont,selobj
	rts

* Send a string of characters to the printer
*
* Enter with: a5= address of string to print
*	      d6= number of bytes to send

printl:	movem.l	a0-a3,-(sp)	Save registers
	move.l	a5,-(sp)
	move.l	d6,-(sp)
	move.w	#3,-(sp)
	move.w	#$40,-(sp)
	trap	#1
	add.l	#12,sp
	movem.l	(sp)+,a0-a3	Restore registers
	rts

chginf:	move.l	#ifont,a0
	move.l	#7,d0
chgera:	move.b	#' ',(a0)+
	dbf	d0,chgera
	move.l	#fdinam,a0
	move.l	#ifont,a1
	move.l	#7,d0
chgi2:	tst.b	(a0)
	beq	chgi3
	move.b	(a0)+,(a1)+
	dbf	d0,chgi2
chgi3:	rts

* Load DEGAS font file

loadde:	move.l	#wldde,a4
	bsr	wndset
	move.l	#i_deg,a5
	move.w	#id_len*8,d5
	bsr	repitm

	bsr	clrfil
	move.l	#ddir,a0
	move.l	#i_deg1,t_adr1
	move.l	#i_deg2,t_adr2
	bsr	fsel
	tst.b	file
	bne	ldde2
	rts

ldde2:	cmp.w	#1,intout+2
	beq	ldde3
	rts

ldde3:	move.l	#wldde,a4
	bsr	wndset
	clr.l	d5		Open the font file
	move.l	#file,a5
	bsr	openfl
	bmi	error
	move.w	d0,handle

	move.l	#degfnt,a5
	move.l	#$802,d5
	bsr	readfl
	bmi	error

	bsr	closfl		Close the file
	bmi	error

	bsr	setfdi
	bsr	savfnm

	move.l	#degfnt,a4	Construct ST format font
	move.l	#usrfnt,a5
	move.w	#127,d5
delp1:	move	#7,d4
delp2:	move.b	(a4),(a5)
	addq.l	#2,a4
	add.l	#$0100,a5
	dbf	d4,delp2
	suba.l	#$07FF,a5
	dbf	d5,delp1

	move.l	#degfnt,a4	Also construct an 8-bit font
	move.l	#b8font,a5
	move	#2047,d5
de8_1:	move.b	(a4),(a5)+
	addq.l	#2,a4
	dbf	d5,de8_1

	cmp.w	#2,res
	bne	ldde4
	bsr	cnv16
ldde4:	bsr	resttl
	bsr	drrect
	bsr	prtfnt
	move.l	shstsv,a5
	clr.w	(a5)
	move.l	mwdesv,a5
	clr.w	(a5)
	move.l	mw8bsv,a5
	clr.w	(a5)
	move.b	#1,ufont
	tst.b	shoflg
	bne	ldde5
	move.l	showsv,a5
	move.l	#shonam,(a5)
ldde5:	tst.w	fntflg
	beq	ldde6
	bsr	chginf
ldde6:	bsr	w_set2
	bsr	savscr
	rts

* Load 8-bit font file

load8b:	move.l	#wld8b,a4
	bsr	wndset
	move.l	#i_fn8,a5
	move.w	#i8_len*8,d5
	bsr	repitm
	bsr	clrfil
	move.l	#fdir,a0	Address of .F8 directory name
	move.l	#i_fn81,t_adr1
	move.l	#i_fn82,t_adr2
	bsr	fsel		Call fsel_input to get font filename
	tst.b	file		No filename selected
	bne	ld8b2
	rts

ld8b2:	cmp.w	#1,intout+2	Did we click on 'OK'?
	beq	ld8b3		Yes, let's go
	rts			No, forget about it

ld8b3:	move.l	#wld8b,a4
	bsr	wndset
	clr.l	d5		Open the font file
	move.l	#file,a5
	bsr	openfl
	bmi	error
	move.w	d0,handle

	move.l	#b8font+$100,a5 Read font file to buffer
	move.l	#$200,d5	and rearrange to ASCII order
	bsr	readfl		as we do it
	bmi	error

	move.l	#b8font,a5
	move.l	#$100,d5
	bsr	readfl
	bmi	error

	move.l	#b8font+$300,a5
	move.l	#$100,d5
	bsr	readfl
	bmi	error

	bsr	closfl		Close the file
	bmi	error

	bsr	setfdi
	bsr	savfnm

	move.l	#usrfnt,a3	a3= address of user font buffer
	move.l	#b8font,a4	a4= address of 8-bit font buffer
	move.l	#127,d3		128 characters
loop1:	move.l	#7,d4		8 bytes
loop2:	move.b	(a4)+,(a3)	Rearrange the font data to ST format
	add.l	#$0100,a3
	dbf	d4,loop2
	suba.l	#$07FF,a3
	dbf	d3,loop1

	move.l	#b8font,a4
	move.l	#degfnt,a5
	move	#1023,d5
b8d_1:	move.b	(a4),(a5)+
	move.b	(a4)+,(a5)+
	dbf	d5,b8d_1
	move	#1,(a5)

	cmp.w	#2,res		Are we in hi res monochrome?
	bne	savst		Nope, skip it
	bsr	cnv16

savst:	bsr	drrect
	bsr	prtfnt
	bsr	resttl
savs2:	tst.w	fntflg
	beq	savs3
	bsr	chginf
savs3:	bsr	w_set2
	bsr	savscr

nosavf:	bsr	finger
	move.l	shstsv,a5
	clr.w	(a5)
	move.l	mwdesv,a5
	clr.w	(a5)
	move.l	mw8bsv,a5
	clr.w	(a5)
	move.b	#1,ufont	Set user-font flag
	tst.b	shoflg
	bne	ld8x1
	move.l	showsv,a5
	move.l	#shonam,(a5)
ld8x1:	rts

* Write DEGAS font

writde:	move.l	#wwrtde,a4
	bsr	wndset
	move.l	#i_wrtd,a5
	move.w	#iwdlen*8,d5
	bsr	repitm

	move.l	#shnm2,a4
	move.l	#file,a5
	move	#7,d5
fdloo1:	tst.b	(a4)
	beq	fdloo2
	cmp.b	#'.',(a4)
	beq	fdloo2
	move.b	(a4)+,(a5)+
	dbf	d5,fdloo1
fdloo2:	move.l	#fdmsg,a4
	move	#4,d5
fdloo3:	move.b	(a4)+,(a5)+
	dbf	d5,fdloo3

stop1:	move.l	#ddir,a0
	move.l	#i_wrd1,t_adr1
	move.l	#i_wrd2,t_adr2
	bsr	fsel
	tst.b	file
	bne	wrtd2
	rts
wrtd2:	cmp.w	#1,intout+2
	beq	wrtd3
	rts
wrtd3:	bsr	getdat
	bne	wrtd4
	bsr	samebx
	beq	wrtd4
	rts
wrtd4:	clr.w	-(sp)
	move.l	#file,-(sp)
	move.w	#$3C,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	bmi	error
	move	d0,handle
	move.l	#degfnt,a5
	move.l	#$802,d5
	bsr	writfl
	bmi	error
	bsr	closfl
	rts

* Write 8-bit font

writ8b:	move.l	#wwrt8b,a4
	bsr	wndset
	move.l	#i_wrt8,a5
	move.w	#iw8len*8,d5
	bsr	repitm

	move.l	#shnm2,a4
	move.l	#file,a5
	move	#7,d5
f8loo1:	tst.b	(a4)
	beq	f8loo2
	cmp.b	#'.',(a4)
	beq	f8loo2
	move.b	(a4)+,(a5)+
	dbf	d5,f8loo1
f8loo2:	move.l	#f8msg,a4
	move	#4,d5
f8loo3:	move.b	(a4)+,(a5)+
	dbf	d5,f8loo3

	move.l	#fdir,a0
	move.l	#i_wr81,t_adr1
	move.l	#i_wr82,t_adr2
	bsr	fsel
	tst.b	file
	bne	wrt82
	rts
wrt82:	cmp.w	#1,intout+2
	beq	wrt83
	rts
wrt83:	bsr	getdat
	bne	wrt84
	bsr	samebx
	beq	wrt84
	rts
wrt84:	clr.w	-(sp)
	move.l	#file,-(sp)
	move.w	#$3C,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	bmi	error
	move	d0,handle
	move.l	#b8font+$100,a5
	move.l	#$200,d5
	bsr	writfl
	bmi	error
	move.l	#b8font,a5
	move.l	#$100,d5
	bsr	writfl
	bmi	error
	move.l	#b8font+$300,a5
	move.l	#$100,d5
	bsr	writfl
	bmi	error
	bsr	closfl
	rts

samebx:	move.l	smtree,a4
	move.l	#nfound,d5
	bsr	obspec
	move.l	#file,(a5)
	move.w	#$403,d5
	bsr	chngco
	move.l	smtree,boxadr
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo
	bsr	closbx
	clr.w	state
	bsr	change
	cmp.w	#writok,selobj
	rts

getdat:	pea	dta		Tell GEM where the DTA buffer is
	move.w	#$1A,-(sp)
	trap	#1
	addq.l	#6,sp
	clr.w	-(sp)		Use SFIRST to get size of file into
	pea	file		dta+26
	move.w	#$4E,-(sp)
	trap	#1
	addq.l	#8,sp
	tst	d0
	rts

* Open a file
* Enter with: a5= address of filename
*	      d5= read/write mode

openfl:	move.w	d5,-(sp)
	move.l	a5,-(sp)
	move.w	#$3D,-(sp)
	trap	#1
	addq.l	#8,sp
	tst.w	d0
	rts

* Read a file
* Enter with: a5= address of buffer
*	      d5= number of bytes to read

readfl:	move.l	a5,-(sp)
	move.l	d5,-(sp)
	move.w	handle,-(sp)
	move.w	#$3F,-(sp)
	trap	#1
	add.l	#12,sp
	tst.l	d0
	rts

* Write to a file
* Enter with: a5= address of buffer
*	      d5= number of bytes to write

writfl:	move.l	a5,-(sp)
	move.l	d5,-(sp)
	move.w	handle,-(sp)
	move.w	#$40,-(sp)
	trap	#1
	add.l	#12,sp
	tst.l	d0
	rts

* Close a file

closfl:	move.w	handle,-(sp)
	move.w	#$3E,-(sp)
	trap	#1
	addq.l	#4,sp
	tst.w	d0
	rts

* This routine constructs an 8x16 font from 8x8

cnv16:	move.l	#usrfnt,a3	Double up all the character
	move.l	#hifont,a4	matrix bytes for hi res display
	move.l	#255,d3
lp16:	move.l	#7,d4
lp162:	move.b	(a3),(a4)
	add.l	#$0100,a4
	move.b	(a3),(a4)
	add.l	#$0100,a4
	add.l	#$0100,a3
	dbf	d4,lp162
	suba.l	#$07FF,a3
	suba.l	#$0FFF,a4
	dbf	d3,lp16
	rts

savfnm:	move.l	#file,a3
	move.l	#txb2,a4
	move.l	#shnm2,a2
	move.l	#15,d5
savf2:	clr.l	d4
	move.b	(a3),d4
	tst.b	d4
	beq	savf3
	move.b	(a3),(a4)+
	move.b	(a3)+,(a2)+
	dbf	d5,savf2
savf3:	clr.b	(a4)
	clr.b	(a2)
	rts

* Error handling routine

error:	move.l	#9,d1
	move.l	#errtbl,a4
err2:	cmp.w	-(a4),d0
	beq	err3
	dbf	d1,err2
	bra	errxit

err3:	move.l	#errtbl,a3
	lsl.b	#2,d1
	adda.l	d1,a3
	move.l	ertree,a4
	move.l	#errbox,d5
	bsr	obspec
	move.l	(a3),(a5)
	move.w	#$014,d5
	bsr	chngco
	move.l	ertree,boxadr
	clr.w	edtflg
	bsr	drawbx
	bsr	formdo
	bsr	closbx
	and.w	#$7FFF,selobj
	move.w	#%110000,state
	bsr	change
errxit:	bsr	closfl
	bsr	resttl
	rts

clrfil:	move.l	#file,a2	Clear out the filename storage area
	move.l	#15,d1		for fsel_input
clrf2	clr	(a2)+
	dbf	d1,clrf2
	rts

setfdi:	move.l	#fdinam,a5
	move.l	#file,a4
	move.l	#7,d5
cpyfnm:	move.b	(a4),d4
	tst.b	d4
	beq	sfxit1
	cmp.b	#".",d4
	beq	sfxit1
	move.b	(a4)+,(a5)+
	dbf	d5,cpyfnm
sfxit1:	clr.b	(a5)
	move.l	optree,a4
	move.l	#ousrbt,d5
	bsr	obspec
	move.l	#fdinam,(a5)
	move.l	#ousrbt,d5
	bsr	obstat
	and.w	#%110111,(a5)
	rts

* form_alert
* Enter with a5= address of definition string
*	     d5= number of default box

alert:	move.l	a5,addrin	Set address of string
	move.w	d5,intin	Set default box
	move.l	#f_alrt,aespb	Display alert box
	bra	aes

* fsel_input
* Enter with a0= address of directory name and buffer

fsel:	move.l	a0,temp		Save address of filespec
	move.l	#f_sel,aespb	Let's call fsel_input with opcode 90
	move.l	temp,addrin
	move.l	#file,addrin+4
	move.l	t_adr1,addrin+8
	move.l	t_adr2,addrin+12
	bsr	aes

	bsr	resscr
	move.l	itmadr,a0	Restore pointer to fsel_input text
	move.l	iasav,(a0)
	and.w	#$FE,-2(a0)
	move.w	ilensv,8(a0)

	clr.w	d0		Set current drive from output of
	move.l	temp,a0		fsel routine
	move.b	(a0),d0
	sub.b	#65,d0
	move.w	d0,-(sp)
	move.w	#$0E,-(sp)
	trap	#1
	addq.l	#4,sp
	move.l	temp,a0		Also set pathname from fsel
	addq.l	#2,a0
	move.l	#pathnm,a1
	move.l	#63,d5
pathlp:	tst.b	(a0)
	beq	plx1
	move.b	(a0)+,(a1)+
	dbf	d5,pathlp
plx1:	move.l	#63,d5
plp2:	cmp.b	#"\",-(a1)
	beq	plx2
	dbf	d5,plp2
plx2:	addq.l	#1,a1
	clr.b	(a1)
	pea	pathnm
	move.w	#$3B,-(sp)
	trap	#1
	addq.l	#6,sp
	bsr	finger
	rts

resttl:	move.l	#wtitle,a4
	bra	wndset

savscr:	dc.w	hidems
	move.l	screen,a2
	move.l	#sbuff,a3
	move.l	#7999,d1
svscrn:	move.l	(a2)+,(a3)+
	dbf	d1,svscrn
	bra	shmous

resscr:	move.l	#w_updt,aespb	Set wind_update so no drop-down menus
	move.w	#1,intin
	bsr	aes
	bsr	ress2
	clr.w	intin		Allow menus again
	bra	aes

ress2:	dc.w	hidems
	move.l	screen,a2	Restore screen from buffer
	move.l	#sbuff,a3
	move.l	#7999,d1
rescrn:	move.l	(a3)+,(a2)+
	dbf	d1,rescrn
	bra	shmous

bee:	move.w	#2,intin
	bra	grfm2
finger:	move.w	#3,intin	Set pointing finger cursor
grfm2:	move.l	#g_mous,aespb	graf_mouse (GEM p.384)
	bra	aes

* rsrc_gaddr
* Enter with: d5= number of object tree

g_addr:	move.l	#r_gadr,aespb	Get address of object tree using rsrc_gaddr
	clr.w	intin		re_gtype = tree structure
	move.w	d5,intin+2	re_gindex = tree number
	bra 	aes

* Calculate the address of an object status word
* Enter with: a4= object tree address
*	      d5= object index
* Exit with:  a5= address of status flags word

obstat:	move.l	a4,a5
	mulu	#24,d5
	add.l	#10,d5
	add.l	d5,a5
	rts

* Calculate the address of an object specification longword
* Enter with: a4= object tree address
*	      d5= object index
* Exit with:  a5= address of object spec longword

obspec:	move.l	a4,a5
	mulu	#24,d5
	add.l	#12,d5
	add.l	d5,a5
	rts

* wind_set

wndset:	move.l	#w_set,aespb	Use wind_set to set our window title
	move.l	#intin,a5	Enter with a4= address of title string
	move.w	whandl,(a5)+
	move.w	#2,(a5)+
	move.l	a4,(a5)
	bra	aes

w_set2:	move.l	#w_set,aespb	Use wind_set to set the info line
	move.l	#intin,a5
	move.w	whandl,(a5)+
	move.w	#3,(a5)+
	move.l	#infoln,(a5)
	bra	aes

* wind_open

wndopn:	move.l	#w_open,aespb	wind_open - open the dang window!
	move.l	#intin,a5
	move.w	whandl,(a5)+
	move.w	xdesk,(a5)+
	move.w	ydesk,(a5)+
	move.w	wdesk,(a5)+
	move.w	hdesk,(a5)
	bra	aes

* wind_close

wndclo:	move.l	#w_clos,aespb	wind_close
	move.w	whandl,intin
	bra	aes

* menu_tnormal

normal:	move.l	#contrl,a5	set fill interior style (GEM p.147)
	move.w	#23,(a5)
	clr.w	2(a5)
	move.w	#1,6(a5)
	move.w	ghandl,12(a5)
	move.w	#1,intin
	jsr	vdi

	move.l	#m_norm,aespb
	move.w	mntitl,intin
	move.w	#1,intin+2
	move.l	mntree,addrin
	bra	aes

* Dialog box drawing routine
* This routine draws an entire object tree
*
* Enter with boxadr= object tree address
*	     edtflg= index of editable text field (if any)

drawbx:	move.l	#f_cntr,aespb	First, let's call form_center
	move.l	boxadr,addrin
	bsr	aes
	move.w	intout+2,cx
	move.w	intout+4,cy
	move.w	intout+6,cw
	move.w	intout+8,ch

db2:	clr.w	diflag		Reserve screen buffer memory
	bsr	dial
	bsr	setgbc
	move.w	#1,diflag	Draw expanding box
	bsr	dial
	bsr	resgbc
	move.l	#o_cdrw,aespb	Now, let's call objc_draw
	clr.w	intin		Root object gets drawn first
	move.w	#5,intin+2	Up to 5 levels of subordinate objects
	move.w	cx,intin+4
	move.w	cy,intin+6
	move.w	cw,intin+8
	move.w	ch,intin+10
	move.l	boxadr,addrin
	bsr	aes
	rts

formdo:	move.l	#f_do,aespb	Here's where it all happens --- form_do
	move.w	edtflg,intin
	move.l	boxadr,addrin
	bsr	aes
	move.w	intout,selobj
	rts

closbx:	move.w	#3,diflag
	bsr	dial
	bsr	setgbc
	bsr	ress2
	move.w	#2,diflag
	bsr	dial
	bsr	resgbc
	move.l	#e_mult,aespb	Intercept the re-draw message
	move.w	#%010000,intin
	move.l	#mspipe,addrin
	bsr	aes
	rts

* objc_draw
* This routine redraws a single object
*
* Enter with strtob= index of object to draw
*	     depth=  # of subordinate objects to draw
*	     drtree= address of object tree
*	     mod_xy= x, y clipping rectangle modifier
*	     mod_wh= w, h    "         "        "

obdraw:	move.l	#o_coff,aespb	First, call objc_offset to get x & y
	move.w	strtob,intin	coordinates of object to draw
	move.l	drtree,addrin
	bsr	aes
	move.w	intout+2,d0
	add.w	mod_xy,d0
	move.w	d0,intin+4
	move.w	intout+4,d0
	add.w	mod_xy,d0
	move.w	d0,intin+6
	move.l	drtree,a5
	clr.l	d0
	move.w	strtob,d0	Get width and height coordinates directly
	mulu	#24,d0		from object tree
	add.l	d0,a5
	move.w	20(a5),d0
	sub.w	mod_wh,d0
	move.w	d0,intin+8
	move.w	22(a5),d0
	sub.w	mod_wh,d0
	move.w	d0,intin+10

	move.l	#o_cdrw,aespb
	move.w	strtob,intin
	move.w	depth,intin+2
	move.l	drtree,addrin
	bra	aes

* form_dial

dial:	move.l	#o_coff,aespb	Call objc_offset to get x, y coordinates
	move.w	mntitl,intin	of selected menu title
	move.l	mntree,addrin
	bsr	aes
	move.l	#f_dial,aespb
	move.w	diflag,intin
	move.l	mntree,a4	Now take the width and height coordinates
	move.w	mntitl,d5	directly from the object tree
	bsr	obspec
	move.w	intout+2,intin+2
	move.w	intout+4,intin+4
	move.w	8(a5),intin+6
	move.w	10(a5),intin+8
cntrs2:	move.w	cx,intin+10
	move.w	cy,intin+12
	move.w	cw,intin+14
	move.w	ch,intin+16
	bsr	aes
	rts

* objc_change

change:	move.l	#o_chng,aespb
	move.w	selobj,intin
	clr.w	intin+2
	move.w	cx,intin+4
	move.w	cy,intin+6
	move.w	cw,intin+8
	move.w	ch,intin+10
	move.w	state,intin+12
	clr.w	intin+14
	move.l	boxadr,addrin
	bsr	aes
	rts

setgbc:	move.w	#-1,-(sp)	Save color for growing/shrinking box
	move.w	#1,-(sp)
	move.w	#7,-(sp)
	trap	#14
	addq.l	#6,sp
	move.w	d0,colsv1
	move.w	#$675,-(sp)	Set box color
	move.w	#1,-(sp)
	move.w	#7,-(sp)
	trap	#14
	addq.l	#6,sp
	rts

resgbc:	move.w	colsv1,-(sp)	Restore color
	move.w	#1,-(sp)
	move.w	#7,-(sp)
	trap	#14
	addq.l	#6,sp
	rts

shmous:	dc.w	init_a		Show mouse unconditionally
	move.l	4(a0),a1	(Number of hides doesn't matter)
	clr.w	2(a1)
	move.w	#1,6(a1)
	move.l	8(a0),a1
	clr.w	(a1)
	dc.w	showms
	rts

* VDI and AES subroutines

vdi:	move.l	#vdipb,d1
	move.l	#$73,d0
	trap	#2
	rts

aes:	move.l	#aespb,d1
	move.l	#$c8,d0
	trap	#2
	rts

* Draw a rectangle with VDI

drrect:	dc.w	hidems
	move.l	#contrl,a5	Turn off clipping
	move.w	#129,(a5)
	move.w	#2,2(a5)
	move.w	#1,6(a5)
	move.w	ghandl,12(a5)
	clr.w	intin
	clr.l	ptsin
	jsr	vdi

	move.l	#contrl,a5	set fill interior style (GEM p.147)
	move.w	#23,(a5)
	clr.w	2(a5)
	move.w	#1,6(a5)
	move.w	ghandl,12(a5)
	move.w	#1,intin
	jsr	vdi
	move.l	#contrl,a5	set fill color index (GEM p.151)
	move.w	#25,(a5)
	clr.w	2(a5)
	move.w	#1,6(a5)
	move.w	ghandl,12(a5)
	clr.w	intin		color 0 = background
	jsr	vdi

	move.l	#contrl,a5	Fill it
	move.w	#114,(a5)
	move.w	#2,2(a5)
	clr.w	6(a5)
	move.w	ghandl,12(a5)
	move.l	#ptsin,a5
	cmp.w	#2,res		Hi res?
	bne	nothi1
	move.l	#h_ptb1,a4
	bra	nothi2
nothi1:	move.l	#l_ptb1,a4
nothi2:	move.l	#3,d5
ptlp1:	move.w	(a4)+,(a5)+
	dbf	d5,ptlp1
	jsr	vdi

	move.l	#contrl,a5	Now draw the polyline
	move.w	#6,(a5)
	move.w	#5,2(a5)
	clr.w	6(a5)
	move.w	ghandl,12(a5)
	move.l	#ptsin,a5
	cmp.w	#2,res
	bne	nothi3
	move.l	#h_ptb2,a4
	bra	nothi4
nothi3:	move.l	#l_ptb2,a4
nothi4:	move.l	#9,d5
ptlp2:	move.w	(a4)+,(a5)+
	dbf	d5,ptlp2
	jsr	vdi

	move.w	#72,xc
	cmp.w	#2,res
	bne	nothi5
	move.w	#346,yc
	bra	nothi6
nothi5:	move.w	#173,yc
nothi6:	move.l	#char1,a5
	bsr	dotxtb
	move.w	#64,xc
	cmp.w	#2,res
	bne	nothi7
	move.w	#366,yc
	bra	nothi8
nothi7:	move.w	#183,yc
nothi8:	move.l	#char2,a5
	bsr	dotxtb
	bsr	shmous

	move.l	#contrl,a5	Reset fill interior style
	move.w	#23,(a5)
	clr.w	2(a5)
	move.w	#1,6(a5)
	move.w	ghandl,12(a5)
	move.w	#2,intin
	jsr	vdi

	rts

* Line A TEXTBLT routine used to
* print font name in upper right corner

prtfnt:	move.w	#432,xc
	move.w	#1,yc
	move.l	#clfmsg,a5
	bsr	dotxtb
	move.w	#432,xc
	move.w	#1,yc
	move.l	#txbmsg,a5
	bsr	dotxtb
	rts

* Call TEXTBLT
* Enter with a5= address of string to output
*	     xc= starting x position
*	     yc= starting y position

dotxtb:	move.l	a5,temp
getchr:	move.l	temp,a3
	clr.w	char
	move.b	(a3)+,char
	move.l	a3,temp
	tst.b	char
	beq	dotx1
	bsr	txtblt
	addq.w	#8,xc
	bra	getchr
dotx1:	rts

* The TEXTBLT subroutine (thanks, Barnaby)

txtblt:	dc.w	init_a
	move.l	a0,a5		save line A offset
	move.l	a1,a4		save font pointer table address
	cmp.w	#2,res
	bne	txtb2
	move.l	8(a4),a4
	bra	txtb3
txtb2:	move.l	4(a4),a4	get address of 8x8 system font
txtb3:	clr.w	wmode(a5)	replace mode
	move.w	#3,textfg(a5)	foreground color
	clr.w	textbg(a5)	background color
	cmp.w	#2,res
	bne	txtb4
	move.l	#hifont,fbase(a5)
	bra	txtb5
txtb4:	move.l	#usrfnt,fbase(a5)	font data pointer
txtb5:	move.w	80(a4),fwidth(a5)	form width
	clr.l	d5
	move.b	char,d5
	lsl.w	#3,d5
	move.w	d5,sourcex(a5)	character (ascii x 8)
	clr.w	sourcey(a5)	always zero
	move.w	xc,destx(a5)	x co.
	move.w	yc,desty(a5)	y co.
	move.w	#8,delx(a5)	char width (offset table = 8)
	move.w	82(a4),dely(a5)	char height = form height
	clr.w	style(a5)	no style flags
	move.w	62(a4),litemsk(a5)	lite mask (usually $5555)
	move.w	64(a4),skewmsk(a5)	italic mask ($5555)
	move.w	58(a4),weight(a5)	thicken by pixel
	move.w	56(a4),roff(a5)	right offset for italics
	move.w	54(a4),loff(a5)	left offset for italics
	clr.w	scale(a5)	no scaling
	move.w	#$8000,xdda(a5)	always $8000
	move.w	#$ffff,ddainc(a5)	if scaling,$ffff will do it
	move.w	#1,scaldir(a5)	if scaling, 1 means enlarge
	clr.w	chup(a5)	no rotation
	move.w	#1,mono(a5)	monospaced (try changing this)
	move.l	#txtbuf,scrtchp(a5)	special effects buffer
	move.w	#100,scrpt2(a5)	offset of enlargement buffer
	dc.w	textblt
	rts

* Data, buffers, etc.

	data
	even
ufont:	dc.b	0
shoflg:	dc.b	0	

wrong:	dc.b	"[3][ This program only |"
	dc.b	" works in medium or |"
	dc.b	" high resolution!   |"
	dc.b	" ]"
	dc.b	"[  ABORT  ]"

norsc:	dc.b	"[3][ Can't find resource file |"
	dc.b	' |     STPRINT.RSC |'
	dc.b	' ]'
	dc.b	'[  ABORT  ]'

	dc.b	27,'Y',12+32,45+32
cntmsg:	ds.b	12

	even
wtitle:	dc.b	' ST FONT PRINTER ',0,0
wsetd:	dc.b	' SET CURRENT DRIVE ',0,0
wpopt:	dc.b	' SET PRINT OPTIONS ',0,0
wptyp:	dc.b	' SET PRINTER TYPE ',0,0
wexit:	dc.b	' EXIT ',0,0
wldde:	dc.b	' LOAD DEGAS FONT ',0,0
wld8b:	dc.b	' LOAD 8-BIT FONT ',0,0
wwrtde:	dc.b	' WRITE DEGAS FONT ',0,0
wwrt8b:	dc.b	' WRITE 8-BIT FONT ',0,0
wtypl:	dc.b	' TYPE-A-LINE ',0,0
wprtf:	dc.b	' PRINT FILE ',0,0
wadrlb:	dc.b	' ADDRESS LABELS ',0,0

infoln:	dc.b	' Font:'
ifont:	dc.b	'SYSTEM     Size:'
isize:	dc.b	'Small   Perf:'
iperf:	dc.b	'Yes   Reset:'
irest:	dc.b	'Yes   Spacing:'
ispac:	dc.b	'1/6 in   Margin:'
imrgn:	dc.b	'05',0,0

nsys:	dc.b	'SYSTEM',0
nszsm:	dc.b	'Small'
nszlg:	dc.b	'Large'
nyes:	dc.b	'Yes'
nno:	dc.b	'No '
n16in:	dc.b	'1/6 in'
n18in:	dc.b	'1/8 in'
n19in:	dc.b	'1/9 in'

err32:	dc.b	" Invalid function number ",0
err33:	dc.b	" File not found ",0
err34:	dc.b	" Pathname not found ",0
err35:	dc.b	" Too many files open ",0
err36:	dc.b	" Access not possible ",0
err37:	dc.b	" Invalid handle number ",0
err39:	dc.b	" Not enough memory ",0
err40:	dc.b	" Invalid memory block address ",0
err46:	dc.b	" Invalid drive specification ",0
err49:	dc.b	" No more files ",0

fdinam:	dc.b	'          ',0

clfmsg:	dc.b	'                        ',0

txbmsg:	dc.b	'Font Name: '
txb2:	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

shonam:	dc.b	'  Show '
shnm2:	ds.b	24

	.even
	ds.w	1
	dc.l	itmtxt

itmtxt:	dc.b	'ITEM SELECTOR',0

i_deg:	dc.b	' Load which DEGAS Font? ',0
i_fn8:	dc.b	' Load which 8-bit Font? ',0
i_wrt8:	dc.b	' Write 8-bit Font to which file? ',0
i_wrtd:	dc.b	' Write DEGAS Font to which file? ',0
i_prt:	dc.b	' Print which text file? ',0

shosys:	dc.b	'  Show System Font',0

id_len	=	i_fn8-i_deg-1
i8_len	=	i_wrt8-i_fn8-1
iw8len	=	i_wrtd-i_wrt8-1
iwdlen	=	i_prt-i_wrtd-1
ip_len	=	shosys-i_prt-1

i_deg1:	dc.b	'Load',0
i_deg2:	dc.b	'DEGAS Font',0

i_fn81:	dc.b	'Load',0
i_fn82:	dc.b	'8-bit Font',0

i_wr81:	dc.b	'Write',0
i_wr82:	dc.b	'8-bit Font',0

i_wrd1:	dc.b	'Write',0
i_wrd2:	dc.b	'DEGAS Font',0

i_prt1:	dc.b	'Print',0
i_prt2:	dc.b	'Text File',0

fdmsg:	dc.b	'.FNT',0
f8msg:	dc.b	'.FN8',0

fnamms:	dc.b	'Filename: ',0

pmargn:	dc.b	esc,"l"
margin:	dc.b	5

prfcom:	dc.b	esc,"N",5

rspcom:	dc.b	esc,"@"

sixcom:	dc.b	esc,'A',12,esc,'2'

eigcom:	dc.b	esc,'A',9,esc,'2'

nincom:	dc.b	esc,'A',8,esc,'2'

rscnam:	dc.b	"STPRINT.RSC",0

sixlen:	dc.b	eigcom-sixcom
eiglen:	dc.b	nincom-eigcom
ninlen:	dc.b	rscnam-nincom

	even
fdext:	dc.b	':\*.FN8',0
pdext:	dc.b	':\*.DOC',0
ddext:	dc.b	':\*.FNT',0

	even
palete:	dc.w	$777,$036,$045,$000
	ds.w	12

h_ptb1:	dc.w	60,342,580,386
l_ptb1:	dc.w	60,171,580,193

h_ptb2:	dc.w	60,342,580,342,580,386,60,386,60,342
l_ptb2:	dc.w	60,171,580,171,580,193,60,193,60,171

errval:	dc.w	-32,-33,-34,-35,-36
	dc.w	-37,-39,-40,-46,-49

errtbl:	dc.l	err32,err33,err34,err35,err36
	dc.l	err37,err39,err40,err46,err49

a_init:	dc.w	10,0,1,0,0
a_exit:	dc.w	19,0,0,0,0
f_alrt:	dc.w	52,1,1,1,0
f_cntr:	dc.w	54,0,5,1,0
f_dial:	dc.w	51,9,1,1,0
f_do:	dc.w	50,1,2,1,0
o_cdrw:	dc.w	42,6,1,1,0
o_chng:	dc.w	47,8,1,1,0
o_coff:	dc.w	44,1,3,1,0
g_hand:	dc.w	77,0,5,0,0
g_mous:	dc.w	78,1,1,1,0
r_load:	dc.w	110,0,1,1,0
r_gadr:	dc.w	112,2,1,0,1
w_get:	dc.w	104,2,5,0,0
w_crea:	dc.w	100,5,1,0,0
w_set:	dc.w	105,6,1,0,0
w_updt:	dc.w	107,1,1,0,0
w_open:	dc.w	101,5,5,0,0
w_clos:	dc.w	102,1,1,0,0
w_del:	dc.w	103,1,1,0,0
m_bar:	dc.w	30,1,1,1,0
m_norm:	dc.w	33,2,1,1,0
e_mult:	dc.w	25,16,7,1,0
f_sel:	dc.w	90,0,2,4,0

vdipb:	dc.l	contrl,intin,ptsin,intout,ptsout
aespb:	dc.l	contrl,global,intin,intout,addrin,addrout

header:	dc.b	esc
grmode:	dc.b	76
outcnt:	dc.w	0

	bss
outbuf:	ds.b	$0500		This must immediately follow outcnt!

usrfnt:	ds.b	$0800		The actual font data

hifont:	ds.b	$1000		Font data for 8x16 mode

b8font:	ds.b	$0400		8-bit font storage area

degfnt:	ds.b	$0802		DEGAS font storage area

res:	ds.w	1
colsav:	ds.w	4
colsv1:	ds.w	1

mntree:	ds.l	1		This is the object tree
titree:	ds.l	1		address storage area
optree:	ds.l	1
extree:	ds.l	1
ertree:	ds.l	1
pmtree:	ds.l	1
petree:	ds.l	1
pltree:	ds.l	1
tptree:	ds.l	1
bgtree:	ds.l	1
lbtree:	ds.l	1
dvtree:	ds.l	1
smtree:	ds.l	1
totree:	ds.l	1

boxadr:	ds.l	1
showsv:	ds.l	1
shstsv:	ds.l	1
mwdesv:	ds.l	1
mw8bsv:	ds.l	1
fsavt:	ds.l	1
fsav1:	ds.l	1
fsav2:	ds.l	1
wtsav:	ds.l	1
itmadr:	ds.l	1
iasav:	ds.l	1
number:	ds.l	1
t_adr1:	ds.l	1
t_adr2:	ds.l	1

ilensv:	ds.w	1
mntitl:	ds.w	1
obindx:	ds.w	1

edtflg:	ds.w	1
diflag:	ds.w	1
tlflag:	ds.w	1
nofflg:	ds.w	1
tiflag:	ds.w	1

lmsav:	ds.w	1
savfs:	ds.w	1
savfu:	ds.w	1
datsav:	ds.w	1
timsav:	ds.w	1
xdesk:	ds.w	1
ydesk:	ds.w	1
wdesk:	ds.w	1
hdesk:	ds.w	1
cx:	ds.w	1
cy:	ds.w	1
cw:	ds.w	1
ch:	ds.w	1
mod_xy:	ds.w	1
mod_wh:	ds.w	1
xc:	ds.w	1
yc:	ds.w	1
strtob:	ds.w	1
depth:	ds.w	1
drtree:	ds.l	1
selobj:	ds.w	1
state:	ds.w	1
temp:	ds.l	1
char:	ds.w	1
screen:	ds.l	1
fntptr:	ds.l	1
sysfad:	ds.l	1
tabcnt:	ds.w	1
perflg:	ds.w	1
rspflg:	ds.w	1
lsflag:	ds.w	1
fntflg:	ds.w	1
lblnum:	ds.w	1
handle:	ds.w	1
ghandl:	ds.w	1
whandl:	ds.w	1
digcnt:	ds.w	1

nummsg:	ds.b	12

char1:	ds.b	64
char2:	ds.b	65

ascdec:	ds.b	6

	even
fdir:	ds.b	64
pdir:	ds.b	64
ddir:	ds.b	64
dta:	ds.b	44
mspipe:	ds.b	16
file:	ds.b	16
pathnm:	ds.b	64
os_sav:	ds.w	64

txtbuf:	ds.b	1000

* GEM arrays

	.even
contrl:	ds.w	12
intin:	ds.w	128
ptsin:	ds.w	128
intout:	ds.w	128
ptsout:	ds.w	128
global:
apvrsn:	ds.w	1
apcont:	ds.w	1
apid:	ds.w	1
apprvt:	ds.l	1
apptre:	ds.l	1
ap1rsv:	ds.l	1
ap2rsv:	ds.l	1
ap3rsv:	ds.l	1
ap4rsv:	ds.l	1

addrin:	ds.w	128
addrout:ds.w	128

	ds.l	300		Reserve 1200 bytes for stack
ustack:	ds.l	1
	ds.w	10

sbuff:	ds.b	$7D00		Temporary screen storage

* Text buffer (100K = maximum text file size)

buffer:	ds.b	$19002
