;*************************************************
;*                   DIALXR                      *
;*                 by Maloney                    *
;*                                               *
;*         Copyright 1988 by ST-Log              *
;*                                               *
;*************************************************
;
               text
install_do     pea       super_do       ;address of subroutine
               move.w    #38,-(sp)      ;superexec funtion code
               trap      #14            ;call XBIOS
               addq.l    #6,sp          ;pop stack

               clr.w     -(sp)          ;no error code
               move.l    #760,-(sp)     ;bytes to keep
               move.w    #$31,-(sp)     ;keep function code
               trap      #1             ;call GEMDOS

super_do       move.w    #6,d0          ;index value
               movea.l   #$4d2,a0       ;_vbl_list + 4
loop           tst.l     (a0)+          ;is vector available?
               dbeq      d0,loop        ;if not take branch

               move.l    #vbl_do,-(a0)  ;store address in vbl vector

vector_change  move.l    $b4,BIOS_default    ;store old address
               move.l    #BIOS_mod_do,$b4    ;store new address
               
super_exit     rts                      ;return to continue

BIOS_mod_do    cmpi.w    #1,8(sp)       ;is device RS-232?
               bne.s     trap13_normal  ;if not take branch

dcd_test       btst.b    #1,$fffffa01   ;are we on-line?
               beq.s     trap13_normal  ;if so take branch

bconout_test   cmpi.w    #3,6(sp)       ;is it bconout?
               bne.s     trap13_normal  ;if not take branch

D_test         cmpi.b    #68,11(sp)     ;is character "D"?
               bne.s     CR_test        ;if not take branch

               bset.b    #0,status_flag ;set prelim bit

CR_test        cmpi.b    #13,11(sp)     ;is character CR?
               bne.s     trap13_normal  ;if not take branch

               btst.b    #0,status_flag ;is prelim bit set?
               beq.s     cancel         ;if not take branch

               btst.b    #1,status_flag ;is dial bit set?
               bne.s     cancel         ;if so take branch

               move.l    $4ba,timer     ;store current time
               addi.l    #6000,timer    ;add 30 seconds
               bset.b    #1,status_flag ;set dial bit
               bra.s     trap13_normal  ;branch always

cancel         clr.b     status_flag    ;reset all bits

trap13_normal  move.l    BIOS_default,a0     ;default trap 13
               jmp       (a0)           ;jump to it

alert_do       move.l    $4a2,-(sp)     ;push current address
               sub.l     #46,$4a2       ;make room

               move.w    #7,-(sp)       ;Control-g (ring bell)
               move.l    #$00030002,-(sp)    ;console and bconout
               trap      #13            ;call BIOS
               addq.l    #6,sp          ;pop stack

               move.l    (sp)+,$4a2     ;pop address

               move.l    $ffff8240,-(sp)     ;push palette regs 0 & 1
               move.w    (sp)+,$ffff8242     ;pop 0 to palette reg 1
               move.w    (sp)+,$ffff8240     ;pop 1 to palette reg 0

               rts                      ;return to continue vbl_do

vbl_do         btst.b    #1,status_flag ;is dial bit on?
               beq.s     vbl_exit       ;if not take branch

               btst.b    #1,$fffffa01   ;are we on-line?
               bne.s     redial_test    ;if not take branch

               btst.b    #2,status_flag ;is connect bit set?
               bne.s     alert_test     ;if so take branch

               bsr.s     alert_do       ;ring bell and reverse screen

               bset.b    #2,status_flag ;set connect bit
               move.b    #15,timer_A    ;set timer to 1/4 second
               rts                      ;return to vbl int handler

alert_test     subq.b    #1,timer_A     ;time for alert_do?
               bne.s     vbl_exit       ;if not take branch

               bsr.s     alert_do       ;ring bell and reverse screen

               clr.b     status_flag    ;disable redial

vbl_exit       rts                      ;return to vbl int handler

redial_test    move.l    timer,d0       ;get target time
               cmp.l     $4ba,d0        ;is wait finished?
               bpl.s     vbl_exit       ;if not take branch

               btst.b    #3,status_flag ;is redial bit set?
               bne.s     redial_do      ;if so take branch
               
               move      sr,-(sp)       ;push status register
               ori       #$0700,sr      ;disable interrupts
               move.w    $ffff8800,-(sp)     ;push last register used
               move.b    #14,$ffff8800  ;select port A
               bset.b    #4,$ffff8802   ;set dtr bit
               move.w    (sp)+,$ffff8800     ;pop last register used
               move      (sp)+,sr       ;pop status register

               move.l    $4ba,timer     ;store current time
               addi.l    #400,timer     ;add two seconds
               bset.b    #3,status_flag ;set redial bit
               rts                      ;return to vbl int handler

redial_do      move      sr,-(sp)       ;push status register
               ori       #$0700,sr      ;disable interrupts
               move.w    $ffff8800,-(sp)     ;push last register used
               move.b    #14,$ffff8800       ;select port A
               bclr.b    #4,$ffff8802        ;reset dtr bit
               move.w    (sp)+,$ffff8800     ;pop last register used
               move      (sp)+,sr       ;pop status register

               move.l    $4a2,-(sp)     ;push current address
               sub.l     #46,$4a2       ;make room

               move.w    #65,-(sp)      ;"A"
               move.l    #$00030001,-(sp)    ;RS-232 & bconout
               trap      #13            ;call BIOS
               addq.l    #6,sp          ;pop stack

               move.w    #47,-(sp)      ;"/"
               move.l    #$00030001,-(sp)    ;RS-232 & bconout
               trap      #13            ;call BIOS
               addq.l    #6,sp          ;pop stack

               move.l    (sp)+,$4a2     ;pop address

               move.l    $4ba,timer     ;store current time
               addi.l    #6000,timer    ;add 30 seconds
               bclr.b    #3,status_flag ;reset redial bit

               rts                      ;return to vbl int handler

               bss                
BIOS_default   ds.l      1
timer          ds.l      1
status_flag    ds.b      1
;status_flag bit assignments:
;    0    prelim
;    1    dial
;    2    connect
;    3    redial
timer_A        ds.b      1

               end
