*   Omni Life assembly module    *
*         by Tom Hudson          *
* Copyright 1987 ST-LOG Magazine *

.globl _cell
.globl _clr_sc
.globl _cop_sc
.globl _life2d
.globl _life3d
.globl _birthL
.globl _birthH
.globl _deathL
.globl _deathH
.globl _runtype
.globl _stereo
.globl _lmap
.globl _rmap

.globl _LEFTS
.globl _RIGHTS
.globl _MASKS
.globl _quikblit

.text

* Fast screen clearing routine.  Clears 32000 bytes.	*
* Call:  clr_sc(LONG address of screen)			*

_clr_sc:
move.l 4(a7),a0
move.w #1000,d1

csc_loop:
clr.l (a0)+
clr.l (a0)+
clr.l (a0)+
clr.l (a0)+
clr.l (a0)+
clr.l (a0)+
clr.l (a0)+
clr.l (a0)+
subq.w #1,d1
bne csc_loop
rts

* Screen copier.  Copies 32000 bytes from source to destination	*
* Call:  cop_sc(LONG destination address, LONG source address)	*

_cop_sc:
move.l 8(a7),a0
move.l 4(a7),a1
move.w #1000,d1

cop_loop:
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
subq.w #1,d1
bne cop_loop
rts

* 2-D Life algorithm *

_life2d:
movem.l d3-d7/a3-a6,-(sp)

move.l #_cell,a5	;point A5 to cell array
move.l #_cell2,a4	;point A4 to next generation array

move.b _birthL,d0	;get LIFE parameters in D0-D3
move.b _birthH,d1
move.b _deathL,d2
move.b _deathH,d3

tst.w _runtype		;doing lookdown?
beq lookdn		;yes!
move.l #do_cell,a0	;point to normal cell plotter
bra set_Y		;and continue.

lookdn:
move.l #do_cell2,a0	;point to lookdown plotter

set_Y:
move.w #10,d6		;Y always 10 for 2-D (used for display only)

clr.w d7		;Z

x2_row:
clr.w d5		;X

looper2:
clr.b d4		;reset cell count

tst.w d5		;is X = 0?
bne xg02

* X = 0 *

tst.w d7		;is Z = 0?
bne xe0zg02

* X=0, Z=0 *

add.b 1(a5),d4

add.b 32(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim2

add.b 31+992(a5),d4
add.b 992(a5),d4
add.b 1+992(a5),d4

add.b 31(a5),d4

add.b 31+32(a5),d4

bra chklim2

xe0zg02:
cmp.w #31,d7		;Z = 31?
beq x0z312

* X=0, Z=n *

add.b -32(a5),d4
add.b 1-32(a5),d4

add.b 1(a5),d4

add.b 32(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim2

add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4

bra chklim2

* X=0, Z=31 *

x0z312:
add.b -32(a5),d4
add.b 1-32(a5),d4

add.b 1(a5),d4

tst.w _wrap
beq chklim2

add.b 31-32(a5),d4

add.b 31(a5),d4

add.b 31-992(a5),d4
add.b -992(a5),d4
add.b 1-992(a5),d4

bra chklim2

* X>0 *

xg02:
cmp.w #31,d5		;X = 31?
beq xe312

tst.w d7		;Z = 0?
bne xnzg02

* X=n, Z=0 *

add.b -1(a5),d4
add.b -1+32(a5),d4

add.b 32(a5),d4

add.b 1(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim2

add.b -1+992(a5),d4
add.b 992(a5),d4
add.b 1+992(a5),d4

bra chklim2

xnzg02:
cmp.w #31,d7		;is Z = 31?
beq xnz312

* X=n, Z=n *

add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4

add.b -32(a5),d4
add.b 32(a5),d4

add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4

bra chklim2

* X=n, Z=31 *

xnz312:

add.b -1-32(a5),d4
add.b -32(a5),d4
add.b 1-32(a5),d4

add.b -1(a5),d4
add.b 1(a5),d4

tst.w _wrap
beq chklim2

add.b -1-992(a5),d4
add.b -992(a5),d4
add.b 1-992(a5),d4

bra chklim2

* X=31 *

xe312:
tst.w d7		;is Z = 0?
bne xe31zg02

* X=31, Z=0 *

add.b -1(a5),d4

add.b -1+32(a5),d4
add.b 32(a5),d4

tst.w _wrap
beq chklim2

add.b -1+992(a5),d4
add.b 992(a5),d4
add.b -31+992(a5),d4

add.b -31(a5),d4

add.b -31+32(a5),d4

bra chklim2

xe31zg02:
cmp.w #31,d7		;is Z = 31?
beq x31z312

* X=31, Z=n *

add.b -1-32(a5),d4
add.b -32(a5),d4

add.b -1(a5),d4

add.b -1+32(a5),d4
add.b 32(a5),d4

tst.w _wrap
beq chklim2

add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4

bra chklim2

* X=31, Z=31 *

x31z312:
add.b -1-32(a5),d4
add.b -32(a5),d4

add.b -1(a5),d4

tst.w _wrap
beq chklim2

add.b -31-32(a5),d4

add.b -31(a5),d4

add.b -1-992(a5),d4
add.b -992(a5),d4
add.b -31-992(a5),d4

* CHECK NEIGHBORS *

chklim2:
tst.b (a5)+		;is cell alive this generation?
bne live2_one		;yes!

* See if cell is born *

cmp.b d0,d4		;too few for birth?
bmi dead2		;yes!
cmp.b d1,d4		;too many?
bgt dead2		;yes!
bra alive2		;it's ALIVE!

* See if cell is still alive *

live2_one:
cmp.b d2,d4		;too few neighbors to live?
bmi dead2		;yes!
cmp.b d3,d4		;too many neighbors to live?
bgt dead2		;yes!

* Cell is alive!  Set state & plot *

alive2:
addq.w #1,_cellcount	;increment live cells

move.b #1,(a4)+		;set the cell to 1 (alive)

jsr (a0)		;plot the cell on the screen!

bra incpos2		;and continue

* No cell *

dead2:
clr.b (a4)+		;set cell to 0 (dead)

incpos2:
addq.w #1,d5		;increment X coord
cmp.w #32,d5		;at end of row?
bne looper2		;no!  Loop back.

addq.w #1,d7		;increment Z coord
cmp.w #32,d7		;at end of row?
bne x2_row		;no!  Loop for more.

* Now copy new cell array to old one *

move.l #_cell2,a0
move.l #_cell,a1
move.w #32,d0

new_2cells:
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
subq.w #1,d0
bne new_2cells

movem.l (sp)+,d3-d7/a3-a6
rts

* 3-D Life algorithm *

_life3d:
movem.l d3-d7/a3-a6,-(sp)

move.l #_cell,a5	;point to cell array
move.l #_cell2,a4	;point to next generation cell array

move.b _birthL,d0	;get LIFE parameters
move.b _birthH,d1
move.b _deathL,d2
move.b _deathH,d3

clr.w d7		;Z = 0

y_slice:
clr.w d6		;Y = 0

x_row:
clr.w d5		;X = 0

looper:
clr.b d4		;reset cell count

tst.w d5		;X = 0?
bne xg0

* X = 0 *

tst.w d6		;Y = 0?
bne xe0yg0

* X=0, Y=0 *

tst.w d7		;Z = 0?
beq x0y0z0
cmp.w #31,d7		;Z = 31?
beq x0y0z31

x0y0zn:
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b 32(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b 31+992-1024(a5),d4
add.b 31-1024(a5),d4
add.b 31+32-1024(a5),d4
add.b 31+992(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4
add.b 31+992+1024(a5),d4
add.b 31+1024(a5),d4
add.b 31+32+1024(a5),d4

add.b 992-1024(a5),d4
add.b 992(a5),d4
add.b 992+1024(a5),d4

add.b 1+992-1024(a5),d4
add.b 1+992(a5),d4
add.b 1+992+1024(a5),d4

bra chklim

x0y0z0:
add.b 32(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b 31+992+31744(a5),d4
add.b 31+31744(a5),d4
add.b 31+32+31744(a5),d4
add.b 31+992(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4
add.b 31+992+1024(a5),d4
add.b 31+1024(a5),d4
add.b 31+32+1024(a5),d4

add.b 992+31744(a5),d4
add.b 31744(a5),d4
add.b 32+31744(a5),d4
add.b 992(a5),d4
add.b 992+1024(a5),d4

add.b 1+992+31744(a5),d4
add.b 1+31744(a5),d4
add.b 1+32+31744(a5),d4
add.b 1+992(a5),d4
add.b 1+992+1024(a5),d4
bra chklim

x0y0z31:
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b 32(a5),d4

add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim

add.b 31+992-1024(a5),d4
add.b 31-1024(a5),d4
add.b 31+32-1024(a5),d4
add.b 31+992(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4
add.b 31+992-31744(a5),d4
add.b 31-31744(a5),d4
add.b 31+32-31744(a5),d4

add.b 992-1024(a5),d4
add.b 992(a5),d4
add.b 992-31744(a5),d4
add.b -31744(a5),d4
add.b 32-31744(a5),d4

add.b 1+992-1024(a5),d4
add.b 1+992(a5),d4
add.b 1+992-31744(a5),d4
add.b 1-31744(a5),d4
add.b 1+32-31744(a5),d4
bra chklim

xe0yg0:
cmp.w #31,d6		;Y = 31?
bne xe0yl31

* X=0, Y=31 *

tst.w d7		;Z = 0?
beq x0y31z0
cmp.w #31,d7		;Z = 31?
beq x0y31z31

x0y31zn:
add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b -32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4

tst.w _wrap
beq chklim

add.b 31-32-1024(a5),d4
add.b 31-1024(a5),d4
add.b 31-992-1024(a5),d4
add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31-992(a5),d4
add.b 31-32+1024(a5),d4
add.b 31+1024(a5),d4
add.b 31-992+1024(a5),d4

add.b -992-1024(a5),d4
add.b -992(a5),d4
add.b -992+1024(a5),d4

add.b 1-992-1024(a5),d4
add.b 1-992(a5),d4
add.b 1-992+1024(a5),d4
bra chklim

x0y31z0:
add.b -32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4

add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4

tst.w _wrap
beq chklim

add.b 31-32+31744(a5),d4
add.b 31+31744(a5),d4
add.b 31-992+31744(a5),d4
add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31-992(a5),d4
add.b 31-32+1024(a5),d4
add.b 31+1024(a5),d4
add.b 31-992+1024(a5),d4

add.b -32+31744(a5),d4
add.b 31744(a5),d4
add.b -992+31744(a5),d4
add.b -992(a5),d4
add.b -992+1024(a5),d4

add.b 1-32+31744(a5),d4
add.b 1+31744(a5),d4
add.b 1-992+31744(a5),d4
add.b 1-992(a5),d4
add.b 1-992+1024(a5),d4
bra chklim

x0y31z31:
add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b -32(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4

tst.w _wrap
beq chklim

add.b 31-32-1024(a5),d4
add.b 31-1024(a5),d4
add.b 31-992-1024(a5),d4
add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31-992(a5),d4
add.b 31-32-31744(a5),d4
add.b 31-31744(a5),d4
add.b 31-992-31744(a5),d4

add.b -992-1024(a5),d4
add.b -992(a5),d4
add.b -32-31744(a5),d4
add.b -31744(a5),d4
add.b -992-31744(a5),d4

add.b 1-992-1024(a5),d4
add.b 1-992(a5),d4
add.b 1-32-31744(a5),d4
add.b 1-31744(a5),d4
add.b 1-992-31744(a5),d4
bra chklim

* X=0, Y<31 *

xe0yl31:
tst.w d7		;Z = 0?
beq x0ynz0
cmp.w #31,d7		;Z = 31?
beq x0ynz31

x0ynzn:
add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b -32(a5),d4
add.b 32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b 31-32-1024(a5),d4
add.b 31-1024(a5),d4
add.b 31+32-1024(a5),d4
add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4
add.b 31-32+1024(a5),d4
add.b 31+1024(a5),d4
add.b 31+32+1024(a5),d4
bra chklim

x0ynz0:
add.b -32(a5),d4
add.b 32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b 31-32+31744(a5),d4
add.b 31+31744(a5),d4
add.b 31+32+31744(a5),d4
add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4
add.b 31-32+1024(a5),d4
add.b 31+1024(a5),d4
add.b 31+32+1024(a5),d4

add.b -32+31744(a5),d4
add.b 31744(a5),d4
add.b 32+31744(a5),d4

add.b 1-32+31744(a5),d4
add.b 1+31744(a5),d4
add.b 1+32+31744(a5),d4
bra chklim

x0ynz31:
add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b -32(a5),d4
add.b 32(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim

add.b 31-32-1024(a5),d4
add.b 31-1024(a5),d4
add.b 31+32-1024(a5),d4
add.b 31-32(a5),d4
add.b 31(a5),d4
add.b 31+32(a5),d4
add.b 31-32-31744(a5),d4
add.b 31-31744(a5),d4
add.b 31+32-31744(a5),d4

add.b -32-31744(a5),d4
add.b -31744(a5),d4
add.b 32-31744(a5),d4

add.b 1-32-31744(a5),d4
add.b 1-31744(a5),d4
add.b 1+32-31744(a5),d4
bra chklim

xg0:
cmp.w #31,d5		;X = 31?
bne xl31

* X = 31 *

tst.w d6		;Y = 0?
bne xe31yg0

* X=31, Y=0 *

tst.w d7		;Z = 0?
beq x31y0z0
cmp.w #31,d7		;Z = 31?
beq x31y0z31

x31y0zn:
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b 32(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1+992-1024(a5),d4
add.b -1+992(a5),d4
add.b -1+992+1024(a5),d4

add.b 992-1024(a5),d4
add.b 992(a5),d4
add.b 992+1024(a5),d4

add.b -31+992-1024(a5),d4
add.b -31-1024(a5),d4
add.b -31+32-1024(a5),d4
add.b -31+992(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4
add.b -31+992+1024(a5),d4
add.b -31+1024(a5),d4
add.b -31+32+1024(a5),d4
bra chklim

x31y0z0:
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b 32(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1+992+31744(a5),d4
add.b -1+31744(a5),d4
add.b -1+32+31744(a5),d4
add.b -1+992(a5),d4
add.b -1+992+1024(a5),d4

add.b 992+31744(a5),d4
add.b 31744(a5),d4
add.b 32+31744(a5),d4
add.b 992(a5),d4
add.b 992+1024(a5),d4

add.b -31+992+31744(a5),d4
add.b -31+31744(a5),d4
add.b -31+32+31744(a5),d4
add.b -31+992(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4
add.b -31+992+1024(a5),d4
add.b -31+1024(a5),d4
add.b -31+32+1024(a5),d4
bra chklim

x31y0z31:
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4

add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b 32(a5),d4

tst.w _wrap
beq chklim

add.b -1+992-1024(a5),d4
add.b -1+992(a5),d4
add.b -1+992-31744(a5),d4
add.b -1-31744(a5),d4
add.b -1+32-31744(a5),d4

add.b 992-1024(a5),d4
add.b 992(a5),d4
add.b 992-31744(a5),d4
add.b -31744(a5),d4
add.b 32-31744(a5),d4

add.b -31+992-1024(a5),d4
add.b -31-1024(a5),d4
add.b -31+32-1024(a5),d4
add.b -31+992(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4
add.b -31+992-31744(a5),d4
add.b -31-31744(a5),d4
add.b -31+32-31744(a5),d4
bra chklim

xe31yg0:
cmp.w #31,d6		;Y = 31?
bne xe31yl31

* X=31, Y=31 *

tst.w d7		;Z = 0?
beq x31y31z0
cmp.w #31,d7		;Z = 31?
beq x31y31z31

x31y31zn:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b -32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4

tst.w _wrap
beq chklim

add.b -1-992-1024(a5),d4
add.b -1-992(a5),d4
add.b -1-992+1024(a5),d4

add.b -992-1024(a5),d4
add.b -992(a5),d4
add.b -992+1024(a5),d4

add.b -31-32-1024(a5),d4
add.b -31-1024(a5),d4
add.b -31-992-1024(a5),d4
add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31-992(a5),d4
add.b -31-32+1024(a5),d4
add.b -31+1024(a5),d4
add.b -31-992+1024(a5),d4
bra chklim

x31y31z0:
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4

add.b -32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4

tst.w _wrap
beq chklim

add.b -1-32+31744(a5),d4
add.b -1+31744(a5),d4
add.b -1-992+31744(a5),d4
add.b -1-992(a5),d4
add.b -1-992+1024(a5),d4

add.b -32+31744(a5),d4
add.b 31744(a5),d4
add.b -992+31744(a5),d4
add.b -992(a5),d4
add.b -992+1024(a5),d4

add.b -31-32+31744(a5),d4
add.b -31+31744(a5),d4
add.b -31-992+31744(a5),d4
add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31-992(a5),d4
add.b -31-32+1024(a5),d4
add.b -31+1024(a5),d4
add.b -31-992+1024(a5),d4
bra chklim

x31y31z31:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b -32(a5),d4

tst.w _wrap
beq chklim

add.b -1-992-1024(a5),d4
add.b -1-992(a5),d4
add.b -1-32-31744(a5),d4
add.b -1-31744(a5),d4
add.b -1-992-31744(a5),d4

add.b -992-1024(a5),d4
add.b -992(a5),d4
add.b -32-31744(a5),d4
add.b -31744(a5),d4
add.b -992-31744(a5),d4

add.b -31-32-1024(a5),d4
add.b -31-1024(a5),d4
add.b -31-992-1024(a5),d4
add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31-992(a5),d4
add.b -31-32-31744(a5),d4
add.b -31-31744(a5),d4
add.b -31-992-31744(a5),d4
bra chklim

* X=31, Y<31 *

xe31yl31:
tst.w d7		;Z = 0?
beq x31ynz0
cmp.w #31,d7		;Z = 31?
beq x31ynz31

x31ynzn:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b -32(a5),d4
add.b 32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -31-32-1024(a5),d4
add.b -31-1024(a5),d4
add.b -31+32-1024(a5),d4
add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4
add.b -31-32+1024(a5),d4
add.b -31+1024(a5),d4
add.b -31+32+1024(a5),d4
bra chklim

x31ynz0:
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b -32(a5),d4
add.b 32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1-32+31744(a5),d4
add.b -1+31744(a5),d4
add.b -1+32+31744(a5),d4

add.b -32+31744(a5),d4
add.b 31744(a5),d4
add.b 32+31744(a5),d4

add.b -31-32+31744(a5),d4
add.b -31+31744(a5),d4
add.b -31+32+31744(a5),d4
add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4
add.b -31-32+1024(a5),d4
add.b -31+1024(a5),d4
add.b -31+32+1024(a5),d4
bra chklim

x31ynz31:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b -32(a5),d4
add.b 32(a5),d4

tst.w _wrap
beq chklim

add.b -1-32-31744(a5),d4
add.b -1-31744(a5),d4
add.b -1+32-31744(a5),d4

add.b -32-31744(a5),d4
add.b -31744(a5),d4
add.b 32-31744(a5),d4

add.b -31-32-1024(a5),d4
add.b -31-1024(a5),d4
add.b -31+32-1024(a5),d4
add.b -31-32(a5),d4
add.b -31(a5),d4
add.b -31+32(a5),d4
add.b -31-32-31744(a5),d4
add.b -31-31744(a5),d4
add.b -31+32-31744(a5),d4
bra chklim

* X<31 *

xl31:
tst.w d6		;Y = 0?
bne xl31yg0

* X<31, Y=0 *

tst.w d7		;Z = 0?
beq xny0z0
cmp.w #31,d7		;Z = 31?
beq xny0z31

xny0zn:
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b 32(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1+992-1024(a5),d4
add.b -1+992(a5),d4
add.b -1+992+1024(a5),d4

add.b 992-1024(a5),d4
add.b 992(a5),d4
add.b 992+1024(a5),d4

add.b 1+992-1024(a5),d4
add.b 1+992(a5),d4
add.b 1+992+1024(a5),d4
bra chklim

xny0z0:
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b 32(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1+992+31744(a5),d4
add.b -1+31744(a5),d4
add.b -1+32+31744(a5),d4
add.b -1+992(a5),d4
add.b -1+992+1024(a5),d4

add.b 992+31744(a5),d4
add.b 31744(a5),d4
add.b 32+31744(a5),d4
add.b 992(a5),d4
add.b 992+1024(a5),d4

add.b 1+992+31744(a5),d4
add.b 1+31744(a5),d4
add.b 1+32+31744(a5),d4
add.b 1+992(a5),d4
add.b 1+992+1024(a5),d4
bra chklim

xny0z31:
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4

add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b 32(a5),d4

add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim

add.b -1+992-1024(a5),d4
add.b -1+992(a5),d4
add.b -1+992-31744(a5),d4
add.b -1-31744(a5),d4
add.b -1+32-31744(a5),d4

add.b 992-1024(a5),d4
add.b 992(a5),d4
add.b 992-31744(a5),d4
add.b -31744(a5),d4
add.b 32-31744(a5),d4

add.b 1+992-1024(a5),d4
add.b 1+992(a5),d4
add.b 1+992-31744(a5),d4
add.b 1-31744(a5),d4
add.b 1+32-31744(a5),d4
bra chklim

xl31yg0:
cmp.w #31,d6		;Y = 31?
bne xl31yl31

* X<31, Y=31 *

tst.w d7		;Z = 0?
beq xny31z0
cmp.w #31,d7		;Z = 31?
beq xny31z31

xny31zn:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b -32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1-992-1024(a5),d4
add.b -1-992(a5),d4
add.b -1-992+1024(a5),d4

add.b -992-1024(a5),d4
add.b -992(a5),d4
add.b -992+1024(a5),d4

add.b 1-992-1024(a5),d4
add.b 1-992(a5),d4
add.b 1-992+1024(a5),d4
bra chklim

xny31z0:
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4

add.b -32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4

add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1-32+31744(a5),d4
add.b -1+31744(a5),d4
add.b -1-992+31744(a5),d4
add.b -1-992(a5),d4
add.b -1-992+1024(a5),d4

add.b -32+31744(a5),d4
add.b 31744(a5),d4
add.b -992+31744(a5),d4
add.b -992(a5),d4
add.b -992+1024(a5),d4

add.b 1-32+31744(a5),d4
add.b 1+31744(a5),d4
add.b 1-992+31744(a5),d4
add.b 1-992(a5),d4
add.b 1-992+1024(a5),d4
bra chklim

xny31z31:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b -32(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4

tst.w _wrap
beq chklim

add.b -1-992-1024(a5),d4
add.b -1-992(a5),d4
add.b -1-32-31744(a5),d4
add.b -1-31744(a5),d4
add.b -1-992-31744(a5),d4

add.b -992-1024(a5),d4
add.b -992(a5),d4
add.b -32-31744(a5),d4
add.b -31744(a5),d4
add.b -992-31744(a5),d4

add.b 1-992-1024(a5),d4
add.b 1-992(a5),d4
add.b 1-32-31744(a5),d4
add.b 1-31744(a5),d4
add.b 1-992-31744(a5),d4
bra chklim

* X<31, Y<31 *

xl31yl31:
tst.w d7		;Z = 0?
beq xnynz0
cmp.w #31,d7		;Z = 31?
beq xnynz31

xnynzn:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b -32(a5),d4
add.b 32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4
bra chklim

xnynz0:
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4
add.b -1-32+1024(a5),d4
add.b -1+1024(a5),d4
add.b -1+32+1024(a5),d4

add.b -32(a5),d4
add.b 32(a5),d4
add.b -32+1024(a5),d4
add.b 1024(a5),d4
add.b 32+1024(a5),d4

add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4
add.b 1-32+1024(a5),d4
add.b 1+1024(a5),d4
add.b 1+32+1024(a5),d4

tst.w _wrap
beq chklim

add.b -1-32+31744(a5),d4
add.b -1+31744(a5),d4
add.b -1+32+31744(a5),d4

add.b -32+31744(a5),d4
add.b 31744(a5),d4
add.b 32+31744(a5),d4

add.b 1-32+31744(a5),d4
add.b 1+31744(a5),d4
add.b 1+32+31744(a5),d4
bra chklim

xnynz31:
add.b -1-32-1024(a5),d4
add.b -1-1024(a5),d4
add.b -1+32-1024(a5),d4
add.b -1-32(a5),d4
add.b -1(a5),d4
add.b -1+32(a5),d4

add.b -32-1024(a5),d4
add.b -1024(a5),d4
add.b 32-1024(a5),d4
add.b -32(a5),d4
add.b 32(a5),d4

add.b 1-32-1024(a5),d4
add.b 1-1024(a5),d4
add.b 1+32-1024(a5),d4
add.b 1-32(a5),d4
add.b 1(a5),d4
add.b 1+32(a5),d4

tst.w _wrap
beq chklim

add.b -1-32-31744(a5),d4
add.b -1-31744(a5),d4
add.b -1+32-31744(a5),d4

add.b -32-31744(a5),d4
add.b -31744(a5),d4
add.b 32-31744(a5),d4

add.b 1-32-31744(a5),d4
add.b 1-31744(a5),d4
add.b 1+32-31744(a5),d4

* CHECK NEIGHBORS *

chklim:
tst.b (a5)+		;is cell alive this generation?
bne live_one		;yes!

* See if cell is born *

cmp.b d0,d4		;too few for birth?
bmi dead		;yes!
cmp.b d1,d4		;too many?
bgt dead		;yes!
bra alive		;it's ALIVE!

* See if cell is still alive *

live_one:
cmp.b d2,d4		;too few neighbors to live?
bmi dead		;yes!
cmp.b d3,d4		;too many neighbors to live?
bgt dead		;yes!

* Cell is alive!  Set state & plot *

alive:
addq.w #1,_cellcount	;increment live cells

move.b #1,(a4)+		;set the cell to 1 (alive)

jsr do_cell		;plot the cell on the screen!

bra incpos		;and continue

* No cell *

dead:
clr.b (a4)+		;set cell to 0 (dead)

incpos:
addq.w #1,d5		;increment X coord
cmp.w #32,d5		;X at limit?
bne looper		;no, loop!

addq.w #1,d6		;increment Y coord
cmp.w #32,d6		;Y at limit?
bne x_row		;no, loop!

addq.w #1,d7		;increment Z coord
cmp.w #32,d7		;Z at limit?
bne y_slice		;no, loop!

* Now copy new cell array to old one *

move.l #_cell2,a0
move.l #_cell,a1
move.w #1024,d0

new_cells:
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
move.l (a0)+,(a1)+
subq.w #1,d0
bne new_cells

movem.l (sp)+,d3-d7/a3-a6	;restore registers
rts

* Plot a cell on the screen			*
* X in D5, Y in D6, Z in D7			*

do_cell:
movem.l d0-d7/a0-a6,-(sp) ;save registers!

eor #31,d7		;flip Z
asl.w #3,d7		;Z * 8, now = 0-248
mulu #46340,d7		;Z * (.707 * 65536) [45 degree rotation]
swap d7			;put Z * .707 in low word half
move.w d7,d4		;save extra copy of rotated Z

eor #31,d5		;flip X
asl.w #3,d5		;now X = 0-248
mulu #46340,d5		;X * (.707 * 65536) [45 degrees]
swap d5			;X * .707 in word half

add.w d5,d4		;Z' = X * .707 + Z * .707 [45 degree rotation]

move.w d4,d0		;calc size of sphere = Z/36
ext.l d0
divu #36,d0		;d0 has cell size = 0 (large) to 9 (small)
mulu #26,d0		;cell size times 26 = mask offset index

move.l #_MASKS,a0	;point to masks
add.w d0,a0		;add offset
move.l a0,maskad	;store mask address

lsl.w #2,d0		;offset * 4 (for 4-plane image offset)
move.w d0,celloff	;store image offset!

eor #31,d6		;flip Y
asl.w #3,d6		;now Y = 0-248

sub.w d7,d5		;X' = X * .707 - Z * .707

* Now calculate left image offset & plot the sphere *

move.w d4,d0		;set Z up,
add.w #600,d0		;add 600 for delta Z

move.w d5,d1		;set X up,
add.w _usesep,d1	;get delta X
ext.l d1
swap d1			;multiply by 65536
divs d0,d1		;deltax/deltaz
muls #600,d1		;* 600,
swap d1			;get result in low word
move.w d1,d2
add.w _lsep,d2		;and get screen X

move.w d6,d3		;get delta Y,
ext.l d3
swap d3			;multiply by 65536
divs d0,d3		;deltaY/deltaZ
muls #600,d3		;* 600,
swap d3			;get result in low word
add.w #10,d3		;and get screen Y

cmp.w #3,_runtype	;2D perspective?
bpl not_2d		;no!

lsr.w #3,d4		;divide Z by 8
sub.w d4,d3		;subtract from Y to tilt cell plane up

not_2d:
movem.l d0-d5,-(sp)	;save work registers

move.w d3,-(sp)		;Y on stack
move.w d2,-(sp)		;X on stack
move.l #_LEFTS,a0	;point to left cell bitmap table
add.w celloff,a0	;add offset
move.l a0,-(sp)		;store pointer to cell bitmap
move.l maskad,-(sp)	;pointer to mask bitmap
move.l _lmap,-(sp)	;address of left screen
jsr _quikblit		;plot the live cell
add.l #16,sp		;readjust stack pointer

movem.l (sp)+,d0-d5	;restore work registers

tst.w _stereo		;doing stereo image?
beq noright		;no!

move.w d5,d1		;set X up,
sub.w _usesep,d1	;get delta X
ext.l d1
swap d1			;multiply by 65536
divs d0,d1		;deltax/deltaz
muls #600,d1		;* 600,
swap d1			;get result in low word
add.w _rsep,d1		;get screen X

move.w d3,-(sp)		;Y on stack
move.w d1,-(sp)		;X on stack
move.l #_RIGHTS,a0	;point to right cell bitmap table
add.w celloff,a0	;add offset
move.l a0,-(sp)		;store pointer to cell bitmap
move.l maskad,-(sp)	;pointer to mask bitmap
move.l _rmap,-(sp)	;address of right screen
jsr _quikblit		;plot the live cell
add.l #16,sp		;adjust stack

noright:
movem.l (sp)+,d0-d7/a0-a6 ;restore all registers
rts

do_cell2:
movem.l d0-d7/a0-a6,-(sp) ;save registers!

move.w d5,d2		;get X * 1
asl.w #3,d2		;make X * 8
sub.w d5,d2		;now have X * 7
add.w #55,d2		;and offset it

asl.w d7		;Z * 2
move.w d7,d3		;get Z * 2
asl.w d7		;Z * 4
add.w d7,d3		;now have Z * 6
addq.w #7,d3		;add in offset

move.w d3,-(sp)		;Y on stack
move.w d2,-(sp)		;X on stack
move.l #_LEFTS+832,-(sp) ;pointer to cell bitmap #8
move.l #_MASKS+208,-(sp) ;pointer to mask bitmap #8
move.l _lmap,-(sp)	;address of left screen
jsr _quikblit		;plot the live cell
add.l #16,sp		;adjust stack

movem.l (sp)+,d0-d7/a0-a6 ;restore all registers
rts

.data
.even

_cell: ds.b 32768	;main cell array, 32 X 32 X 32
_cell2: ds.b 32768	;secondary cell array

_birthL: ds.b 1		;min neighbors needed for birth
_birthH: ds.b 1		;max neighbors allowed for birth
_deathL: ds.b 1		;min neighbors needed to stay alive
_deathH: ds.b 1		;max neighbors allowed to stay alive

.even

_runtype: dc.w 3	;run type
_stereo: ds.w 1		;stereo flag
_lmap: ds.l 1		;left screen bitmap
_rmap: ds.l 1		;right screen bitmap
celloff: ds.w 1		;cell address offset
maskad: ds.l 1		;mask address

* LEFT SPHERES

_LEFTS:
* Bitmap data for left sphere 1
* Bit plane 1
dc.w $01C0,$05D0,$0550,$1D5C
dc.w $0140,$7F7F,$7087,$7F7F
dc.w $0140,$1D5C,$0550,$05D0
dc.w $01C0
* Bit plane 2
dc.w $03E0,$0C18,$1364,$3496
dc.w $2B6A,$2AAA,$25D2,$2AAA
dc.w $2B6A,$3496,$1364,$0C18
dc.w $03E0
* Bit plane 3
dc.w $0000,$03E0,$0F78,$0C18
dc.w $188C,$19CC,$13E4,$19CC
dc.w $188C,$0C18,$0F78,$03E0
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0080,$03E0
dc.w $07F0,$07F0,$0FF8,$07F0
dc.w $07F0,$03E0,$0080,$0000
dc.w $0000

* Bitmap data for left sphere 2
* Bit plane 1
dc.w $02A0,$0630,$0140,$1140
dc.w $1F7E,$1086,$1F7E,$0140
dc.w $1D5C,$0550,$05D0,$01C0
dc.w $0000
* Bit plane 2
dc.w $01C0,$0D58,$1494,$1B6A
dc.w $2AAA,$05D3,$0AAB,$2B6A
dc.w $1496,$1364,$0C18,$03E0
dc.w $0000
* Bit plane 3
dc.w $0000,$0360,$0C18,$088C
dc.w $19CC,$33E4,$39CC,$188C
dc.w $0C18,$0F78,$03E0,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0080,$03E0,$07F0
dc.w $07F0,$0FF8,$07F0,$07F0
dc.w $03E0,$0080,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 3
* Bit plane 1
dc.w $0000,$0180,$0510,$1D38
dc.w $0100,$1F7C,$308C,$0140
dc.w $1D3C,$0528,$05B0,$01A0
dc.w $0000
* Bit plane 2
dc.w $0000,$03C0,$0B50,$14A8
dc.w $0B54,$2AD4,$25A6,$2B54
dc.w $14A8,$1340,$0C20,$03C0
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0760,$0C30
dc.w $1898,$1998,$13C8,$1898
dc.w $0C30,$0F70,$03C0,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0080,$03C0
dc.w $07E0,$07E0,$0FF0,$07E0
dc.w $03C0,$0080,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 4
* Bit plane 1
dc.w $0000,$00C0,$0070,$044C
dc.w $0908,$1086,$1476,$0848
dc.w $015C,$0358,$00C0,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$01E0,$0558,$0A98
dc.w $0D24,$02DC,$06AC,$0D64
dc.w $0B68,$0690,$01E0,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0360,$0610
dc.w $04C8,$09E8,$0DC8,$0488
dc.w $0770,$01E0,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0080,$01E0
dc.w $03F0,$07F0,$03F0,$03F0
dc.w $0080,$0000,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 5
* Bit plane 1
dc.w $0000,$0000,$0180,$0E00
dc.w $1CF0,$0CE8,$2A8C,$0100
dc.w $1D08,$0DC0,$0180,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$03C0,$0550
dc.w $09A8,$1658,$13A8,$1758
dc.w $08A0,$0410,$03C0,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0360
dc.w $0430,$0D90,$09C0,$0C90
dc.w $0430,$03E0,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0080
dc.w $03C0,$03E0,$07F0,$03E0
dc.w $03C0,$0000,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 6
* Bit plane 1
dc.w $0000,$0000,$0180,$03C0
dc.w $03C0,$0760,$0660,$0000
dc.w $0240,$0180,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$03C0,$01A0
dc.w $0DB0,$06E0,$0660,$0DB0
dc.w $05A0,$03C0,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$07C0
dc.w $0420,$0DB0,$0DB0,$0420
dc.w $03C0,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $03C0,$03C0,$03C0,$03C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 7
* Bit plane 1
dc.w $0000,$0000,$0000,$02A0
dc.w $0410,$0808,$0C98,$0808
dc.w $0410,$02A0,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$01C0
dc.w $0140,$0140,$02A0,$0140
dc.w $0140,$01C0,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $0360,$0490,$05D0,$0490
dc.w $0360,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0080,$03E0,$03E0,$03E0
dc.w $0080,$0000,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 8
* Bit plane 1
dc.w $0000,$0000,$0000,$0180
dc.w $07E0,$05A0,$0890,$05A0
dc.w $05A0,$0180,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$03C0
dc.w $05A0,$0990,$0F70,$0990
dc.w $05A0,$03C0,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $03C0,$0420,$05A0,$0420
dc.w $03C0,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0000,$03C0,$03C0,$03C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 9
* Bit plane 1
dc.w $0000,$0000,$0000,$02A0
dc.w $02A0,$0690,$0430,$0140
dc.w $0140,$0000,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$01C0
dc.w $0770,$05F0,$07D0,$0490
dc.w $0360,$0000,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $0140,$0220,$0280,$0220
dc.w $0080,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0080,$01C0,$01E0,$01C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* Bitmap data for left sphere 10
* Bit plane 1
dc.w $0000,$0000,$0000,$0000
dc.w $0080,$01C0,$0550,$01C0
dc.w $0080,$0000,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$0000
dc.w $0220,$0490,$07F0,$0490
dc.w $0220,$0000,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $01C0,$0220,$02A0,$0220
dc.w $01C0,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0000,$01C0,$01C0,$01C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* RIGHT SPHERES

* Bitmap data for right sphere 1
_RIGHTS:
* Bit plane 1
dc.w $03C0,$0FE0,$0528,$1550
dc.w $252C,$5DEA,$6216,$5DEA
dc.w $252C,$1550,$0520,$0FA0
dc.w $0380
* Bit plane 2
dc.w $03E0,$0838,$0DCC,$3266
dc.w $0DB6,$2AB3,$375B,$2AB3
dc.w $0DB6,$3266,$0DCC,$0838
dc.w $03E0
* Bit plane 3
dc.w $0000,$07C0,$1DF0,$1078
dc.w $2238,$273C,$2F9C,$273C
dc.w $2238,$1078,$1DF0,$07C0
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0200,$0F80
dc.w $1FC0,$1FC0,$1FE0,$1FC0
dc.w $1FC0,$0F80,$0200,$0000
dc.w $0000

* Bitmap data for right sphere 2
* Bit plane 1
dc.w $03A0,$0CA0,$1528,$0514
dc.w $3DEA,$020B,$3DEB,$252C
dc.w $0554,$1528,$0FA0,$03C0
dc.w $0000
* Bit plane 2
dc.w $03C0,$0938,$124C,$1DA6
dc.w $2AB2,$3753,$0AB3,$2DB6
dc.w $1266,$1DCC,$0838,$03E0
dc.w $0000
* Bit plane 3
dc.w $0000,$05C0,$0070,$1238
dc.w $073C,$2F9C,$273C,$0238
dc.w $1078,$0DF0,$07C0,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0200,$0F80,$0FC0
dc.w $1FC0,$1FE0,$1FC0,$1FC0
dc.w $0F80,$0200,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 3
* Bit plane 1
dc.w $0000,$0100,$0220,$1A70
dc.w $1208,$3EF8,$011C,$2298
dc.w $1A64,$1A48,$0B50,$0160
dc.w $0000
* Bit plane 2
dc.w $0000,$03C0,$08B0,$1158
dc.w $06AC,$35AC,$0B4E,$36AC
dc.w $0948,$1690,$0860,$0380
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$06C0,$0860
dc.w $1130,$1330,$2790,$1130
dc.w $1870,$0EE0,$0780,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0100,$0780
dc.w $0FC0,$0FC0,$1FE0,$0FC0
dc.w $0780,$0100,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 4
* Bit plane 1
dc.w $0000,$0180,$06C0,$0880
dc.w $0218,$190A,$18EA,$0098
dc.w $0AA4,$0688,$0180,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$01E0,$0498,$0D2C
dc.w $024C,$05BC,$055C,$02CC
dc.w $0EC8,$0510,$01E0,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$02E0,$0430
dc.w $0990,$0BD0,$0B90,$0910
dc.w $06F0,$03E0,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0100,$03C0
dc.w $07E0,$07E0,$07E0,$07E0
dc.w $0100,$0000,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 5
* Bit plane 1
dc.w $0000,$0000,$0300,$0C20
dc.w $19F0,$01C8,$3518,$0200
dc.w $1A18,$0FA0,$0300,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$03C0,$06B0
dc.w $0B58,$1CA8,$174C,$1EA8
dc.w $0950,$0430,$03C0,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$02C0
dc.w $0060,$0B30,$0390,$0930
dc.w $0060,$03C0,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0100
dc.w $0780,$07C0,$0FE0,$07C0
dc.w $0780,$0000,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 6
* Bit plane 1
dc.w $0000,$0000,$0180,$03C0
dc.w $0360,$0700,$0600,$00A0
dc.w $0240,$0180,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$03C0,$01A0
dc.w $0D90,$07E0,$0760,$0D10
dc.w $05A0,$03C0,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$07C0
dc.w $0420,$0DB0,$0DB0,$0420
dc.w $03C0,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $03C0,$03C0,$03C0,$03C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 7
* Bit plane 1
dc.w $0000,$0000,$0000,$02A0
dc.w $0410,$0888,$0D38,$0888
dc.w $0410,$02A0,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$01C0
dc.w $0140,$00C0,$03C0,$00C0
dc.w $0140,$01C0,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $0360,$0510,$0590,$0510
dc.w $0360,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0080,$03E0,$03E0,$03E0
dc.w $0080,$0000,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 8
* Bit plane 1
dc.w $0000,$0000,$0000,$0180
dc.w $07E0,$0520,$08D0,$0520
dc.w $05A0,$0180,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$03C0
dc.w $05A0,$0990,$0FB0,$0990
dc.w $05A0,$03C0,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $03C0,$0420,$0520,$0420
dc.w $03C0,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0000,$03C0,$03C0,$03C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 9
* Bit plane 1
dc.w $0000,$0000,$0000,$02A0
dc.w $02A0,$07D0,$0530,$0140
dc.w $0140,$0000,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$01C0
dc.w $0770,$05B0,$07D0,$0490
dc.w $0360,$0000,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $0140,$0220,$0280,$0220
dc.w $0080,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0080,$01C0,$01E0,$01C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* Bitmap data for right sphere 10
* Bit plane 1
dc.w $0000,$0000,$0000,$0000
dc.w $0080,$0180,$0510,$0180
dc.w $0080,$0000,$0000,$0000
dc.w $0000
* Bit plane 2
dc.w $0000,$0000,$0000,$0000
dc.w $0220,$0490,$07F0,$0490
dc.w $0220,$0000,$0000,$0000
dc.w $0000
* Bit plane 3
dc.w $0000,$0000,$0000,$0000
dc.w $01C0,$0220,$02A0,$0220
dc.w $01C0,$0000,$0000,$0000
dc.w $0000
* Bit plane 4
dc.w $0000,$0000,$0000,$0000
dc.w $0000,$01C0,$01C0,$01C0
dc.w $0000,$0000,$0000,$0000
dc.w $0000

* BLIT MASKS

_MASKS:
* Bitmap data for sphere 1 mask
dc.w $FC1F,$F007,$E003,$C001
dc.w $C001,$8000,$8000,$8000
dc.w $C001,$C001,$E003,$F007
dc.w $FC1F

* Bitmap data for sphere 2 mask
dc.w $FC1F,$F007,$E003,$E001
dc.w $C001,$C000,$C000,$C001
dc.w $E001,$E003,$F007,$FC1F
dc.w $FFFF

* Bitmap data for sphere 3 mask
dc.w $FFFF,$FC3F,$F00F,$E007
dc.w $E003,$C003,$C001,$C003
dc.w $E003,$E007,$F00F,$FC1F
dc.w $FFFF

* Bitmap data for sphere 4 mask
dc.w $FFFF,$FE1F,$F807,$F003
dc.w $F003,$E001,$E001,$F003
dc.w $F003,$F807,$FE1F,$FFFF
dc.w $FFFF

* Bitmap data for sphere 5 mask
dc.w $FFFF,$FFFF,$FC3F,$F00F
dc.w $E007,$E007,$E003,$E007
dc.w $E007,$F00F,$FC3F,$FFFF
dc.w $FFFF

* Bitmap data for sphere 6 mask
dc.w $FFFF,$FFFF,$FC3F,$F81F
dc.w $F00F,$F00F,$F00F,$F00F
dc.w $F81F,$FC3F,$FFFF,$FFFF
dc.w $FFFF

* Bitmap data for sphere 7 mask
dc.w $FFFF,$FFFF,$FFFF,$FC1F
dc.w $F80F,$F007,$F007,$F007
dc.w $F80F,$FC1F,$FFFF,$FFFF
dc.w $FFFF

* Bitmap data for sphere 8 mask
dc.w $FFFF,$FFFF,$FFFF,$FC3F
dc.w $F81F,$F00F,$F00F,$F00F
dc.w $F81F,$FC3F,$FFFF,$FFFF
dc.w $FFFF

* Bitmap data for sphere 9 mask
dc.w $FFFF,$FFFF,$FFFF,$FC1F
dc.w $F80F,$F80F,$F80F,$F80F
dc.w $FC1F,$FFFF,$FFFF,$FFFF
dc.w $FFFF

* Bitmap data for sphere 10 mask
dc.w $FFFF,$FFFF,$FFFF,$FFFF
dc.w $FC1F,$F80F,$F80F,$F80F
dc.w $FC1F,$FFFF,$FFFF,$FFFF
dc.w $FFFF

.text

* My special 16X13, 4 bitplane fast blit *

_quikblit:
movem.l d3-d6,-(sp)	;save registers

move.l 20(sp),a0	;screen base
move.l 24(sp),a1	;mask address
move.l 28(sp),a2	;block address
move.w 32(sp),d1	;x
subq.w #7,d1		;adjust x for block size
move.w 34(sp),d2	;y
subq.w #5,d2		;adjust y for block size

move.w d1,d0		;duplicate x
lsr.w d0		;x/2
and.w #$fff8,d0		;get screen offset in scan line

and.w #15,d1		;get horizontal shift count

startit:
move.w #$ffff,d4	;set up constant
move.w d2,d5		;duplicate y

lsl.w #5,d2		;y * 32
add.w d2,a0		;add to screen base
lsl.w #2,d2		;y * 128
add.w d2,a0		;add to base = screen + (y * 160)

* Start the blit! *

move.w	#13,d2		;scan line count
clr.w d3		;clear index into blocks

blitloop:
cmp.w #200,d5		;y off bottom?
bpl blitdone		;yes!

move.w 0(a1,d3.w),d6	;get mask word
swap d6			;put in high word of d6
move.w d4,d6		;put $ffff in low word of d6
ror.l d1,d6		;shift the mask!

and.w d6,8(a0,d0.w)	;mask right word of plane 0
and.w d6,10(a0,d0.w)	;mask right word of plane 1
and.w d6,12(a0,d0.w)	;mask right word of plane 2
and.w d6,14(a0,d0.w)	;mask right word of plane 3

swap d6
and.w d6,0(a0,d0.w)	;mask left word of plane 0
and.w d6,2(a0,d0.w)	;mask left word of plane 1
and.w d6,4(a0,d0.w)	;mask left word of plane 2
and.w d6,6(a0,d0.w)	;mask left word of plane 3

* Get & blit image data! *

* Plane 0 *

move.w 0(a2,d3.w),d6	;get plane 0 data
swap d6			;put in upper word
clr.w d6		;clear low word
lsr.l d1,d6		;shift the image
or.w d6,8(a0,d0.w)	;store right word
swap d6			;swap words
or.w d6,0(a0,d0.w)	;store left word

* Plane 1 *

move.w 26(a2,d3.w),d6	;again for plane 1
swap d6
clr.w d6
lsr.l d1,d6
or.w d6,10(a0,d0.w)
swap d6
or.w d6,2(a0,d0.w)

* Plane 2 *

move.w 52(a2,d3.w),d6	;again for plane 2
swap d6
clr.w d6
lsr.l d1,d6
or.w d6,12(a0,d0.w)
swap d6
or.w d6,4(a0,d0.w)

* Plane 3 *

move.w 78(a2,d3.w),d6	;again for plane 3
swap d6
clr.w d6
lsr.l d1,d6
or.w d6,14(a0,d0.w)
swap d6
or.w d6,6(a0,d0.w)

subq.w #1,d2		;scans exhausted?
beq blitdone		;yes!

addq.w #1,d5		;increment y position
addq.w #2,d3		;increment block index
add.l #160,a0		;go to next scan line
bra blitloop		;do next scan!

blitdone:
movem.l (sp)+,d3-d6	;restore registers
rts			;and return!

* End!
