/**********************************/
/* 	 Omni Life C module	  */
/*	   by Tom Hudson	  */
/* Copyright 1987 ST-LOG Magazine */
/**********************************/

#include "osbind.h"
#include "omnilife.h"

/****************************/
/* External LIFE data areas */
/****************************/

extern char cell[32][32][32],deathL,deathH,birthL,birthH;
extern int runtype,stereo;
extern long lmap,rmap;
extern int MASKS[][13],LEFTS[][52],RIGHTS[][52];

/*************/
/* GEM Stuff */
/*************/

int contrl[12],intin[128],ptsin[128],intout[128],ptsout[128];

/*********************/
/* Program variables */
/*********************/

int handle,oldrez,dum;
int l_intin[11],l_ptsin[20],l_out[57],gr_1,gr_2,gr_3,gr_4;
int dim,sep=20,usesep,lsep,rsep;
int formx,formy,formw,formh,formresult;
long s1phys,diaaddr,optaddr,inch,displ,dispr;
int cellx,celly,cellz,gcx,gcy,gcz,randx,randy,randz;
int generation,cellcount;
int groups=0,wrap=0,status=0;

/*****************************/
/* Slider settings for 2D/3D */
/*****************************/

int slider0[2]={2,4};
int slider1[2]={3,5};
int slider2[2]={3,5};
int slider3[2]={3,5};
int slidlim[2]={7,25};

/*********************************/
/* Color palette for LIFE screen */
/*********************************/

int palette[16] =
{
0x0004,0x0100,0x0200,0x0300,0x0400,0x0500,0x0600,0x0700,
0x0710,0x0720,0x0730,0x0740,0x0750,0x0760,0x0770,0x0775
};

/****************************************************/
/* Set up these variables for the slider subroutine */
/* They allow up to 10 sliders per dialog box!      */
/****************************************************/

long slidstep[10],slidacc[10];
int slidpos[10],slidmax[10];

/****************************************************/
/* Miscellaneous slider routine variables.	    */
/****************************************************/

int mousex,mousey,dum,moved;
int tbasex,tbasey,sbasex,sbasey;

/*************************/
/* My form_alert strings */
/*************************/

static char bad_ranges[]=
"[1][Range error, try again!][SORRY]";
static char intro[]=
"[1][   Omni Life by Tom Hudson|Copyright 1987 ST-LOG Magazine][OK]";
static char no_rsrc[]=
"[1][Cannot find resource file!][SORRY]";
static char badrez[]=
"[1][Run this program in low res!][SORRY]";
static char rand_user[]=
"[3][Random or User-defined|cell pattern?][Random|User]";

static char stat_line[]=
"Generation: 00000   Cells: 00000";

static int oldpal[16],worksc[32300],dispsc[32300];

main()
{
register int ix,jx;

/**********************/
/* Start the program! */
/**********************/

s1phys=Physbase();

/*************************************/
/* Set up pointers to screen buffers */
/*************************************/

lmap=((long)worksc+255L)/256L*256L;
rmap=lmap+32256;

displ=((long)dispsc+255L)/256L*256L;
dispr=displ+32256;

/*************************/
/* Start up application! */
/*************************/

appl_init();

handle=graf_handle(&gr_1,&gr_2,&gr_3,&gr_4);

/********************/
/* open workstation */
/********************/

for(ix=0; ix < 10; ix++)
 l_intin[ix] = 1;
l_intin[10] = 2;
v_opnvwk(l_intin, &handle, l_out);
graf_mouse(0,&dum);
v_show_c(handle,0);

/********************/
/* Save old palette */
/********************/

for(ix=0; ix<16; ++ix)
 oldpal[ix]=Setcolor(ix,-1);

/***************************************/
/* Set text alignment to center/bottom */
/***************************************/

vst_alignment(handle,1,3,&dum,&dum);

/*****************/
/* Intro display */
/*****************/

form_alert(1,intro);

/*************************************************/
/* Load resource file, bail out if not available */
/*************************************************/

if(rsrc_load("omnilife.rsc")==0)
 {
 form_alert(1,no_rsrc);
 goto rsrc_bail;
 }

rsrc_gaddr(0,OPTIONS,&optaddr);
rsrc_gaddr(0,SLIDIA,&diaaddr);

/*******************************/
/* Make sure we're in low rez! */
/*******************************/

oldrez=Getrez();
if(oldrez!=0)
 {
 form_alert(1,badrez);
 goto bail_out;
 }

/********************************/
/* Do the parameter input forms */
/********************************/

redo_form:
Setpallete(oldpal);
v_show_c(handle,0);

form_center(optaddr,&formx,&formy,&formw,&formh);
form_dial(0,0,0,0,0,formx,formy,formw,formh);
objc_draw(optaddr,0,2,formx,formy,formw,formh);

srcon(optaddr,LOOKDN+runtype);
srcon(optaddr,CELL1+groups);
if(wrap)
 srcon(optaddr,WRAP);
if(status)
 srcon(optaddr,STATUS);

/*********************************/
/* Initialize sep slider to	 */
/* its current setting.		 */
/*********************************/

hreset(0,optaddr,SEPTRACK,SEPSLIDE,39,sep-1);

/*********************************/
/* Display current setting of	 */
/* sep slider			 */
/*********************************/

show_pos(optaddr,SEPREAD,SEPBOX,slidpos[0]+1);

/*********************************/
/* Do the form!			 */
/*********************************/

optloop:
formresult=form_do(optaddr,0) & 0x7FFF;

/*********************************/
/* Process the sep slider	 */
/*********************************/

switch(formresult)
 {
 case SEPLEFT:
 case SEPRIGHT:
 case SEPSLIDE:
 case SEPTRACK:
  do_hslider(0,optaddr,SEPTRACK,SEPSLIDE,SEPLEFT,SEPRIGHT,formresult,1);
  show_pos(optaddr,SEPREAD,SEPBOX,slidpos[0]+1);
  goto optloop;
  break;

 /*********************************/
 /* If Quit pressed, bail out!	 */
 /*********************************/

 case OPTQUIT:
  goto bail_out;
  break;
 }

/*********************************/
/* If OK pressed, grab the	 */
/* slider settings, options	 */
/*********************************/

runtype=radio(optaddr,LOOKDN,5);
radreset(optaddr,LOOKDN,5);
groups=radio(optaddr,CELL1,8);
radreset(optaddr,CELL1,8);

if(runtype<3)
 dim=0;		/* 2D */
else
 dim=1;		/* 3D */

if(runtype==2 || runtype==4)
 {
 stereo=1;
 usesep=sep=slidpos[0]+1;
 }
else
 stereo=usesep=0;

wrap=itmstate(optaddr,WRAP);
srcoff(optaddr,WRAP);

status=itmstate(optaddr,STATUS);
srcoff(optaddr,STATUS);

lsep=160-usesep;
rsep=160+usesep;

srcoff(optaddr,formresult);
form_dial(3,0,0,0,0,formx,formy,formw,formh);

/*********************************/
/* Now get master life params	 */
/*********************************/

form_center(diaaddr,&formx,&formy,&formw,&formh);
form_dial(0,0,0,0,0,formx,formy,formw,formh);
objc_draw(diaaddr,0,2,formx,formy,formw,formh);

/*********************************/
/* Initialize all sliders to	 */
/* their current settings	 */
/*********************************/

hreset(0,diaaddr,TRACK0,SLIDER0,slidlim[dim],slider0[dim]-1);
hreset(1,diaaddr,TRACK1,SLIDER1,slidlim[dim],slider1[dim]-1);
hreset(2,diaaddr,TRACK2,SLIDER2,slidlim[dim],slider2[dim]-1);
hreset(3,diaaddr,TRACK3,SLIDER3,slidlim[dim],slider3[dim]-1);

/*********************************/
/* Display current settings of	 */
/* sliders below each slider	 */
/*********************************/

show_pos(diaaddr,NUMBER0,BN0,slidpos[0]+1);
show_pos(diaaddr,NUMBER1,BN1,slidpos[1]+1);
show_pos(diaaddr,NUMBER2,BN2,slidpos[2]+1);
show_pos(diaaddr,NUMBER3,BN3,slidpos[3]+1);

/*********************************/
/* Do the form!			 */
/*********************************/

formloop:
formresult=form_do(diaaddr,0) & 0x7FFF;

/*********************************/
/* Find which slider to process	 */
/* and do it.			 */
/*********************************/

switch(formresult)
 {
 case LEFT0:
 case RIGHT0:
 case SLIDER0:
 case TRACK0:
  do_hslider(0,diaaddr,TRACK0,SLIDER0,LEFT0,RIGHT0,formresult,1);
  show_pos(diaaddr,NUMBER0,BN0,slidpos[0]+1);
  goto formloop;
  break;
 case LEFT1:
 case RIGHT1:
 case SLIDER1:
 case TRACK1:
  do_hslider(1,diaaddr,TRACK1,SLIDER1,LEFT1,RIGHT1,formresult,1);
  show_pos(diaaddr,NUMBER1,BN1,slidpos[1]+1);
  goto formloop;
  break;
 case LEFT2:
 case RIGHT2:
 case SLIDER2:
 case TRACK2:
  do_hslider(2,diaaddr,TRACK2,SLIDER2,LEFT2,RIGHT2,formresult,1);
  show_pos(diaaddr,NUMBER2,BN2,slidpos[2]+1);
  goto formloop;
  break;
 case LEFT3:
 case RIGHT3:
 case SLIDER3:
 case TRACK3:
  do_hslider(3,diaaddr,TRACK3,SLIDER3,LEFT3,RIGHT3,formresult,1);
  show_pos(diaaddr,NUMBER3,BN3,slidpos[3]+1);
  goto formloop;
  break;

 /*********************************/
 /* If Quit pressed, bail out!	 */
 /*********************************/

 case SLIDQUIT:
  goto bail_out;
  break;
 }

/*********************************/
/* Turn off exit button		 */
/*********************************/

srcoff(diaaddr,formresult);

/*********************************/
/* If OK pressed, grab the	 */
/* slider settings		 */
/*********************************/

slider0[dim]=slidpos[0]+1;
slider1[dim]=slidpos[1]+1;
slider2[dim]=slidpos[2]+1;
slider3[dim]=slidpos[3]+1;
if(slider0[dim]>slider1[dim] || slider2[dim]>slider3[dim])
 {
 form_alert(1,bad_ranges);
 goto formloop;
 }

/*********************************/
/* Set up master LIFE parameters */
/*********************************/

deathL=slider0[dim];
deathH=slider1[dim];
birthL=slider2[dim];
birthH=slider3[dim];

form_dial(3,0,0,0,0,formx,formy,formw,formh);

v_hide_c(handle);

/********************/
/* Start LIFE here! */
/********************/

newlife:
Setpallete(palette);
Setscreen(displ,displ,0);

if(dim==1)
 {

 /*********************************/
 /* Reset 3D cell array to zeroes */
 /*********************************/

 for(randx=0; randx<32; ++randx)
  {
  for(randy=0; randy<32; ++randy)
   {
   for(randz=0; randz<32; ++randz)
    cell[randz][randy][randx]=0;
   }
  }

 v_show_c(handle,0);
 if(form_alert(1,rand_user)==2)
  {

  /*****************/
  /* User-defined! */
  /*****************/

  editor();
  }
 else
  {

  /*********************************/
  /* Randomize (30 * groups) cells */
  /*********************************/

  for(ix=0; ix<(groups+1); ++ix)
   {
   if(groups==0)
    {
    gcx=gcy=gcz=16;
    }
   else
    {
    gcx=(int)Random() & 0x001f;
    gcy=(int)Random() & 0x001f;
    gcz=(int)Random() & 0x001f;
    }

   for(jx=0; jx<30; ++jx)
    {
    randx=gcx+3-((int)Random() & 0x0007);
    randy=gcy+3-((int)Random() & 0x0007);
    randz=gcz+3-((int)Random() & 0x0007);

    if(randx>31)
     {
     if(wrap)
      randx-=32;
     else
      randx=31;
     }
    else
    if(randx<0)
     {
     if(wrap)
      randx+=32;
     else
      randx=0;
     }

    if(randy>31)
     {
     if(wrap)
      randy-=32;
     else
      randy=31;
     }
    else
    if(randy<0)
     {
     if(wrap)
      randy+=32;
     else
      randy=0;
     }

    if(randz>31)
     {
     if(wrap)
      randz-=32;
     else
      randz=31;
     }
    else
    if(randz<0)
     {
     if(wrap)
      randz+=32;
     else
      randz=0;
     }

    cell[randz][randy][randx]=1;
    }
   }
  }
 }
else
 {

 /*********************************/
 /* Reset 2D cell array to zeroes */
 /*********************************/

 for(randx=0; randx<32; ++randx)
  {
  for(randy=0; randy<32; ++randy)
   cell[0][randy][randx]=0;
  }

 /* Random or user-defined? */

 v_show_c(handle,0);
 if(form_alert(1,rand_user)==2)
  {

  /*****************/
  /* User-defined! */
  /*****************/

  editor();
  }
 else
  {

  /*********************************/
  /* Randomize (20 * groups) cells */
  /*********************************/

  for(ix=0; ix<(groups+1); ++ix)
   {
   gcx=(int)Random() & 0x001f;
   gcy=(int)Random() & 0x001f;

   for(jx=0; jx<20; ++jx)
    {
    randx=gcx+3-((int)Random() & 0x0007);
    randy=gcy+3-((int)Random() & 0x0007);

    if(randx>31)
     {
     if(wrap)
      randx-=32;
     else
      randx=31;
     }
    else
    if(randx<0)
     {
     if(wrap)
      randx+=32;
     else
      randx=0;
     }

    if(randy>31)
     {
     if(wrap)
      randy-=32;
     else
      randy=31;
     }
    else
    if(randy<0)
     {
     if(wrap)
      randy+=32;
     else
      randy=0;
     }

    cell[0][randy][randx]=1;
    }
   }
  }
 }

v_hide_c(handle);

if(stereo)
 {
 Setscreen(dispr,dispr,0);
 stereo_switch(1,displ,dispr);
 }

Setscreen(displ,displ,0);

/**********************/
/* Reset generation # */
/**********************/

generation=0;

lifecont:
generation++;
cellcount=0;

/***************************/
/* Clear screen work areas */
/***************************/

clr_sc(lmap);
if(stereo)
 clr_sc(rmap);

/*****************/
/* Process cells */
/*****************/

if(dim==1)
 life3d();
else
 life2d();

/************************/
/* Check for keypresses */
/************************/

if(Cconis())
 {
 inch=Crawcin();
 if(inch==0x00610000L)	/* Undo */
  goto lifedone;
 if(inch==0x00620000L)	/* Help */
  {
  if(stereo)
   stereo_switch(0,displ,dispr);
  goto newlife;
  }
 if(inch==0x00390020L)	/* Space */
  {
  do
   {
   inch=Crawcin();
   }
   while(inch!=0x00390020L);
  }
 else
 if(inch==0x00440000L)	/* F10 */
  {
  orig_screen();
  goto redo_form;
  }
 }

/*******************************/
/* display new life cell image */
/*******************************/

cop_sc(displ,lmap);
if(stereo)
 cop_sc(dispr,rmap);

if(status)
 {
 vst_color(handle,1);
 vswr_mode(handle,2);
 iset(generation,&stat_line[12],5,0,1);
 iset(cellcount,&stat_line[27],5,1,1);
 if(stereo)
  {
  Setscreen(dispr,-1L,-1);
  v_gtext(handle,160,199,stat_line);
  }
 Setscreen(displ,-1L,-1);
 v_gtext(handle,160,199,stat_line);
 }

if(cellcount==0)
 {
 vst_color(handle,13);
 if(stereo)
  {
  Setscreen(dispr,-1L,-1);
  v_gtext(handle,160,100,"*** NO LIFE ***");
  }
 Setscreen(displ,-1L,-1);
 v_gtext(handle,160,100,"*** NO LIFE ***");

 no_life:
 inch=Crawcin();
 if(inch==0x00610000L)	/* Undo */
  goto lifedone;
 if(inch==0x00620000L)	/* Help */
  {
  if(stereo)
   stereo_switch(0,displ,dispr);
  goto newlife;
  }
 if(inch==0x00440000L)	/* F10 */
  {
  orig_screen();
  goto redo_form;
  }
 goto no_life;
 }

goto lifecont;

/***********************************************/
/* All done, turn off stereo & restore palette */
/***********************************************/

lifedone:
if(stereo)
 stereo_switch(0,lmap,rmap);
Setpallete(oldpal);

/****************************/
/* Free resource allocation */
/****************************/

bail_out:
rsrc_free();

rsrc_bail:
v_hide_c(handle); 

/***************************/
/* Back to original screen */
/***************************/

Setscreen(s1phys,s1phys,oldrez);

/**************************/
/* Close the workstation. */
/**************************/

v_clsvwk(handle);
 
appl_exit();
}

/************************************************/
/* Set a 3-digit value in a string object	*/
/*						*/
/* Parameters:					*/
/* tree      = pointer to object tree		*/
/* index     = index of string object		*/
/* boxindex  = index of box containing string	*/
/* value     = 0-999 integer value		*/
/************************************************/

show_pos(tree,index,boxindex,value)
long tree[][6];
int index,boxindex,value;
{
iset(value,tree[index][3],3,1,0);
objc_draw(tree,boxindex,1,formx,formy,formw,formh);
}

/****************************************************/
/* Convert an integer value to a string		    */
/*						    */
/* Parameters:					    */
/* num      = integer number to convert		    */
/* string   = pointer to target string		    */
/* count    = number of digits			    */
/* term     = terminate string? 0=no, <>0=yes	    */
/* zsup     = zero suppression? 0=no, <>0=yes	    */
/****************************************************/

iset(num,string,count,term,zsup)
int num,count,term,zsup;
char *string;
{
register int ix,divfac,dct;

divfac=1;
for(ix=1; ix<count; ++ix)
 divfac*=10;

for(ix=0; ix<count; ++ix,divfac/=10)
 {
 dct=num/divfac;
 string[ix]=(char)dct+'0';
 num-=(dct*divfac);
 }

if(term)
 string[count]=0;

if(zsup)
 {
 for(ix=0; ix<(count-1); ++ix)
  {
  if(string[ix]=='0')
   string[ix]=' ';
  else
   break;
  }
 }
}

/****************************************/
/* Select an item in a dialog 		*/
/*					*/
/* Parameters:				*/
/* tree	  = pointer to object tree	*/
/* index  = index of object to select	*/
/****************************************/

srcon(tree,index)
long tree;
int index;
{
objc_change(tree,index,0,formx,formy,formw,formh,1,1);
}

/****************************************/
/* Deselect an item in a dialog 	*/
/*					*/
/* Parameters:				*/
/* tree	  = pointer to object tree	*/
/* index  = index of object to deselect	*/
/****************************************/

srcoff(formad,index)
long formad;
int index;
{
objc_change(formad,index,0,formx,formy,formw,formh,0,1);
}

/************************************************/
/* Find radio button that is selected		*/
/*						*/
/* Parameters:					*/
/* tree    = pointer to object tree		*/
/* fradio  = index of first radio button	*/
/* radcnt  = number of radio objects in group	*/
/*						*/
/* Returns number of selected radio button,	*/
/* ranging from 0 to radcnt-1			*/
/************************************************/

radio(tree,fradio,radcnt)
long tree;
int fradio,radcnt;
{
register int ix;
int butnum;

butnum= -1;
for(ix=0; ix<radcnt; ++ix)
 {
 if(itmstate(tree,fradio+ix) & 0x0001)
  butnum=ix;
 }
return(butnum);
}

/************************************************/
/* Reset a group of radio buttons		*/
/*						*/
/* Parameters:					*/
/* tree    = pointer to object tree		*/
/* fradio  = index of first radio button	*/
/* radcnt  = number of radio objects in group	*/
/************************************************/

radreset(tree,fradio,radcnt)
long tree;
int fradio,radcnt;
{
register int ix;

for(ix=0; ix<radcnt; ++ix)
 srcoff(tree,fradio+ix);
}

/****************************************/
/* Find state of an object		*/
/*					*/
/* Parameters:				*/
/* tree   = pointer to object tree	*/
/* index  = index of object		*/
/****************************************/

itmstate(tree,index)
int tree[][12];
int index;
{
return(tree[index][5]);
}

/*****************************************/
/* Go back to original screen, no stereo */
/*****************************************/

orig_screen()
{
if(stereo)
 stereo_switch(0,lmap,rmap);
Setscreen(s1phys,s1phys,-1);
}

/***************/
/* cell editor */
/***************/

editor()
{
int mousex,mousey,lastx,lasty,mstate,kstate,cellplot;
int box[4];

/********************************/
/* Point to work screen, set up */
/********************************/

wind_update(3);		/* Take control of mouse */
v_hide_c(handle);
Setscreen(lmap,lmap,0);
vsf_interior(handle,0);
cellz=0;
if(dim==1)
 show_slice();
draw_frame();

v_show_c(handle,0);

/*****************************************/
/* Watch mouse, respond to mouse buttons */
/* and keypresses (3D only)		 */
/*****************************************/

edit_it:

do
 {
 graf_mkstate(&mousex,&mousey,&mstate,&kstate);
 }
 while(mstate==0);

if(mstate==2)
 {
 while(mstate)
  graf_mkstate(&mousex,&mousey,&mstate,&kstate);
 v_hide_c(handle);
 Setscreen(displ,displ,0);
 wind_update(2);		/* Return control of mouse */
 return;
 }

/********************************************/
/* Left mouse button pressed, find location */
/********************************************/

if(dim==1 && mousey>19 && mousey<31 && mousex<28)
 {
 if(mousex>3 && mousex<12 && cellz>0)	/* decrement slice */
  {
  cellz--;
  draw_slice();
  }
 else
 if(mousex>19 && cellz<31)	/* increment slice */
  {
  cellz++;
  draw_slice();
  }

 evnt_timer(500,0);	/* Repeat delay = 500 ms */

 goto edit_it;
 }

if(mousex<52 || mousex>276 || mousey<5 || mousey>196)
 goto edit_it;

/**************************************/
/* Mouse in edit rectangle, go to it! */
/**************************************/

cellx=(mousex-52)/7;
celly=(mousey-5)/6;

if(dim==1)
 cellplot=1-cell[cellz][31-celly][31-cellx];	/* Flip axes on 3D */
else
 cellplot=1-cell[cellz][celly][cellx];		/* Normal axes on 2D */

lastx=lasty=999;

vswr_mode(handle,1);

while(mstate==1)
 {
 if(mousex>51 && mousex<275 && mousey>4 && mousey<197)
  {
  cellx=(mousex-52)/7;
  celly=(mousey-5)/6;
 
  /*************************************/
  /* If new location, plot/erase cell! */
  /*************************************/

  if(cellx!=lastx || celly!=lasty)
   {
   if(dim==1)
    cell[cellz][31-celly][31-cellx]=cellplot;	/* Flip axes if 3D */
   else
    cell[cellz][celly][cellx]=cellplot;		/* Normal axes on 2D */

   lastx=cellx;
   lasty=celly;

   v_hide_c(handle);

   if(cellplot)
    {

    /*************/
    /* Plot cell */
    /*************/

    quikblit(lmap,&MASKS[8],&LEFTS[8],cellx*7+55,celly*6+7);
    }
   else
    {

    /***************/
    /* Erase cell! */
    /***************/

    box[0]=cellx*7+53;
    box[1]=celly*6+5;
    box[2]=box[0]+6;
    box[3]=box[1]+5;
    vr_recfl(handle,box);
    }

   v_show_c(handle,0);
   }
  }

 graf_mkstate(&mousex,&mousey,&mstate,&kstate);
 }

goto edit_it;
}

/**********************************/
/* Display slice number on screen */
/**********************************/

show_slice()
{
static char slice[3];

iset(cellz,slice,2,1,1);
vst_color(handle,1);
vswr_mode(handle,2);
v_gtext(handle,16,10,slice);
v_gtext(handle,16,30,"- +");
draw_frame();
}

/*******************************/
/* Draw frame around cell area */
/*******************************/

draw_frame()
{
static int frame[10]=
{
51,4,
277,4,
277,197,
51,197,
51,4
};

vsl_color(handle,1);
v_pline(handle,5,frame);
}

/******************************************/
/* Display a slice of cells on the screen */
/******************************************/

draw_slice()
{
register int ix,iy,jx,jy;

v_hide_c(handle);

clr_sc(lmap);

show_slice();		/* Display new slice */

for(iy=0,jy=31; iy<32; ++iy,--jy)
 {
 for(ix=0,jx=31; ix<32; ++ix,--jx)
  {
  if(cell[cellz][jy][jx])
   quikblit(lmap,&MASKS[8],&LEFTS[8],ix*7+55,iy*6+7);
  }
 }

v_show_c(handle,0);
}

/****************************************************/
/* RESET HORIZONTAL SLIDER			    */
/* -----------------------			    */
/* Parameters:					    */
/* number  = slider number (0-9)		    */
/* tree    = address of dialog tree		    */
/* trackix = index of slider track		    */
/* slidix  = index of slider			    */
/* maximum = maximum slider setting (0-maximum)     */
/* initial = initial slider setting (0-maximum)     */
/****************************************************/

hreset(number,tree,trackix,slidix,maximum,initial)
int number,tree[][12],trackix,slidix,maximum,initial;
{
slidmax[number]=maximum;
slidpos[number]=initial;
slidstep[number]=((long)(tree[trackix][10]-tree[slidix][10])<<16)/(long)maximum;
slidacc[number]=slidstep[number]*(long)initial;
tree[slidix][8]=(int)(slidacc[number]>>16);
objc_draw(tree,trackix,1,tree[0][8],tree[0][9],tree[0][10],tree[0][11]);
}

/****************************************************/
/* PROCESS HORIZONTAL SLIDER			    */
/* -------------------------			    */
/* Parameters:					    */
/* number  = slider number (0-9)		    */
/* tree    = address of dialog tree		    */
/* trackix = index of slider track		    */
/* slidix  = index of slider			    */
/* leftix  = index of left-move button		    */
/* rightix = index of right-move button		    */
/* whichix = index of item from form_do		    */
/* trakstep = # of steps for in-track click	    */
/****************************************************/

do_hslider(number,tree,trackix,slidix,leftix,rightix,whichix,trakstep)
int tree[][12],trackix,slidix,leftix,rightix,whichix,trakstep;
{
register int ix;
int tempx,kbtest,repeat;

graf_mkstate(&tempx,&tempx,&tempx,&kbtest);
if(kbtest & 3)
 repeat=trakstep;
else
 repeat=1;
moved=0;

/****************************************************/
/* If click in track, determine direction of slider */
/* movement & move it TRAKSTEP times in that dir.   */
/****************************************************/

if(whichix==trackix)
 {
 graf_mkstate(&mousex,&mousey,&dum,&dum);
 objc_offset(tree,slidix,&sbasex,&dum);
 if(mousex>sbasex)
  {
  for(ix=0; ix<trakstep; ++ix)
   {
   if(slidpos[number]<slidmax[number])
    {
    slidacc[number]+=slidstep[number];
    slidpos[number]++;
    moved=1;
    }
   else
    break;
   }
  }
 else
  {
  for(ix=0; ix<trakstep; ++ix)
   {
   if(slidpos[number]>0)
    {
    slidacc[number]-=slidstep[number];
    slidpos[number]--;
    moved=1;
    }
   else
    break;
   }
  }
 }
else

/****************************************************/
/* Move slider to the right 1 unit.		    */
/****************************************************/

if(whichix==rightix)
 {
 for(ix=0; ix<repeat; ++ix)
  {
  if(slidpos[number]<slidmax[number])
   {
   slidacc[number]+=slidstep[number];
   slidpos[number]++;
   moved=1;
   }
  else
   break;
  }
 }
else

/****************************************************/
/* Move slider to the left 1 unit.		    */
/****************************************************/

if(whichix==leftix)
 {
 for(ix=0; ix<repeat; ++ix)
  {
  if(slidpos[number]>0)
   {
   slidacc[number]-=slidstep[number];
   slidpos[number]--;
   moved=1;
   }
  else
   break;
  }
 }
else

/****************************************************/
/* Clicked on slider -- allow user to drag the      */
/* slider and then record new position		    */
/****************************************************/

if(whichix==slidix)
 {

 /******************************************/
 /* Get slider screen coordinates	   */
 /******************************************/

 objc_offset(tree,slidix,&sbasex,&sbasey);

 /******************************************/
 /* Get track screen coordinates	   */
 /******************************************/

 objc_offset(tree,trackix,&tbasex,&tbasey);

 /******************************************/
 /* Drag the slider inside the track, and  */
 /* put final x coordinate in tempx.	   */
 /******************************************/

 graf_dragbox(tree[slidix][10],tree[slidix][11],sbasex,sbasey,
              tbasex,tbasey,tree[trackix][10],tree[trackix][11],
              &tempx,&dum);

 /******************************************/
 /* If slider was moved, save new position */
 /******************************************/

 if(tempx!=sbasex)
  {
  slidacc[number]=(long)(tempx-tbasex)<<16;
  slidpos[number]=(int)(slidacc[number]/slidstep[number]);
  slidacc[number]=(long)slidpos[number]*slidstep[number];
  moved=1;
  }
 }

/****************************************************/
/* Redraw slider track (& slider) if the slider was */
/* moved by the user's action			    */
/****************************************************/

if(moved)
 {
 tree[slidix][8]=(int)(slidacc[number]>>16);
 objc_draw(tree,trackix,1,tree[0][8],tree[0][9],tree[0][10],tree[0][11]);
 }
}
