{ Title          The Game Cupboard          version 1.0
  Author         Mark E. Nelson
  Last Update    February 12, 1988
}

Program The_Game_Cupboard; 
{                   
                   Copyright (c) 1988 by ST-Log 
       Portions of this code may be used freely as long as the title
     screen contains the message, "Portions of this program were
     published in ST-Log and were written by Mark E. Nelson."
}
 
{$P-}

{$I Gemsubs.pas}
{$I Auxsubs.pas}

Const
  { constants for sound routines }
  cmd_write = 128;
  cmd_read  = 0;
  chana_lo  = 0;
  chana_hi  = 1;
  chana_vol = 8;
  chan_enable = 7;
  enable_sound=7;
  { musical notes for use with sound routines }
  A2 = 600;
  B2 = 530;
  C2 = 470;
  D2 = 437;
  E2 = 396;
  F2 = 350;
  G2 = 310;
  A3 = 300;
  B3 = 265;
  C3 = 235;
  D3 = 220;
  E3 = 198;
  F3 = 175;
  G3 = 157;
  A4 =150;
  A1 = 1200;
  B1 = 1060;
  C1 = 940;
  D1 = 880;
  E1 = 800;
  F1 = 700;
  G1 = 620;
 
  My_Brown = 7;
  Same = -1;

Type
 Channel = 0..2;      { for sound routines }
 
 lights_array = array[1..250] of integer;
 Screen_ptr = Record
               case boolean of
                False: (p:^Screen_L);  { Screen_L defined in AUXSUBS.PAS }
                True: (l:Long_integer);
              end;

Var
 Noise, Tone: boolean;      { for sound routines }
 Exit_Game, Button: boolean;
 Mouse_x, Mouse_y, num_answers: integer;
 Msg_Area:Message_Buffer;
 Eight_Scr, Cupboard_Scr, Nought_Scr, Repeat_Scr: Screen_type;
 Roll_Eight: array[1..5] of Screen_ptr;
 board: array[1..9] of integer;
 answers: array[1..100] of string;  
   
Function Random(Max:Integer):Integer;
 FORWARD;

Function GetRez:Integer;
 XBIOS(4);

Function physbase: long_integer;
 XBIOS(2);

Function logbase: long_integer;
 XBIOS(3);
 
Procedure setscreen(logadr, physadr: long_integer; res: integer);
 XBIOS(5);

Procedure Sav_Scn(Sav_To: Screen_Ptr);
 var Sav_From: Screen_Ptr;
 begin
  Sav_From.l:=Physbase;
  Sav_To.p^:=Sav_From.p^
 end; { of Proc Sav_Scn }

Procedure Rest_Scn(Sav_From: Screen_Ptr);
 var Sav_To: Screen_Ptr;
 begin
  Sav_To.l:=Physbase;
  Sav_To.p^:=Sav_From.p^
 end; { of Proc Rest_Scn }

Procedure Str(value:integer; var number:string);
{ This Procedure converts an integer value to a string of digits }

Var
 temp,I:Integer;
 Gotit:boolean;
begin
 Gotit:=false;
 Number:='';
 If value<0 then begin
   Number:='-';
   Value:=abs(value);
  end;
 If value=0 then number:='0';
 For I:=4 downto 0 do begin
  temp:=value div round(pwroften(I));
  If temp>0 then Gotit:=true;
  If Gotit then number:=concat(number,chr(ord(48)+temp));
  Value:=Value- temp*round(pwroften(I))
  end
 end;{ of Procedure Str }


Procedure Main_Event(Time:Long_Integer);
 FORWARD;

Procedure Box_Cmd(cmd,i1,i2,i3,i4,i5,i6,i7,i8:integer; Var out1,out2:integer);
 Var
  Int_in:Int_in_parms;
  Int_out:Int_out_parms;
  Addr_in:Addr_in_parms;
  Addr_out:Addr_out_parms;

Begin
 int_in[0]:=i1;
 int_in[1]:=i2;
 int_in[2]:=i3;
 int_in[3]:=i4;
 int_in[4]:=i5;
 int_in[5]:=i6;
 int_in[6]:=i7;
 int_in[7]:=i8;
 AES_Call(cmd,int_in,Int_out,addr_in,addr_out);
 out1:=int_out[1];
 out2:=int_out[2]
End; { of procedure Box_Cmd }

Procedure Grow_Shrink(cmd, small_x, small_y, small_w, small_h,
                      big_x, big_y, big_w, big_h:integer );
 Var
  int_in:Int_in_parms;
  int_out:Int_out_parms;
  addr_in:addr_in_parms;
  addr_out:addr_out_parms;

 Begin
  Int_in[0]:=small_x;
  Int_in[1]:=small_y;
  Int_in[2]:=small_w;
  Int_in[3]:=small_h;
  Int_in[4]:=big_x;
  Int_in[5]:=big_y;
  Int_in[6]:=big_w;
  Int_in[7]:=big_h;
  AES_Call(cmd, int_in, Int_out, addr_in, addr_out)
 End; { of Procedure Grow_Shrink }

Procedure Grow_Box(small_x, small_y, small_w, small_h,
                   big_x, big_y, big_w, big_h:integer);
 Begin
  Grow_Shrink(73, small_x, small_y, small_w, small_h,
             big_x, big_y, big_w, big_h)
 End; { of Prodedure Grow_Box }

Procedure Shrink_Box(big_x, big_y, big_w, big_h,
                     small_x, small_y, small_w, small_h:integer);
 Begin
  Grow_Shrink(74, small_x, small_y, small_w, small_h,
             big_x, big_y, big_w, big_h)

 End; { of procedure Shrink_Box }

Procedure Move_Box(x,y,w,h,new_x,New_y:Integer);
begin
 Grow_Shrink(72,w,h,x,y,new_x,new_y,0,0)
end; { of procedure Move_Box }

Procedure Wait( Seconds: Long_Integer); 
Var Message:Message_Buffer;
     d:Integer;
Begin
 Seconds:=Seconds*1000;
 Main_Event(Seconds)
End; { of procedure Wait }

Function gia_read (data, register:integer):integer;
 XBIOS (28);

Procedure gia_write (data, register:integer);
 XBIOS (28);

Procedure Sound_init;
 Var
  Port_state:integer;

 Begin
  port_state:=gia_read(0,chan_enable+cmd_read);
  gia_write(port_state&(~enable_sound),chan_enable+cmd_write);
  {Next three lines added by me}
  port_state:=gia_read(0,7+cmd_read);
  gia_write(port_state | 56,7+cmd_write);
  port_state:=gia_read(0,7+cmd_read);
  If Noise then gia_write(port_state & (~56),7+cmd_write)
           else gia_write(port_state | 56,7+cmd_write);
  port_state:=gia_read(0,7+cmd_read);
  If Tone then gia_write(port_state & (~7),7+cmd_write)
          else gia_write(port_state | 7,7+cmd_write)

 End; { Of Procedure Sound_init }

Procedure Sound(ch:channel; pitch:integer; vol:integer);
 Begin
  Sound_Init;
  gia_write(vol,chana_vol+ch+cmd_write);
  gia_write(pitch&$FF, chana_lo+ch*2+cmd_write);
  gia_write(shr(pitch,8),chana_hi+ch*2+cmd_write);
  gia_write(pitch&$FF,6+cmd_write)
 end; { Of Procedure Sound }

Procedure Sound_off;

 Var
  port_state:integer;

 Begin
  Sound(0,0,0);
  Sound(1,0,0);
  Sound(2,0,0);
  port_state:=gia_read(0,chan_enable+cmd_read);
  gia_write(port_state|enable_sound, chan_enable+cmd_write)
 end; { Of Procedure Sound_Off }

Procedure Wait_Sound(Time:integer);
var x,y,j:Integer;
Begin
 For J:=1 to 100 do For x:=1 to Time do y:=x*100-3+14*2 div 100
end; { Of Procedure Wait_Sound }

Procedure Wrong_Sound;
 Var
  Count:Integer;
 Begin
  Tone:=True;Noise:=False;
  For Count:=1 to 2 do begin
   Sound(1,2260,15);
   Sound(2,2538,15);
   Sound(0,2260,15);
   Wait_Sound(30);
   Sound_Off;
   Wait_Sound(4)
   end
 end;  { Of procedure Wrong_Sound }

Procedure Happy_Sound;
 Var
  Volume,Note:Integer;
 Begin
  Volume:=12;
  Tone:=True;Noise:=False;
  For note:=1 to 3 do begin
   Sound(0,a2,volume);
   Sound(1,c2,volume);
   Sound(2,e2,volume);
   If Note=1 then Wait_Sound (60) else Wait_Sound(35);
   Sound_off;Wait_Sound(1)
   end;
 Sound(0,a4,volume);
 Sound(1,c3,volume);
 Sound(2,e3,volume);
 Wait_Sound(200);
 For Note:=1 to volume-5 do begin
   Sound(0,a4,volume-Note);
   Sound(1,c3,volume-Note);
   Sound(2,e3,volume-Note);
   Wait_Sound(2)
   end;
  Sound_off
 end; { Of Procedure Happy_Sound }

Procedure Comp_moved_Sound;
var volume: integer;
begin
  tone:=true; noise:=false;
  volume:=12;
  Sound(0,a4,volume);
  Sound(1,a3,volume);
  Sound(2,a2,volume);
  wait_sound(20);
  Sound(0,a3,volume);
  Sound(1,a2,volume);
  Sound(2,a1,volume);
  wait_sound(20);
  Sound_Off;
end; { of Procedure Comp_moved_Sound }

Procedure Hum_moved_sound;
var volume: integer;
begin
  tone:=TRUE; noise:=FALSE;
  volume:=12;
  Sound(0,a3,volume);
  sound(1,a2,volume);
  sound(2,a1,volume);
  wait_sound(20);
  sound(0,a4,volume);
  sound(1,a3,volume);
  sound(2,a2,volume);
  wait_sound(20);
  sound_off;
end; { of procedure Hum_moved_sound }  

Procedure Lights_Sound(Light, Length: integer);
var volume: integer;
begin
  tone:= TRUE; noise:= FALSE;
  volume:=12;
  Case light of
    1: begin
         Sound(0,a3,volume);
         Sound(1,a2,volume);
         Sound(2,a1,volume);
       end;
    2: begin
         Sound(0,b3,volume);
         Sound(1,b2,volume);
         Sound(2,b1,volume);
       end;
    3: begin
         Sound(0,c3,volume);
         Sound(1,c2,volume);
         Sound(2,c1,volume);
       end;
    4: begin
         Sound(0,d3,volume);
         Sound(1,d2,volume);
         Sound(2,d1,volume);
       end;
   end;
   Wait_Sound(Length);
   Sound_off;       
end; { of procedure lights_sound }

Procedure Correct_Sound;
 Var
  Volume,Note:integer;
 Begin
  Volume:=11;
  Tone:=True;Noise:=False;
  Note:=1;
  Repeat
    Sound(1,993-Note,Volume);
    Sound(2,1001-Note,Volume);
    Sound(0,997-Note,Volume);
    Note:=Note+15;
  Until Note>1000;
  Sound_off
 end; { Of Procedure Correct_Sound }

Function XB_Rnd:Long_Integer;
 XBIOS(17);

Function Random; {Declared prior with FORWARD }
 var I:Integer;
 Begin
  I:=Abs(Int(XB_Rnd) Mod (Max+1));
  If (I<1) OR (I>Max) then I:=Random(Max);
  Random:=I
 End; { of Function Random }

Procedure Get_Out;
{ exits the program unconditionally }
 Begin
  Exit_Gem;
  Halt
 End; { of procedure Get_out }

Procedure Main_Event; { declared prior with FORWARD }
 Var d,event,bstate:integer;    { d is a dummy variable }
     
 begin
   event:=Get_Event(E_Button|E_Timer,1,1,1,Time,
                    False,0,0,0,0,False,0,0,0,0,
                    msg_area,d,d,bstate,Mouse_x,Mouse_y,d);

If (Event & E_Button) <> 0 { Then a button has been pressed }
  then
    button:= TRUE
  
  else              { a timer event has occured }
    button:= FALSE;
  
end; { of procedure Main_Event }

Procedure Get_Button;
begin
  Repeat
    Main_Event(100)             { wait for mouse button input }
  Until button;
end; { of Procedure Get_Button }

Procedure Init_Screens;
{ set up the eight ball screens }
var i: integer;
    log: long_integer;
begin
  hide_mouse;
  set_clip(0,0,320,200);
  log:=logbase; 
  for i:= 1 to 5 do begin
    new(Roll_Eight[i].p);
    Roll_Eight[i].p^:=Eight_Scr.pic;  { Each gets a copy of 8 ball screen }
  end;
  setscreen(Roll_Eight[1].l, Same, Same); { work on screen 1 }
  paint_color(black);
  paint_style(1);
  paint_oval(158,110,67,67);           { 8 ball itself }
  paint_Color(white);
  paint_oval(158,125,28,28);           { white circle in 8 ball }
  paint_Color(black);
  for i:=1 to 5 do begin
    frame_oval(158,116,(4+i),(4+i));   { draw top circle of 8 }
    frame_oval(158,131,(8+i),(7+i));   { bottom circle of 8 }
  end;
  setscreen(Roll_Eight[2].l, Same, Same); { work on screen 2 }
  paint_color(black);
  paint_oval(158,130,95,95);              { 8 ball itself }
  paint_color(white);
  paint_oval(158,177,35,35);           { white circle in 8 ball }
  paint_color(black);
  for i:=1 to 8 do begin
    frame_oval(158,168,(4+i),(4+i));
    frame_oval(158,189,(5+i),(7+i));
  end;
  setscreen(Roll_Eight[3].l, Same, Same); { work on Screen 3 }
  paint_oval(158,140,110,110);              { 8 ball itself }
 
  setscreen(Roll_Eight[4].l, Same, Same); { work on screen 4 }
  paint_oval(158,150,125,125);              { 8 ball itself }
  paint_color(11);  { dark blue }
  paint_round_rect(110,60,100,15);
  
  setscreen(Roll_Eight[5].l, Same, Same); { work on screen 5 }
  paint_color(black);
  paint_oval(158,160,140,140);            { 8 ball itself }
  paint_color(11); { dark blue }
  paint_round_rect(100,110,120,30);
  
  setscreen(log, Same, Same);
  show_mouse;   
end; { of procedure init_screens }

Procedure Initialize;
 Var
  Rez,x:integer;
  f: file of text;
 begin
  Hide_Mouse;
  Exit_Game:= FALSE;
  Rez:=GetRez;
  If Rez=1 then begin
    x:=Do_Alert ('[0][  |  Switch to Low Resolution      |  ][   OK   ]',1);
    Get_Out
    end;
  Clear_Screen;
  x:=Read_Scrn('CUPBOARD.PI1', Cupboard_Scr);   { Read picture screens }
  ScrRest(Cupboard_Scr);
  Set_Mouse(M_Bee);
  Show_Mouse;
  x:=Read_Scrn('EIGHT.PI1', Eight_Scr);
  x:=Read_Scrn('NOUGHT.PI1',Nought_Scr);
  x:=Read_Scrn('REPEAT.PI1',Repeat_Scr);
  Reset(f,'ANSWERS.EIT');
  num_answers:=0;
  While ((NOT EOF(f)) AND (num_answers<100)) do begin
    num_answers:=num_answers+1;
    Readln(f,answers[num_answers]); { read 8 ball answers }
  end;
  close(f);
  Init_Screens;
  Set_Mouse(M_Arrow);
 end; { of Procedure Initialize }

{************************************************************************
************************** Repeat Procedures ****************************
*************************************************************************}

Procedure light(which_light, length: integer);
Const
  w = 70;
  h = 43;
  
begin
  hide_mouse;
  case which_light of
    1: begin
         Paint_Color(6);
         Paint_Rect(77,32,w,h);
         lights_sound(which_light, length);
         Paint_Color(2);
         Paint_Rect(77,32,w,h);
       end;
    2: begin
         Paint_Color(8);
         Paint_Rect(172,32,w,h);
         lights_sound(which_light, length);
         Paint_Color(14);
         Paint_Rect(172,32,w,h);
       end;
    3: begin
         Paint_Color(0);
         Paint_Rect(77,100,w,h);
         lights_sound(which_light, length);
         Paint_Color(4);
         Paint_Rect(77,100,w,h);
       end;
    4: begin
         paint_color(10);
         Paint_Rect(172,100,w,h);
         lights_sound(which_light, length);
         paint_Color(11);
         Paint_Rect(172,100,w,h);
       end;
  end; 
  show_mouse;
end; { of procedure light }

Procedure Show_Lights(var lights: lights_array; var count: integer);
{ Shows the previous moves and adds another }
var i, length: integer;
begin
  wait_sound(200);                         { pause a moment }
  count:=count+1;                          { inc count }
  if (count< 6) then length:= 100          { set sound length }
    else if (count<11) then length:=75
    else if (count<16) then length:=50
    else if (count<21) then length:=40
    else if (count<26) then length:=35
    else length:=30; 
  lights[count]:= random(4);               { add a new light }
  for i:= 1 to (count-1) do begin          { show the lights }
    light(lights[i], length);
    wait_sound((length div 10));
    end;
  light(lights[count], 100);  { show last light a tad longer }
end; { of Procedure Show_Lights }

Procedure Get_A_Light(lights: lights_array; which_light: integer; 
                      var Wrong, Exit_Repeat: boolean);
var x,y, selected,i: integer;
    OK: boolean;
begin
  OK:= FALSE; selected:=0;
  Repeat
  get_button;
  x:= mouse_x;  y:= mouse_y;
  if ((x>=72) AND (x<=146)) then     { Left side }
    If ((y>=32) AND (y<=74)) then    { top Left  }
      selected:=1 else
    if ((y>=100) AND (y<=142)) then  { bottom left }
      selected:=3 else
  else
  if ((x>=172) AND (x<=241)) then    { Right Side }
    If ((y>=32) AND (y<=74)) then    { top right  }
      selected:=2 else
    if ((y>=100) AND (y<=142)) then  { bottom right }
      selected:=4;
  If ((x>=141) AND (x<=178) AND (y>=82) AND (y<=92))
    then Exit_Repeat:=TRUE;
  OK:= (selected<>0)
  Until (OK OR Exit_Repeat);
  light(selected, 50);
  If (selected=which_light) then Wrong:=FALSE
    else Wrong:=TRUE;
  If (Wrong AND (NOT Exit_Repeat)) then begin
    wrong_sound;
    for i:= 1 to 5 do
      light(which_light,15);
    end;
end; { of Procedure Get_A_Light }

Procedure Get_Lights(lights: lights_array; count: integer;
                       var game_over, Exit_Repeat: boolean);
{ gets human input and checks for validity. }
var i: integer;
begin
  i:=1; Game_Over:= FALSE;
  Repeat
    Get_A_Light(lights,lights[i],Game_Over,Exit_Repeat);
  i:=i+1;
  Until (Game_Over OR (i>count) or Exit_Repeat);
end; { of procedure get_lights }

Procedure Update_Score(var hi, score: integer; var New_hi: boolean);
{ updates the hi score and the reg score }
var st: string;
begin
  Hide_mouse;
    Str(score,st);
    draw_String(24,30,st);
    If (score>hi) then begin
      New_hi:=TRUE;
      hi:=score;
      str(hi,st);
      draw_string(272,30,st);
    end;
  Show_mouse;
end; { of procedure update_score }

Procedure Repeat_Game;
var
  lights: lights_array;
  Count, i, hi: integer;
  Exit_Repeat, Game_Over, New_hi: boolean;
  st: string;
  f: file of integer;
    
begin
  Grow_Box(118, 88, 76, 30, 0, 0, 320, 200);
  Hide_Mouse;
  ScrRest(Repeat_Scr);
  Show_Mouse;
  Exit_Repeat:= FALSE; New_hi:=FALSE;

  IO_Check(FALSE);
  Reset(f,'Repeat.hi');
  If (IO_Result>=0) then begin
    Read(f,hi);
    close(f);
    end
  else hi:=0;

  Repeat
    Hide_Mouse;
    Draw_String(52,140,'Click mouse button to play.');
    Show_Mouse;
    get_button;
    Hide_Mouse;
    ScrRest(Repeat_Scr);
    str(hi,st);
    Draw_String(272,30,st);
    Draw_String(24,30,'0    ');
    Show_Mouse;
    Count:=0;  Game_Over:= FALSE;
    Repeat
      Show_lights(lights, count);
      Get_Lights(lights,count,Game_Over,Exit_Repeat);
      If NOT Game_Over then Update_Score(hi, count, New_hi);
    Until (Game_Over OR Exit_Repeat);
  Until Exit_Repeat;
  
  If New_hi then begin          { save hi score to disk }
    Rewrite(f,'Repeat.hi');
    Write(f,hi);
    close(f);
  end;
  
  hide_Mouse;
  ScrRest(Cupboard_Scr);
  Shrink_Box(0,0,320,200,118,88,76,30);
  Show_Mouse;
end; { of Procedure Repeat_Game }

{************************************************************************
*********************** Eight Ball Game Procedures **********************
*************************************************************************}

Procedure Show_Answer;
var i: integer;
    temp_scr: screen_ptr;
    ans,temp1,temp2: string;
begin
  Hide_mouse;
  new(temp_scr.p);
  Sav_Scn(temp_scr);
  for i:=1 to 5 do begin              { roll the ball }
    Rest_Scn(Roll_Eight[i]);
    wait_sound(5);
  end;
  
  i:= random(num_answers);            { randomly select an answer }
  ans:=answers[i];
  
  if (length(ans)>14) then            { parse ans into two strings }
    begin
      i:=15;
      while (i>1) AND (ans[i]<>' ') do i:=i-1;  { search for space }
      if i<=1 then         { no spaces found }
        begin
          temp1:=ans;
          temp2:='';
        end
      else                 { space WAS found }
        begin
          temp1:=copy(ans,1,i-1);   { first i elements to temp1 }
          temp2:=copy(ans,i+1,(length(ans)-i)); { rest to temp2 }
        end;
    end
  else 
    begin
      temp1:=ans;
      temp2:='';
    end;
  
  Text_color(13);
  Set_Color(13,0,0,1000);  
  Draw_mode(2);                       { draw the answer }
  if temp2<>'' then begin
  	Draw_String(160-(4*length(temp1)), 122, temp1);
  	Draw_String(160-(4*length(temp2)), 132, temp2);
  end else
    Draw_String(160-(4*length(temp1)), 127, temp1);  
  Show_Mouse;
  Draw_mode(1);
  Text_Color(black);
  
  for i:=0 to 1000 do           { fade words in }
    set_color(13,i,i,1000);
    
  get_button;                   { wait for a button event }
  
  Hide_mouse;
  for i:=5 downto 1 do begin     { unroll the ball }
    Rest_Scn(Roll_Eight[i]);
    wait_Sound(5);
  end;
  Rest_Scn(temp_scr);
  Show_Mouse;
  dispose(temp_scr.p);
end; { of procedure Show_answer }

Procedure Answer;
var Exit_Answer: boolean;
    x, y: integer;
begin
  Exit_Answer:= FALSE;
  Repeat
    get_button;
    x:= mouse_x; y:= mouse_y;
    If ((x>=263) AND (x<=299) AND (y>=189) AND (y<=199))
      then Exit_Answer:= TRUE
      else Show_Answer;
  Until Exit_Answer;
end; { of Procedure Answer }

Procedure Eight_Ball;
begin
  Grow_Box(118, 124, 76, 30, 0, 0, 320, 200);
  Hide_Mouse;
  ScrRest(Eight_Scr);
  Show_Mouse;
  Answer;
  Hide_Mouse;
  ScrRest(Cupboard_Scr);
  Shrink_Box(0,0,320,200,118,124,76,30);
  Show_mouse;  
end; { of Procedure Eight_Ball }

{***********************************************************************
************************  Noughts Procedures ***************************
************************************************************************}

Procedure Show_Move(Letter: string; move: integer);
{ Shows the letter in position held by move }
begin
  hide_mouse;
  Text_Height(20);
  case move of                        { place an 'x' or an 'o' }
    1: Draw_String(103,34,Letter);
    2: Draw_String(146,34,Letter);
    3: Draw_String(191,34,Letter);
    4: Draw_String(103,67,Letter);
    5: Draw_String(146,67,Letter);
    6: Draw_String(191,67,Letter);
    7: Draw_String(103,99,Letter);
    8: Draw_String(146,99,Letter);
    9: Draw_String(191,99,Letter);
  end;
  Hum_moved_sound;
  Text_Height(6);
  Show_mouse;  
end; { of Procedure Show_Move }

Procedure Get_Move(var exit_noughts, harder: boolean);
{  Gets a human move, shows it, and stores it.
   exit_noughts becomes true if exit is clicked rather than a move.
   Will not allow a move to a space that is not vacant.  }
Const
  Exit_Top      = 189;
  Exit_Bottom   = 199;
  Exit_Left     = 135;
  Exit_Right    = 172;
  Top           = 10;
  Top_Mid       = 44;
  Bottom_mid    = 77;
  Bottom        = 112;
  Left          = 81;
  Left_mid      = 127;
  Right_mid     = 172;
  Right         = 225;
  Easy_Left     = 16;
  Easy_Right    = 64;
  Hard_Left     = 251;
  Hard_Right    = 302;
  
var
  done, Left_Col, Mid_Col, Right_Col, Top_Row, Mid_Row, Bot_Row: boolean;
  x, y, move: integer;
    
begin
  Exit_Noughts:= FALSE; Left_Col:= FALSE; Mid_Col:= FALSE; 
  Right_Col:= FALSE; Top_Row:= FALSE; Mid_Row:= FALSE;
  Bot_Row:= FALSE; done:= FALSE;
  Repeat
    Main_Event(100);
    If Button then begin
      x:= mouse_x;  y:= mouse_y;
      If ((x >= Exit_Left) AND (x <= Exit_Right) AND    { Check for Exit }
          (y >= Exit_Top)  AND (y <= Exit_Bottom))
        then Exit_Noughts:= TRUE;

      If ((x >= Easy_Left) AND (x <= Easy_Right) AND
          (y >= Exit_Top)  AND (y <= Exit_Bottom))
        then begin
          Hide_Mouse;
          Harder:= FALSE;
          Line_Color(Black);
          Line(Easy_Left,Exit_Bottom,Easy_Right,Exit_Bottom);
          Line(Easy_Left,Exit_Top,Easy_Right,Exit_Top);
          Line_Color(My_Brown);
          Line(Hard_Left,Exit_Bottom,Hard_Right,Exit_Bottom);
          Line(Hard_Left,Exit_Top,Hard_Right,Exit_Top);
          show_mouse;
        end;
      
      If ((x >= Hard_Left) AND (x <= Hard_Right) AND
          (y >= Exit_Top)  AND (y <= Exit_Bottom))
        then begin
          hide_mouse;
          Harder:= TRUE;
          Line_Color(My_Brown);
          Line(Easy_Left,Exit_Bottom,Easy_Right,Exit_Bottom);
          Line(Easy_Left,Exit_Top,Easy_Right,Exit_Top);
          Line_Color(Black);
          Line(Hard_Left,Exit_Bottom,Hard_Right,Exit_Bottom);
          Line(Hard_Left,Exit_Top,Hard_Right,Exit_Top);
          show_mouse;
        end;
      
      If ((x >= Left) AND (x <= Left_mid)) then Left_Col:= TRUE else
      If ((x >= Left_mid) AND (x <= Right_mid)) then Mid_Col:= TRUE else
      If ((x >= Right_mid) AND (x <= Right)) then Right_Col:= TRUE;
      if ((y >=Top) AND (y <= Top_mid)) then Top_Row:=TRUE else
      if ((y >=Top_mid) AND (y <= Bottom_mid)) then Mid_Row:= TRUE;
      if ((y >=Bottom_mid) AND (y <= bottom)) then Bot_Row:= TRUE;
      
 
      If (Left_Col AND Top_Row AND (board[1]=0)) then begin
          Show_Move('X',1);
          Board[1]:= 1;
          done:= TRUE;
          end else
      If (Left_Col AND Mid_Row AND (board[4]=0)) then begin
          Show_Move('X',4);
          board[4]:=1;
          done:= TRUE;
          end else
      If (Left_Col AND Bot_Row AND (board[7]=0)) then begin
          Show_Move('X',7);
          board[7]:=1;
          done:= TRUE;
          end else
      If (Mid_Col AND Top_Row AND (board[2]=0)) then begin
          Show_Move('X',2);
          board[2]:= 1;
          done:= TRUE;
          end else
      If (Mid_Col AND Mid_Row AND (board[5]=0)) then begin
          Show_Move('X',5);
          board[5]:=1;
          done:= TRUE;
          end else
      If (Mid_Col AND Bot_Row AND (board[8]=0)) then begin
          Show_move('X',8);
          board[8]:= 1;
          done:= TRUE;
          end else
      If (Right_Col AND Top_Row AND (board[3]=0)) then begin
          Show_move('X',3);
          board[3]:=1;
          done:= TRUE;
          end else
      If (Right_Col AND Mid_Row AND (board[6]=0)) then begin
          Show_move('X',6);
          board[6]:=1;
          done:= TRUE;
          end else
      If (Right_Col AND Bot_Row AND (board[9]=0)) then begin
          Show_move('X',9);
          board[9]:= 1;
          done:= TRUE;
          end;
      
    end;
  Until done OR Exit_Noughts;
end; { of Function Get_Move }

Procedure Comp_Move( Move: integer );
{ Marks the computer move at board[move] and shows it on screen. }
begin
  board[move]:= 2;
  Show_Move('O',move);
  comp_moved_sound;
end; { of Procedure Comp_Move }

Function All_2(x,y,z: integer): boolean;
{ returns true if board[x] - board[z] are all 2's }
begin
  All_2:= (board[x]=2) AND (board[y]=2) AND (board[z]=2);
end; { of Function All_2 }

Function All_1(x,y,z: integer): boolean;
{ returns true if board[x] - board[z] are all 1's }
begin
  All_1:= (board[x]=1) AND (board[y]=1) AND (board[z]=1);
end; { of Function All_2 }

Function Comp_Wins: boolean;
{ returns true if computer wins the game }
begin
  Comp_Wins:= ( All_2(1,2,3) OR All_2(1,4,7) OR All_2(1,5,9) OR
                All_2(3,5,7) OR All_2(3,6,9) OR All_2(7,8,9) OR
                All_2(2,5,8) OR All_2(4,5,6) ); 
end; { of Function Comp_Wins }

Function Human_Wins: boolean;
{ returns true if human wins the game }
begin
  Human_Wins:= ( All_1(1,2,3) OR All_1(1,4,7) OR All_1(1,5,9) OR
                All_1(3,5,7) OR All_1(3,6,9) OR All_1(7,8,9) OR
                All_1(2,5,8) OR All_1(4,5,6) ); 
end; { of Function Human_Wins }

Function Two_2(x,y,z: integer; var vacant: integer): boolean;
{ returns true if two of board[x]- board[y] are 2's and board[vacant] = 0 }
var temp: boolean;
begin
  temp:= FALSE;
  If ((board[x]=2) AND (board[y]=2) AND (board[z]=0))
    then begin
      vacant:=z;
      temp:= TRUE;
    end
  else if ((board[x]=2) AND (board[z]=2) AND (board[y]=0))
    then begin
      vacant:=y;
      temp:= TRUE;
    end
  else if ((board[y]=2) AND (board[z]=2) AND (board[x]=0))
    then begin
      vacant:= x;
      temp:= TRUE;
    end;
  Two_2:= temp;  
end; { of Function Two_2 }

Function Two_1(x,y,z: integer; var vacant: integer): boolean;
{ returns true if two of board[x]- board[y] are 1's and board[vacant] = 0 }
var temp: boolean;
begin
  temp:= FALSE;
  If ((board[x]=1) AND (board[y]=1) AND (board[z]=0))
    then begin
      vacant:=z;
      temp:= TRUE;
    end
  else if ((board[x]=1) AND (board[z]=1) AND (board[y]=0))
    then begin
      vacant:=y;
      temp:= TRUE;
    end
  else if ((board[y]=1) AND (board[z]=1) AND (board[x]=0))
    then begin
      vacant:= x;
      temp:= TRUE;
    end;
  Two_1:= temp;  
end; { of Function Two_1 }


Function Win_Space(var vacant: integer): boolean;
{ returns true if there's a space that can result in the computer
  winning the game.  Vacant returns the space.  }
var temp: boolean;
begin
  temp:= ( Two_2(1,2,3,vacant) OR Two_2(1,4,7,vacant) 
                OR Two_2(1,5,9,vacant) OR Two_2(3,5,7,vacant)
                OR Two_2(3,6,9,vacant) OR Two_2(7,8,9,vacant)
                OR Two_2(2,5,8,vacant) OR Two_2(4,5,6,vacant) );
  If temp then
    if Two_2(1,2,3,vacant) then
    else if Two_2(1,4,7,vacant) then
    else if Two_2(1,5,9,vacant) then
    else if Two_2(3,5,7,vacant) then
    else if Two_2(3,6,9,vacant) then
    else if Two_2(7,8,9,vacant) then
    else if Two_2(2,5,8,vacant) then
    else if Two_2(4,5,6,vacant) then;
  Win_Space:=temp;
end; { of Function Win_Space }

Function Block_Needed(var vacant: integer): boolean;
{ returns true if the computer needs to block a win by the human.
  vacant returns the space that must be moved into to block.  }
var temp: boolean;
begin
  temp:= ( Two_1(1,2,3,vacant) OR Two_1(1,4,7,vacant) OR
                   Two_1(1,5,9,vacant) OR Two_1(3,5,7,vacant) OR
                   Two_1(3,6,9,vacant) OR Two_1(7,8,9,vacant) OR
                   Two_1(2,5,8,vacant) OR Two_1(4,5,6,vacant) );
  If temp then
    if Two_1(1,2,3,vacant) then
    else if Two_1(1,4,7,vacant) then
    else if Two_1(1,5,9,vacant) then
    else if Two_1(3,5,7,vacant) then
    else if Two_1(3,6,9,vacant) then
    else if Two_1(7,8,9,vacant) then
    else if Two_1(2,5,8,vacant) then
    else if Two_1(4,5,6,vacant) then;
  Block_Needed:=temp;
end; { of Function Block_Needed } 

Function Tie_Game: boolean;
{ returns true if all spaces on board are occupied }
var i: integer;
    temp: boolean;
begin
  temp:= TRUE;
  for i:= 1 to 9 do
    if board[i]=0 then temp:= FALSE;
  Tie_Game:= temp;
end; { of Function Tie_Game }

Procedure Do_Comp_Wins;
{ does whatever should be done when the computer wins.
  '(click mouse to continue)' message before new game.  }
begin
  Draw_String(104,150,'Computer Wins');
  Correct_Sound;
  get_button;
end; { of Procedure Do_Comp_Wins }

Procedure Do_Tie_Game;
{ does what should be done when it's a tie game.
  '(click mouse to continue)' message before new game.  }
begin
  Draw_String(124,150,'Tie Game');
  get_button;
end; { Of Procedure Do_Tie_Game }

Procedure Do_Human_Wins;
{ human has won }
begin
  Draw_String(128,150,'You Win');
  Happy_Sound;
  get_button;
end; { of procedure Do_human_wins }

Function Three_Moves: boolean;
var i,j: integer;
begin
  j:=0;
  for i:=1 to 9 do
    if board[i]<>0 then j:=j+1;
  Three_moves:= (j = 3);
end; { of Function Three_Moves }

Function Diagonals(var vacant: integer): boolean;
{ returns true if either diagonal contains two player moves with a 
  computer move in the center.  vacant returns space to move. }
var temp: boolean;
begin
  temp:= FALSE;
  If three_moves then begin
  If ((board[3]=1) AND (board[7]=1) AND (board[5]=2)) 
    then begin
      temp:= TRUE;
      If board[6]=0 then vacant:= 6
        else if board[2]=0 then vacant:= 2;
      end
    else If ((board[1]=1) AND (board[9]=1) AND (board[5]=2))
      then begin
        temp:=TRUE;
        If board[2]=0 then vacant:=2
          else if board[6]=0 then vacant:=6;
      end;
  end;
  Diagonals:= temp;
end; { of Function Diagonals }

Function Special_Sit(var vacant: integer): boolean;
{ returns true if any of the special situations are true.  vacant 
  returns the space to move.  }
begin
  Special_Sit:=FALSE;
  If (board[5]=2) AND (Three_Moves) then
    if ((board[2]=1) AND (board[9]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=3
      end
    else if ((board[6]=1) AND (board[7]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=9
      end
    else if ((board[3]=1) AND (board[4]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=1
      end
    else if ((board[1]=1) AND (board[8]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=7;
      end
    else if ((board[4]=1) AND (board[9]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=1;
      end
    else if ((board[8]=1) AND (board[3]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=7;
      end
    else if ((board[8]=1) AND (board[6]=1)) then
      begin
        Special_Sit:=TRUE;
        vacant:=9;
      end;
end; { of Function Special_Sit }

Procedure choice_move;
{ computer can go in a corner or adjacent to a 1. }
var i: integer;
begin
  { free corner ? }
  If ((board[1]=0) and (board[9]=0)) then comp_move(1)
  else if ((board[3]=0) and (board[7]=0)) then comp_move(3)
  else if board[1]=0 then comp_move(1)
  else if board[3]=0 then comp_move(3)
  else if board[7]=0 then comp_move(7)
  else if board[9]=0 then comp_move(9)
  
  { adjacent space to a 1 ? }
  else begin
    i:=2;
    while(board[i-1]<>1)AND(i<9) do i:=i+1;
    If (board[i]=0) then comp_move(i)
      else begin
        i:=0;
        Repeat
          i:=i+1;
        Until (board[i]=0);
        comp_move(i);
      end;
  end;
end; { of Procedure choice_move } 

Procedure Noughts;
var
  vacant,x: integer;
  exit_noughts, comp_turn, harder: boolean;
begin
  exit_noughts:= FALSE; harder:= TRUE;
  Grow_Box(118,159, 76, 30, 0, 0, 320, 200);
  
  Repeat
    Hide_Mouse;
    ScrRest(Nought_Scr);
    
    Line_Color(black);           { outline harder or easier }
    If harder then begin
      Line(251,199,302,199);
      Line(251,189,302,189);
    end else begin
      Line(16,189,64,189);
      Line(16,199,64,199);
    end;
    Show_Mouse;

    For x:= 1 to 9 do            { clear board }
      board[x]:= 0;
    Get_Move(exit_noughts, harder);
    If NOT exit_noughts then begin
      If board[5]=0              { the center is vacant }
        then comp_move(5)        { take the center }
        else comp_move(3);       { take a corner }
      comp_turn:= FALSE;
      Repeat
        If comp_turn then        { computer makes move }
          begin
            comp_turn:= FALSE;
            If Win_Space(vacant)         { If computer can win, win }
              then comp_move(vacant)
            else If Block_needed(vacant) { If comp needs to block, block }
              then comp_move(vacant)
            else If Diagonals(vacant)    { make a good move }
              then comp_move(vacant)
            else if (Special_Sit(vacant) AND harder)
              then comp_move(vacant)
            else choice_move;   
          end
        else begin               { human makes move }
          comp_turn:= TRUE;
          Get_Move(exit_noughts, harder);
        end;
      Until Comp_Wins or Tie_Game or exit_noughts or human_wins;
      If Comp_Wins then Do_Comp_Wins
      else if Tie_Game then Do_Tie_Game
      else if human_wins then do_human_wins;
    end;
  Until exit_noughts;
  
  Hide_mouse;
  ScrRest(Cupboard_Scr);
  Shrink_Box(0,0,320,200,118,159,76,30);
  Show_mouse;
end; { of Procedure Noughts }

Function Main_Menu: Integer;
{ Gets input from main screen.  
  Returns: 1=Repeat, 2=Eight ball, 3=Noughts, 4=Exit_Game. }
Const
  Rpt_Top       = 88;    { These define the shelves of the cupboard }
  Rpt_Bottom    = 118;
  Eight_Top     = 124;
  Eight_Bottom  = 154;
  Nought_Top    = 159;
  Nought_Bottom = 189;
  Left          = 118;
  Right         = 194; 
  Exit_Top      = 184;
  Exit_Bottom   = 194;
  Exit_Left     = 241;
  Exit_Right    = 282;
  
Var
  done: boolean;
  x, y: integer;
begin
  done:= FALSE;
  Repeat
    Main_Event(100);
    If button then begin     { check to see if item selected }
      x:= Mouse_x;
      y:= Mouse_y;
      If ((x >= Left) AND (x <= Right)) then
        If ((y >= Rpt_Top) AND (y <= Rpt_Bottom)) then begin
          done:= TRUE;
          Main_Menu:= 1;
        end else
        If ((y >= Eight_Top) AND (y <= Eight_Bottom)) then begin
          done:= TRUE;
          Main_Menu:= 2;
        end else
        if ((y >= Nought_Top) AND (y <= Nought_Bottom)) then begin
          done:= TRUE;
          Main_menu:= 3;
        end;
      If ((x >= Exit_Left) AND (x <= Exit_Right) AND (y >= Exit_Top)
          AND (y <= Exit_Bottom))
        then begin
          done:=TRUE;
          Main_Menu:= 4;
        end;
    end;
  Until done;
end; { of Function Main_Menu }

Procedure Main_Loop;
{  This is the main loop which calls all of the other routines }
var
  picked: integer;
begin
  Repeat
    picked:= Main_Menu;
    case picked of
      1: Repeat_Game;
      2: Eight_Ball;
      3: Noughts;
      4: Get_Out;
    end; 
  Until Exit_Game;
end; { of procedure Main_Loop }


begin
If Init_Gem>=0 then begin
 Initialize;
 Main_Loop;
 Exit_Gem;
end;
end.

